(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    484796,      10051]
NotebookOptionsPosition[    452279,       9572]
NotebookOutlinePosition[    452827,       9591]
CellTagsIndexPosition[    452784,       9588]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"A", ".", "Odrzywolek"}], ",", " ", 
   RowBox[{"NSE", " ", "abundance", " ", "data"}], ",", " ", 
   RowBox[{
    RowBox[{
    "Atomic", " ", "Data", " ", "and", " ", "Nuclear", " ", "Data", " ", 
     "Tables", " ", "98", " ", 
     RowBox[{"(", "2012", ")"}], " ", "852"}], "-", "861"}]}], 
  "\[IndentingNewLine]", "*)"}]], "Input",
 CellChangeTimes->{{3.553491552495081*^9, 3.5534915528474894`*^9}, 
   3.553491601723505*^9, {3.553671991551638*^9, 3.553672004439375*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"19fa1b95-7fd4-43ef-bdfa-c0f2ac877b16"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Date", "[", "]"}]], "Input",
 CellChangeTimes->{{3.4895597412626166`*^9, 3.4895597426776977`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"85db82bf-e65c-4e35-904a-30434f00d25b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2024", ",", "11", ",", "12", ",", "9", ",", "28", ",", 
   "49.8876282`9.450567712343798"}], "}"}]], "Output",
 CellChangeTimes->{3.9403889298962593`*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"138af5cb-9277-254c-b2e2-a2b750eb236c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Version"], "Input",
 CellLabel->"In[3]:=",ExpressionUUID->"2efee145-9b28-4183-8f04-019577cea4f8"],

Cell[BoxData["\<\"14.1.0 for Microsoft Windows (64-bit) (July 16, \
2024)\"\>"], "Output",
 CellChangeTimes->{3.9403889299178905`*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"e67b9187-cade-1d49-a539-cd85f24d3396"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"800", " ", "isotopes", " ", "NSE", " ", "calculation"}], ",", " ", 
   RowBox[{"MAX", " ", "3181", " ", "from", " ", "Wolfram", " ", "database"}],
    ",", " ", 
   RowBox[{"64", "-", 
    RowBox[{"bit", " ", "OS", " ", "required", 
     RowBox[{"(", 
      RowBox[{"!", "?"}], ")"}], " ", "for", " ", "all", " ", 
     "nuclides"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4032765158393154`*^9, 3.403276539603486*^9}, {
  3.40717232709375*^9, 3.4071723271875*^9}, {3.4127392144928226`*^9, 
  3.412739217272471*^9}, {3.412739720695259*^9, 3.412739722472021*^9}, {
  3.412918419241041*^9, 3.412918470670774*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"625d2b90-416f-4186-bff5-dee56cfa16be"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"ParentDirectory", "@", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.9401646802018967`*^9, 3.940164710746086*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"dff45a32-b0d1-489b-9e1c-dea2d5c48b9a"],

Cell[BoxData["\<\"H:\\\\misiek\\\\programy\\\\biblioteki\\\\libNSE\"\>"], \
"Output",
 CellChangeTimes->{3.940388929941332*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"bbf8aa55-b285-0849-a847-fd7fa47061ca"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "SetDirectory", "[", "\"\<H://misiek//nse//datasetADNDTfigs/\>\"", "]"}], 
  " ", "*)"}]], "Input",
 CellChangeTimes->{{3.48964808916842*^9, 3.489648108366518*^9}, {
  3.489893972634468*^9, 3.489893974471573*^9}, {3.4899022900921993`*^9, 
  3.4899022905942287`*^9}, {3.553441696905846*^9, 3.553441698657838*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"3f7dbdb6-6e58-4d88-834e-88d32bea376d"],

Cell[BoxData[
 RowBox[{"(*", " ", "\[IndentingNewLine]", 
  RowBox[{"SetDirectory", "[", "\"\</mnt/E/temp/NSE_pn_table_tmp/\>\"", "]"}],
   "\[IndentingNewLine]", "*)"}]], "Input",
 CellChangeTimes->{{3.429933972043726*^9, 3.42993398359236*^9}, {
  3.439445685431582*^9, 3.439445687320854*^9}, {3.489210363541375*^9, 
  3.489210369516717*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"966afd46-a483-4947-9682-df6eb40f1746"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"myPrecision", "=", "96"}]], "Input",
 CellChangeTimes->{{3.4892869230136724`*^9, 3.489286939452613*^9}, {
  3.553522566901333*^9, 3.553522568492536*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"9f98e6bd-f85f-42e0-9e92-605f9f69e225"],

Cell[BoxData["96"], "Output",
 CellChangeTimes->{3.94038892996434*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"f85ef974-4cf3-dd45-a8e2-e1e515408232"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MinPrecision", "=", 
  RowBox[{"Max", "[", 
   RowBox[{"50", ",", "myPrecision"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.412739573346127*^9, 3.412739604825012*^9}, {
  3.4892034151269484`*^9, 3.4892034166830378`*^9}, {3.4892301603946905`*^9, 
  3.489230160930721*^9}, {3.4892869371124787`*^9, 3.4892869531193943`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"1d91a6e3-7cca-4e76-85f8-f58a9215a03f"],

Cell[BoxData["96"], "Output",
 CellChangeTimes->{3.9403889299693413`*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"d91fe4e0-52b7-f246-ae7e-65adedf23140"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"range", " ", "of", " ", 
   RowBox[{"temperatures", " ", "[", "MeV", "]"}], " ", "and", " ", 
   RowBox[{"densities", " ", "[", 
    RowBox[{"kg", "/", 
     RowBox[{"m", "^", "3"}]}], "]"}], " ", "with", " ", "grid", " ", 
   "size"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.42043920425*^9, 3.420439246203125*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"0d51edc7-8184-4a37-9847-19b91719988e"],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{"(*", 
   RowBox[{"T9tbl", "=", 
    RowBox[{"Rationalize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0.1", ",", "0.15", ",", "0.2", ",", "0.3", ",", "0.4", ",", "0.5", 
        ",", "0.6", ",", "0.7", ",", "0.8", ",", "0.9", ",", "1.0", ",", 
        "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", "3.5", ",", "4.0", 
        ",", "4.5", ",", "5.0", ",", "6.0", ",", "7.0", ",", "8.0", ",", 
        "9.0", ",", "10.0"}], "}"}], ",", "0.001"}], "]"}]}], " ", "*)"}], 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"T9", " ", "from", " ", "Hix"}], "&"}], "Thielemann", " ", 
    RowBox[{"nse", ".", "f"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{
  3.4898338025710373`*^9, {3.4899025160821257`*^9, 3.489902521904458*^9}, {
   3.512881350693162*^9, 3.512881355045411*^9}, {3.5534912833707237`*^9, 
   3.553491288376596*^9}, {3.5536720952205677`*^9, 3.5536722254420156`*^9}, {
   3.5536732346057367`*^9, 3.5536732402320585`*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"45c5685b-0d3d-4aa8-ad1d-c80aaa918826"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"kTtoT9", "=", 
   RowBox[{"116045", "/", "10000"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.553441743846282*^9, 3.5534417560839157`*^9}, {
  3.5536749820946875`*^9, 3.55367498458683*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"495f8663-9ca7-4449-8513-2d1fd459586b"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"(*", " ", 
   RowBox[{"kTtbl", "=", 
    RowBox[{"T9tbl", "/", "kTtoT9"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.489833806275408*^9, 3.4898338216529455`*^9}, {
  3.4898940263315396`*^9, 3.4898940283146524`*^9}, {3.5128813579825788`*^9, 
  3.512881358897631*^9}, {3.553441740725689*^9, 3.553441765787652*^9}, {
  3.553491304619529*^9, 3.5534913063165283`*^9}, {3.5536723477020087`*^9, 
  3.5536723497651267`*^9}, {3.5536749864829383`*^9, 3.553674989603117*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"be6fb0f6-1e7c-481b-af35-4e706f4766f6"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"(*", " ", 
   RowBox[{"tempMAX", "=", 
    RowBox[{"kTtbl", "[", 
     RowBox[{"[", 
      RowBox[{"-", "1"}], "]"}], "]"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.489833841874967*^9, 3.4898338504878283`*^9}, {
  3.489894030988806*^9, 3.489894032960919*^9}, {3.5128813608757443`*^9, 
  3.512881361882802*^9}, {3.553491308844469*^9, 3.553491310292747*^9}, {
  3.5536723512142096`*^9, 3.5536723520382566`*^9}, {3.553674991339216*^9, 
  3.553674994483396*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"9a4aabef-d19c-462b-a81a-bbf658ace73a"],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{"(*", " ", 
   RowBox[{"tempMIN", "=", 
    RowBox[{"kTtbl", "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.4898338520259824`*^9, 3.489833858533633*^9}, {
  3.4898940350760393`*^9, 3.489894036901144*^9}, {3.5128813635668983`*^9, 
  3.512881365076985*^9}, {3.553491311724619*^9, 3.5534913153654623`*^9}, {
  3.553672353102318*^9, 3.553672354069373*^9}, {3.5536749959554806`*^9, 
  3.5536749977955856`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"35bf6b4b-e9ea-46ad-b657-b20afc3b87a1"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"kTtbl", "[", 
       RowBox[{"[", "ii", "]"}], "]"}], "-", 
      RowBox[{"kTtbl", "[", 
       RowBox[{"[", 
        RowBox[{"ii", "-", "1"}], "]"}], "]"}]}], "//", "N"}], ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "2", ",", "tempNum"}], "}"}]}], "]"}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.553443268966683*^9, 3.5534432710614147`*^9}, {
  3.553443550908588*^9, 3.553443583063716*^9}, {3.553491319081273*^9, 
  3.553491320857931*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"f76e19ed-fa3c-4648-a374-da4ba0c29a9a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{"tempMAX", "=", 
   RowBox[{"1.0", " ", "//", "Rationalize", " "}]}]}]], "Input",
 CellChangeTimes->{{3.412677320484375*^9, 3.41267732315625*^9}, {
  3.412682516198226*^9, 3.412682516237638*^9}, {3.412687591506442*^9, 
  3.4126875923673*^9}, {3.4126877601468887`*^9, 3.4126877641064262`*^9}, {
  3.42043951775*^9, 3.4204395178125*^9}, {3.42045217675*^9, 
  3.420452176984375*^9}, {3.420452229359375*^9, 3.420452229421875*^9}, {
  3.420685194375*^9, 3.42068519453125*^9}, {3.420686884640625*^9, 
  3.42068688471875*^9}, {3.48930451233638*^9, 3.489304512545392*^9}, {
  3.4896481148178873`*^9, 3.489648115253912*^9}, {3.489833862563036*^9, 
  3.4898338646682463`*^9}, {3.489894039420288*^9, 3.4898940446935897`*^9}, {
  3.553441778403223*^9, 3.553441780187458*^9}, {3.553443804149062*^9, 
  3.553443805396484*^9}, {3.5535216376793795`*^9, 3.5535216377417793`*^9}, {
  3.5535225908941755`*^9, 3.5535225909721756`*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"958e0879-2902-40db-9625-585685f2ba52"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.9403889300083485`*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"8522951f-e530-f044-9748-ddc1f4dce1a3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{"tempMIN", "=", 
   RowBox[{"0.3", " ", "//", "Rationalize", " "}]}]}]], "Input",
 CellLabel->"In[18]:=",ExpressionUUID->"3c501a2d-a347-4723-a237-d7b8840728dd"],

Cell[BoxData[
 FractionBox["3", "10"]], "Output",
 CellChangeTimes->{3.9403889300320473`*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"df5b4939-3ac4-6a45-8133-32820f04b016"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[CapitalDelta]temp", "=", 
  RowBox[{"0.05", " ", "//", "Rationalize"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "NOTE", " ", "that", " ", "temperature", " ", "step", " ", "must", " ", 
     "be", " ", "small", " ", "enough", " ", "to", " ", "provide", " ", 
     "accurate", " ", "guess", " ", "for", " ", "the", " ", "next", " ", 
     RowBox[{"step", ".", " ", "Procedure"}], " ", "starts", " ", "with", " ",
      "analytical", " ", "approximation", " ", "for", " ", "p"}], ",", " ", 
    "n", ",", " ", 
    RowBox[{
    "He4", " ", "mixture", " ", "for", " ", "highest", " ", "temperature"}], 
    ",", " ", 
    RowBox[{
     RowBox[{"and", " ", "slowly", " ", "decrease", " ", 
      RowBox[{"kT", ".", " ", "This"}], " ", "procedure", " ", "fails", " ", 
      "for", " ", "kT"}], "<", 
     RowBox[{"0.3", " ", "if", " ", "step", " ", "is", " ", "too", " ", 
      RowBox[{"large", ".", "\[IndentingNewLine]", "In"}], " ", "fact"}]}], 
    ",", " ", 
    RowBox[{
    "it", " ", "is", " ", "combination", " ", "of", " ", "temperature", " ", 
     "and", " ", "density"}], ",", " ", 
    RowBox[{
    "and", " ", "for", " ", "highest", " ", "densities", " ", "failure", " ", 
     "is", " ", "more", " ", "likely"}]}], " ", "*)"}]}]}], "Input",
 CellLabel->"In[19]:=",ExpressionUUID->"33557eba-f662-4c19-82e7-a4ab4e56f966"],

Cell[BoxData[
 FractionBox["1", "20"]], "Output",
 CellChangeTimes->{3.940388930053587*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"0a853754-3b76-4e45-b982-8d23a8a56c63"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"tempNum", "=", 
   RowBox[{
    RowBox[{"Dimensions", "[", "T9tbl", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4898338850222816`*^9, 3.489833896667446*^9}, {
  3.489894058648388*^9, 3.489894060724507*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"a79e13bb-561f-48a7-b756-b1f022b955ab"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"tempNum", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{",", 
       RowBox[{"{", 
        RowBox[{
        "temp", ",", "tempMIN", ",", "tempMAX", ",", "\[CapitalDelta]temp"}], 
        "}"}]}], "]"}], " ", "//", "Dimensions"}], " ", "//", "First"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.4206850806875*^9, 3.42068521475*^9}, {
  3.489833880363816*^9, 3.489833882370016*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"9a289158-98c7-4e86-bf15-25be67babac5"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"kTtbl", "=", 
    RowBox[{"Table", "[", 
     RowBox[{"kT", ",", 
      RowBox[{"{", 
       RowBox[{
       "kT", ",", "tempMIN", ",", "tempMAX", ",", "\[CapitalDelta]temp"}], 
       "}"}]}], "]"}]}], " ", ";"}], " "}]], "Input",
 CellChangeTimes->{
  3.4892923265393925`*^9, 3.489648128088646*^9, {3.5534418058031588`*^9, 
   3.553441807860197*^9}, {3.553443827927058*^9, 3.553443828918043*^9}, {
   3.553516808450954*^9, 3.5535168093840075`*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"6822d631-37db-4a19-b870-68f6f55bd6ef"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tempNum", "=", 
  RowBox[{
   RowBox[{"Dimensions", "[", "kTtbl", "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.48990052653633*^9, 3.4899005319316387`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"9fa38111-4217-4bf3-99d7-fcabdde0fe9d"],

Cell[BoxData["15"], "Output",
 CellChangeTimes->{3.9403889300791836`*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"e8ccd1f2-27db-9641-990a-9798b169f82b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/kT.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"kTtbl", "//", "N"}], "]"}], "<>", "\"\<\\n\\n\>\""}], ",", 
   "\"\<Text\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.489292331449673*^9, 3.489292353180916*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"7dbc7269-9c82-4be1-9da1-22474519e46f"],

Cell[BoxData["\<\"data/kT.dat\"\>"], "Output",
 CellChangeTimes->{3.940388930103056*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"c372326b-6870-c142-93a5-a2aa7fd55d35"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Directory", "[", "]"}]], "Input",
 CellChangeTimes->{{3.940164478717201*^9, 3.9401644810342693`*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"d2bb59fb-bffb-5f48-b136-01672058b5e5"],

Cell[BoxData["\<\"H:\\\\misiek\\\\programy\\\\biblioteki\\\\libNSE\"\>"], \
"Output",
 CellChangeTimes->{3.9403889301080704`*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"7d9cd8fa-7329-0a44-b70f-68b9343a1dee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lgdensMAX", "=", "10"}]], "Input",
 CellChangeTimes->{{3.412677333390625*^9, 3.41267735196875*^9}, {
  3.4126774391875*^9, 3.412677445125*^9}, {3.412678044796875*^9, 
  3.412678044984375*^9}, {3.412678278109375*^9, 3.412678278203125*^9}, {
  3.4126876048995743`*^9, 3.412687606231152*^9}, {3.412687777561489*^9, 
  3.4126877786578627`*^9}, {3.4893887658176894`*^9, 3.489388766015701*^9}, {
  3.489648132577903*^9, 3.4896481347900295`*^9}, {3.4898339463274117`*^9, 
  3.4898339487166505`*^9}, {3.489894108547242*^9, 3.4898941094882956`*^9}, {
  3.553662484291854*^9, 3.553662485530925*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"3b742155-193e-4098-b996-a414f73e69af"],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{3.9403889301307297`*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"89506158-ed6b-fe4b-ba24-dac6a9075d1f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lgdensMIN", "=", "6"}]], "Input",
 CellChangeTimes->{{3.412677356921875*^9, 3.4126773735*^9}, {3.4126774415*^9, 
   3.412677447671875*^9}, {3.412678046609375*^9, 3.412678047453125*^9}, {
   3.412678279890625*^9, 3.412678281203125*^9}, {3.4126876203344307`*^9, 
   3.4126876211241627`*^9}, {3.412687783201467*^9, 3.4126877836984262`*^9}, 
   3.42046334215625*^9, 3.42047063584375*^9, {3.489388768306832*^9, 
   3.4893887684028373`*^9}, 3.489463048859956*^9, {3.4896481368571477`*^9, 
   3.4896481377842007`*^9}, {3.4898339524900274`*^9, 3.489833952983077*^9}, {
   3.4898941110413847`*^9, 3.489894111927435*^9}, {3.5536624738112545`*^9, 
   3.5536624763073974`*^9}, {3.5536701652131777`*^9, 
   3.5536701662612376`*^9}, {3.553675018962796*^9, 3.553675020042858*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"b783a075-f7cc-49ab-b6bb-bb22e01488d5"],

Cell[BoxData["6"], "Output",
 CellChangeTimes->{3.9403889301347313`*^9},
 CellLabel->"Out[27]=",ExpressionUUID->"59083ee8-1634-fb49-bd62-41ddc1f275b5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[CapitalDelta]lgdens", "=", 
  RowBox[{"0.5", " ", "//", "Rationalize"}]}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAGIQzcBwME0r96UjA0NFJojmPvo8QR9IBy/8B6Y5XhiU
gmiuq//A9I4dRssjgHTrIRMwzdCgfDu4GqRfB0obyW8E05EQusFu9T8wnQKh
GbramGtA/K0QmmHbFBkwX2AqhPZ+NBNM50FpkcJDtSB1hlD6l49TL4iW8wXR
z8QWXJ8FpHU+rQPTDAyrDqwB02vBdJJy+FyF/y8dI2akgekbAUxJ84H0Dzdp
MG2ws//gTyB9Z8VkMO3bv6QmhOGV462TzPUgemLCLqP9la8c+17uAdOTn7Eu
Og2kN79iB9M3udMOngXSjcULwXRAIvchoapXjq6+mmB64oZ3DyWA9KM9H8D0
l6o5glJAmsthL5gGALrUupA=
  "],
 CellLabel->"In[28]:=",ExpressionUUID->"b2e5d326-1e42-4bf5-9274-3b4ce3435d06"],

Cell[BoxData[
 FractionBox["1", "2"]], "Output",
 CellChangeTimes->{3.940388930138731*^9},
 CellLabel->"Out[28]=",ExpressionUUID->"7834adfc-3676-784d-98f7-15e7189f4cb7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lgdenstbl", "=", 
  RowBox[{"Table", "[", 
   RowBox[{"lgdens", ",", 
    RowBox[{"{", 
     RowBox[{
     "lgdens", ",", "lgdensMIN", ",", " ", "lgdensMAX", ",", " ", 
      "\[CapitalDelta]lgdens"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[29]:=",ExpressionUUID->"a9bb0946-12b7-4a14-9e07-0620236e1c5d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", ",", 
   FractionBox["13", "2"], ",", "7", ",", 
   FractionBox["15", "2"], ",", "8", ",", 
   FractionBox["17", "2"], ",", "9", ",", 
   FractionBox["19", "2"], ",", "10"}], "}"}]], "Output",
 CellChangeTimes->{3.9403889301608295`*^9},
 CellLabel->"Out[29]=",ExpressionUUID->"6dfaefe4-4e2a-ae4f-b888-abc658f91b0e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lgdensNum", "=", 
  RowBox[{
   RowBox[{"lgdenstbl", "//", "Dimensions"}], "//", "First"}]}]], "Input",
 CellChangeTimes->{{3.420685486125*^9, 3.420685540609375*^9}, {
  3.553491363681487*^9, 3.553491367977417*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"58042146-a9dc-436d-a5b9-82b887b37f33"],

Cell[BoxData["9"], "Output",
 CellChangeTimes->{3.940388930164831*^9},
 CellLabel->"Out[30]=",ExpressionUUID->"c7f839b0-8c14-f640-9849-a3133495b569"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/lg_rho.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"lgdenstbl", "//", "N"}], "]"}], "<>", "\"\<\\n\\n\>\""}], ",", 
   "\"\<Text\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.553441903950672*^9, 3.553441924758156*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"f17bb2f9-66a3-4369-8f34-4d2e91bb93f9"],

Cell[BoxData["\<\"data/lg_rho.dat\"\>"], "Output",
 CellChangeTimes->{3.9403889301884766`*^9},
 CellLabel->"Out[31]=",ExpressionUUID->"1a80fea9-540b-7647-afc2-3c8ee505714d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"NOTE", ":", " ", 
    RowBox[{
    "it", " ", "is", " ", "better", " ", "to", " ", "use", " ", "rational", 
     " ", "steps", " ", "for", " ", "Ye"}]}], ",", " ", 
   RowBox[{
   "because", " ", "numerical", "\[IndentingNewLine]", "values", " ", "might",
     " ", "look", " ", "identical"}], ",", " ", 
   RowBox[{"while", " ", "they", " ", "are", " ", "not"}], ",", " ", 
   RowBox[{
    RowBox[{"e", ".", "g", "."}], ":", " ", "0.35`"}], ",", " ", 
   RowBox[{
   "0.35000000`", "\[IndentingNewLine]", "In", " ", "worst", " ", "case", " ",
     "you", " ", "will", " ", "get", " ", "repeated", " ", "or", " ", 
    "extremely", " ", "close", " ", 
    RowBox[{"entries", " ", "!"}]}]}], "\[IndentingNewLine]", "*)"}]], "Input",
 CellChangeTimes->{{3.4893876865599594`*^9, 3.489387791248947*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"f1905761-961d-4ff6-b172-7533b88ff9c7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YeFINE", "=", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{"Ye", ",", 
     RowBox[{"{", 
      RowBox[{"Ye", ",", "0.35", ",", "0.55", ",", "0.025"}], "}"}]}], "]"}], 
   "//", "Rationalize", " ", 
   RowBox[{"(*", " ", 
    RowBox[{
    "more", " ", "dense", " ", "tabulation", " ", "in", " ", "rapid", " ", 
     "variation", " ", "region"}], " ", "*)"}]}]}]], "Input",
 CellLabel->"In[33]:=",ExpressionUUID->"f3cf726c-59ba-4483-b71b-1c1399ee3141"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["7", "20"], ",", 
   FractionBox["3", "8"], ",", 
   FractionBox["2", "5"], ",", 
   FractionBox["17", "40"], ",", 
   FractionBox["9", "20"], ",", 
   FractionBox["19", "40"], ",", 
   FractionBox["1", "2"], ",", 
   FractionBox["21", "40"], ",", 
   FractionBox["11", "20"]}], "}"}]], "Output",
 CellChangeTimes->{3.9403889302121468`*^9},
 CellLabel->"Out[33]=",ExpressionUUID->"1fe1a402-f2b5-5d4b-bffc-406bd14951ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ye1", "=", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{"Ye", ",", 
     RowBox[{"{", 
      RowBox[{"Ye", ",", "0.05", ",", "0.35", ",", "0.05"}], "}"}]}], "]"}], "//",
    "Rationalize", " ", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"TODO", ":", " ", 
      RowBox[{"Ye", " ", "very", " ", "small", " ", "0.01"}]}], ",", " ", 
     RowBox[{
      RowBox[{"0.001", " ", 
       RowBox[{"etc", "."}], "*"}], ";", " ", 
      RowBox[{
       RowBox[{
       "maybe", " ", "scalling", " ", "density", " ", "from", " ", "Ye"}], 
       "=", 
       RowBox[{
        RowBox[{
         RowBox[{"0.1", " ", "?", " ", "Results"}], " ", "does", " ", "not", 
         " ", "seem", " ", "to", " ", "change"}], "..."}]}]}]}], 
    "\[IndentingNewLine]", "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.4296849785074377`*^9, 3.4296850227970963`*^9}, 
   3.429721624328125*^9, {3.429743593328125*^9, 3.429743614296875*^9}, {
   3.42976876821875*^9, 3.42976876884375*^9}, {3.429857483625*^9, 
   3.429857491640625*^9}, {3.489203466071862*^9, 3.4892034785555763`*^9}, {
   3.489387666966839*^9, 3.48938766891195*^9}, {3.489388841825037*^9, 
   3.489388906198719*^9}, {3.4894631120675716`*^9, 3.4894631456194906`*^9}, {
   3.4896481623636065`*^9, 3.4896481628166323`*^9}, 3.4896500797232733`*^9, 
   3.489902620587103*^9, 3.553443853007415*^9},
 CellLabel->"In[34]:=",ExpressionUUID->"12559e9e-40d1-4ee2-a219-ad5696483428"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", "20"], ",", 
   FractionBox["1", "10"], ",", 
   FractionBox["3", "20"], ",", 
   FractionBox["1", "5"], ",", 
   FractionBox["1", "4"], ",", 
   FractionBox["3", "10"], ",", 
   FractionBox["7", "20"]}], "}"}]], "Output",
 CellChangeTimes->{3.9403889302171555`*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"45de8a17-c41c-b64d-888e-fda24414d41c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ye2", "=", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{"Ye", ",", 
     RowBox[{"{", 
      RowBox[{"Ye", ",", "0.55", ",", "0.95", ",", "0.05"}], "}"}]}], "]"}], "//",
    "Rationalize"}]}]], "Input",
 CellChangeTimes->{{3.4296850301983023`*^9, 3.429685036961532*^9}, 
   3.4297216279375*^9, {3.430139803328125*^9, 3.430139804859375*^9}, {
   3.430241793140625*^9, 3.4302417954375*^9}, {3.43028236171875*^9, 
   3.4302823631875*^9}, {3.4892034694740567`*^9, 3.4892034743233347`*^9}, {
   3.489387671374091*^9, 3.489387676847404*^9}, {3.4894631505307713`*^9, 
   3.4894631515308285`*^9}, 3.4899026251943665`*^9, 3.553443858933056*^9},
 CellLabel->"In[35]:=",ExpressionUUID->"64a00a82-8522-462b-99ec-e7fe0332c5b2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["11", "20"], ",", 
   FractionBox["3", "5"], ",", 
   FractionBox["13", "20"], ",", 
   FractionBox["7", "10"], ",", 
   FractionBox["3", "4"], ",", 
   FractionBox["4", "5"], ",", 
   FractionBox["17", "20"], ",", 
   FractionBox["9", "10"], ",", 
   FractionBox["19", "20"]}], "}"}]], "Output",
 CellChangeTimes->{3.9403889302397575`*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"1a1cd90b-6e51-e742-bbfd-63bf4d067c35"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"YeMAX", " ", "=", " ", 
   RowBox[{
    RowBox[{"Count", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{"\"\<E:/temp/np_800_\>\"", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"NumberForm", "[", 
            RowBox[{
             RowBox[{"N", "[", "Ye", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "]"}], "<>", 
          "\"\<.dat\>\""}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Ye", ",", "\[CapitalDelta]Ye", ",", "0.5", ",", 
          "\[CapitalDelta]Ye"}], "}"}]}], "]"}], ",", "$Failed"}], "]"}], "/",
     "1000"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.422451815953125*^9, 3.42245189021875*^9}, {
   3.422452199703125*^9, 3.422452235859375*^9}, {3.422452267046875*^9, 
   3.422452278875*^9}, {3.422452434671875*^9, 3.42245244803125*^9}, 
   3.42336405190625*^9, {3.427613005154201*^9, 3.4276130082411537`*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"2916ffd7-df2c-45ea-9a0c-103334a7d6f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Yetbl", "=", 
  RowBox[{
   RowBox[{"Union", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"1", "/", "1000"}], ",", 
       RowBox[{"1", "/", "100"}]}], "}"}], ",", "Ye1", ",", " ", "YeFINE", 
     ",", "Ye2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"99", "/", "100"}], ",", 
       RowBox[{"999", "/", "1000"}], ",", "1"}], "}"}]}], "]"}], "//", "Sort",
    " ", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Sort", " ", "is", " ", "not", " ", "required"}], ",", " ", 
     RowBox[{"Union", " ", "should", " ", "do", " ", "this"}]}], " ", 
    "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.420698889899971*^9, 3.420698909858738*^9}, {
  3.429685047516992*^9, 3.429685111349432*^9}, {3.4296851837738237`*^9, 
  3.4296851859952917`*^9}, {3.429857498625*^9, 3.429857499265625*^9}, {
  3.4301398089375*^9, 3.43013981125*^9}, {3.430282369765625*^9, 
  3.430282373421875*^9}, {3.4893876096225586`*^9, 3.4893876108196273`*^9}, {
  3.4893876411753635`*^9, 3.4893876430934734`*^9}, {3.4893878154653325`*^9, 
  3.4893878335963697`*^9}, {3.489650111962117*^9, 3.4896501176274414`*^9}, {
  3.48990264012222*^9, 3.489902645319517*^9}, {3.5535164596830053`*^9, 
  3.553516463497224*^9}, {3.553677480276575*^9, 3.5536774908901825`*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"2687c39e-0fc6-41ef-a6e2-cdb956b7bb49"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   FractionBox["1", "1000"], ",", 
   FractionBox["1", "100"], ",", 
   FractionBox["1", "20"], ",", 
   FractionBox["1", "10"], ",", 
   FractionBox["3", "20"], ",", 
   FractionBox["1", "5"], ",", 
   FractionBox["1", "4"], ",", 
   FractionBox["3", "10"], ",", 
   FractionBox["7", "20"], ",", 
   FractionBox["3", "8"], ",", 
   FractionBox["2", "5"], ",", 
   FractionBox["17", "40"], ",", 
   FractionBox["9", "20"], ",", 
   FractionBox["19", "40"], ",", 
   FractionBox["1", "2"], ",", 
   FractionBox["21", "40"], ",", 
   FractionBox["11", "20"], ",", 
   FractionBox["3", "5"], ",", 
   FractionBox["13", "20"], ",", 
   FractionBox["7", "10"], ",", 
   FractionBox["3", "4"], ",", 
   FractionBox["4", "5"], ",", 
   FractionBox["17", "20"], ",", 
   FractionBox["9", "10"], ",", 
   FractionBox["19", "20"], ",", 
   FractionBox["99", "100"], ",", 
   FractionBox["999", "1000"], ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.940388930247324*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"f78b9869-35d9-5b47-8cc0-c11ae72261dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YeNum", "=", 
  RowBox[{
   RowBox[{"Yetbl", "//", "Dimensions"}], "//", "First"}]}]], "Input",
 CellChangeTimes->{{3.42068561734375*^9, 3.420685656984375*^9}, {
  3.420698917533041*^9, 3.420698919813614*^9}, {3.489463076326527*^9, 
  3.4894630777846107`*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"74a7e304-4a15-4041-a965-67aad3d70727"],

Cell[BoxData["29"], "Output",
 CellChangeTimes->{3.9403889302719097`*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"e21810ff-0fc3-d543-a9aa-9fa807f22574"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToString", "[", 
  RowBox[{"Yetbl", "//", "N"}], "]"}]], "Input",
 CellChangeTimes->{3.4893875912315073`*^9, 3.489387854692576*^9, 
  3.4896481911132507`*^9, 3.553677501745803*^9},
 CellLabel->"In[39]:=",ExpressionUUID->"af775fd8-e782-477c-9c21-4cc8a47aa251"],

Cell[BoxData["\<\"{0., 0.001, 0.01, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35, \
0.375, 0.4, 0.425, 0.45, 0.475, 0.5, 0.525, 0.55, 0.6, 0.65, 0.7, 0.75, 0.8, \
0.85, 0.9, 0.95, 0.99, 0.999, 1.}\"\>"], "Output",
 CellChangeTimes->{3.9403889302759094`*^9},
 CellLabel->"Out[39]=",ExpressionUUID->"01697e5b-ec53-9442-9f87-6b652fa13a2f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/Ye.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"Yetbl", "//", "N"}], "]"}], "<>", "\"\<\\n\\n\>\""}], ",", 
   "\"\<Text\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.429685464479493*^9, 3.42968552148771*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"d37c07c8-8bde-47ef-8bf1-2243cdf550f8"],

Cell[BoxData["\<\"data/Ye.dat\"\>"], "Output",
 CellChangeTimes->{3.9403889302987785`*^9},
 CellLabel->"Out[40]=",ExpressionUUID->"87c251fa-54bc-6c47-95d7-38db42b18381"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"iso800", "=", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{"Delete", "[", 
        RowBox[{
         RowBox[{"IsotopeData", "[", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "9", "}"}], ",", 
           RowBox[{"{", "18", "}"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "800"}], "}"}]}], "]"}]}], " ", ";"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "Mechanical", " ", "use", " ", "of", " ", "large", " ", "databases", " ", 
     "requires", " ", 
     RowBox[{"caution", ".", " ", "Deleted"}], " ", "positions", " ", "are", 
     " ", "Helium2", " ", "and", " ", "Lithium3"}], ",", " ", 
    RowBox[{
    "included", " ", "in", " ", "the", " ", "databases", " ", "for", " ", 
     "historical", " ", 
     RowBox[{"reasons", ".", " ", "Lithium3"}], " ", "drastically", " ", 
     "changes", " ", "results", " ", "for", " ", "large", " ", "Ye"}], ",", 
    " ", 
    RowBox[{"because", " ", "it", " ", "replaces", " ", 
     RowBox[{"protons", "!"}], " ", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "For", " ", "beginners"}], ",", " ", 
    RowBox[{
     RowBox[{"I", " ", "recommend", " ", "use", " ", "hand"}], "-", 
     RowBox[{
     "crafted", " ", "selections", " ", "below", " ", "from", " ", "well"}], 
     "-", 
     RowBox[{"established", " ", "published", " ", "sources"}]}]}], " ", 
   "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.403269591752968*^9, 3.4032696527606926`*^9}, {
   3.4032712621148305`*^9, 3.403271286369707*^9}, {3.403842529640625*^9, 
   3.403842529921875*^9}, {3.403870543140625*^9, 3.403870544421875*^9}, {
   3.407163704328125*^9, 3.407163704796875*^9}, {3.40716886484375*^9, 
   3.40716886540625*^9}, 3.407172174109375*^9, {3.407172249359375*^9, 
   3.407172271203125*^9}, {3.407172305234375*^9, 3.407172312359375*^9}, 
   3.4071724044375*^9, {3.41240031834375*^9, 3.41240031890625*^9}, 
   3.412434729234375*^9, {3.412436513234375*^9, 3.412436513921875*^9}, {
   3.412522769265625*^9, 3.41252277353125*^9}, {3.41252291571875*^9, 
   3.41252291709375*^9}, {3.4125334306875*^9, 3.41253343190625*^9}, {
   3.41253376509375*^9, 3.412533765140625*^9}, {3.412533803515625*^9, 
   3.412533803625*^9}, {3.412533841140625*^9, 3.4125338430625*^9}, {
   3.412668035625*^9, 3.41266803571875*^9}, {3.412668124921875*^9, 
   3.41266812578125*^9}, {3.412676811453125*^9, 3.412676823875*^9}, {
   3.412739106798875*^9, 3.412739109858615*^9}, {3.4127391435055523`*^9, 
   3.412739185370407*^9}, {3.4127396644504423`*^9, 3.412739677174745*^9}, {
   3.4127397109704733`*^9, 3.412739727729602*^9}, 3.412917965223287*^9, {
   3.412918010694021*^9, 3.4129180118428783`*^9}, {3.4129180507265587`*^9, 
   3.4129180509742804`*^9}, {3.412918083535722*^9, 3.412918147382197*^9}, {
   3.412918186539332*^9, 3.412918192324059*^9}, {3.4131175929857597`*^9, 
   3.413117595289193*^9}, {3.420430225359375*^9, 3.420430225921875*^9}, 
   3.42043040365625*^9, 3.4204325018125*^9, {3.4206949632363977`*^9, 
   3.42069496564364*^9}, {3.420695877170203*^9, 3.420695878791893*^9}, {
   3.489229767742232*^9, 3.4892297989730177`*^9}, {3.5536700154226103`*^9, 
   3.5536700191748247`*^9}, {3.5536700557269154`*^9, 3.553670062927327*^9}, {
   3.553670101566537*^9, 3.5536701033346386`*^9}, {3.553670777048173*^9, 
   3.553670963470835*^9}, {3.553675043960226*^9, 3.553675046616378*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"ba9f117c-4650-4d8d-93bd-3d2da80073e7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"isoP", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Neutron\>\"", ",", "\"\<H1\>\"", ",", "\"\<He4\>\"", ",", 
     "\"\<C12\>\"", ",", "\"\<O16\>\"", ",", "\"\<Ti44\>\"", ",", 
     "\"\<Fe54\>\"", ",", "\"\<Fe56\>\"", ",", "\"\<Ni56\>\"", ",", 
     "\"\<Ni62\>\"", ",", "\"\<Co57\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Minimal", " ", "astrophysically"}], "-", 
    RowBox[{"motivated", " ", "selection", " ", "of", " ", "nuclides"}]}], 
   " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4032376130599055`*^9, 3.4032376446453233`*^9}, {
   3.4032376751892433`*^9, 3.4032377554045873`*^9}, {3.40325855818748*^9, 
   3.40325855994*^9}, {3.403263912807045*^9, 3.403263932134837*^9}, {
   3.403264756400072*^9, 3.4032647595546083`*^9}, {3.4032691911369104`*^9, 
   3.403269197425954*^9}, 3.4032711248975215`*^9, 3.489204278478329*^9, {
   3.5536710286465635`*^9, 3.5536710522539134`*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"544755f9-9350-4891-8737-d37b53410fbe"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iso32", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Neutron\>\"", ",", "\"\<Hydrogen1\>\"", ",", "\"\<He4\>\"", ",", 
     "\"\<C12\>\"", ",", "\"\<O16\>\"", ",", "\"\<Ne20\>\"", ",", 
     "\"\<Mg24\>\"", ",", "\"\<Si28\>\"", ",", "\"\<S32\>\"", ",", 
     "\"\<Ar36\>\"", ",", "\"\<Ca40\>\"", ",", "\"\<Ti44\>\"", ",", 
     "\"\<Ti50\>\"", ",", "\"\<Cr48\>\"", ",", "\"\<Cr54\>\"", ",", 
     "\"\<Cr55\>\"", ",", "\"\<Mn54\>\"", ",", "\"\<Mn55\>\"", ",", 
     "\"\<Mn56\>\"", ",", "\"\<Fe52\>\"", ",", "\"\<Fe54\>\"", ",", 
     "\"\<Fe55\>\"", ",", "\"\<Fe56\>\"", ",", "\"\<Fe57\>\"", ",", 
     "\"\<Fe58\>\"", ",", "\"\<Co55\>\"", ",", "\"\<Co56\>\"", ",", 
     "\"\<Ni56\>\"", ",", "\"\<Ni57\>\"", ",", "\"\<Ni58\>\"", ",", 
     "\"\<Ni60\>\"", ",", "\"\<Zn60\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"MPA", "-", 
    RowBox[{"Garching", " ", "HOTB", " ", "iso32", " ", "network"}]}], " ", 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4892961976518073`*^9, 3.489296349820511*^9}, {
  3.489296579525649*^9, 3.48929664248325*^9}, {3.4898941401810513`*^9, 
  3.4898941799393253`*^9}, {3.5536709758545437`*^9, 3.5536709782546806`*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"4f289380-687b-412d-9249-d853ee800a46"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"isoFXT", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Neutron\>\"", ",", "\"\<Hydrogen1\>\"", ",", "\"\<He4\>\"", ",", 
     "\"\<C12\>\"", ",", "\"\<C13\>\"", ",", "\"\<N13\>\"", ",", 
     "\"\<N14\>\"", ",", "\"\<O14\>\"", ",", "\"\<O15\>\"", ",", 
     "\"\<O16\>\"", ",", "\"\<O17\>\"", ",", "\"\<O18\>\"", ",", 
     "\"\<F17\>\"", ",", "\"\<F18\>\"", ",", "\"\<F19\>\"", ",", 
     "\"\<Ne18\>\"", ",", "\"\<Ne19\>\"", ",", "\"\<Ne20\>\"", ",", 
     "\"\<Mg22\>\"", ",", "\"\<Mg24\>\"", ",", "\"\<Al27\>\"", ",", 
     "\"\<Si28\>\"", ",", "\"\<P31\>\"", ",", "\"\<S30\>\"", ",", 
     "\"\<S32\>\"", ",", "\"\<Cl35\>\"", ",", "\"\<Ar36\>\"", ",", 
     "\"\<K39\>\"", ",", "\"\<Ca40\>\"", ",", "\"\<Ti44\>\"", ",", 
     "\"\<Cr48\>\"", ",", "\"\<Cr49\>\"", ",", "\"\<Cr50\>\"", ",", 
     "\"\<Cr51\>\"", ",", "\"\<Cr52\>\"", ",", "\"\<Cr53\>\"", ",", 
     "\"\<Cr54\>\"", ",", "\"\<Fe52\>\"", ",", "\"\<Fe54\>\"", ",", 
     "\"\<Fe55\>\"", ",", "\"\<Fe56\>\"", ",", "\"\<Fe57\>\"", ",", 
     "\"\<Fe58\>\"", ",", "\"\<Co55\>\"", ",", "\"\<Ni56\>\"", ",", 
     "\"\<Ni58\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"F", ".", "X", ".", "Timmes"}], " ", "NSE", " ", "calculations", 
    " ", "from", " ", 
    RowBox[{"cococubbed", ".", "com"}]}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.413275363716773*^9, 3.4132754320369596`*^9}, {
   3.413275549222986*^9, 3.413275586331378*^9}, {3.413275706042344*^9, 
   3.4132757232858047`*^9}, {3.4199147405*^9, 3.41991474346875*^9}, {
   3.419914789171875*^9, 3.419914919640625*^9}, {3.419915021640625*^9, 
   3.419915054828125*^9}, {3.41991509421875*^9, 3.41991525209375*^9}, 
   3.4892040514763455`*^9, {3.553668472086336*^9, 3.5536684842620325`*^9}, {
   3.5536709827039356`*^9, 3.5536710123096285`*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"3484365f-e60a-469b-bfd3-8078ac3cb9b0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"isoSimplest", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Neutron\>\"", ",", "\"\<Hydrogen1\>\"", ",", "\"\<Helium4\>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Simplest", " ", "possible", " ", 
     RowBox[{"case", ".", " ", "Useful"}], " ", "for", " ", "debugging"}], 
    ",", " ", 
    RowBox[{"analytical", " ", "estimates"}], ",", " ", 
    RowBox[{"and", " ", "for", " ", "high", " ", "temperatures"}]}], " ", 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.489229825818554*^9, 3.4892298332469783`*^9}, {
  3.5536710564541535`*^9, 3.5536710925332174`*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"f229cc15-e2ca-4f0e-a0ce-fd3278d4dd89"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"NOTE", ":", " ", 
   RowBox[{
   "isotope", " ", "set", " ", "must", " ", "include", " ", "Neutron", " ", 
    "and", " ", "Hydrogen1"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.553675076474086*^9, 3.55367509647423*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"ef40f7ac-a719-4b1f-84e4-ef1a6968dbd0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParticleData", "[", "\"\<Neutron\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.940212489567545*^9, 3.9402124990057087`*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"7db0ab35-aa96-c74a-a70d-e7e6cf4b5d62"],

Cell[BoxData[
 TemplateBox[{"\"neutron\"", 
   RowBox[{"Entity", "[", 
     RowBox[{"\"Particle\"", ",", "\"Neutron\""}], "]"}], 
   "\"Entity[\\\"Particle\\\", \\\"Neutron\\\"]\"", "\"particle\""},
  "Entity"]], "Output",
 CellChangeTimes->{3.940388933330492*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"bcb501a1-8289-6e43-b38b-dbd41c743b7e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"iso", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"IsotopeData", "[", "#", "]"}], "&"}], ")"}], "/@", 
     "isoSimplest"}], ")"}], "/.", 
   RowBox[{
    RowBox[{"IsotopeData", "[", "\"\<Neutron\>\"", "]"}], "->", 
    RowBox[{"ParticleData", "[", "\"\<Neutron\>\"", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.940164771152731*^9, 3.940164771776535*^9}, {
  3.940212479751793*^9, 3.940212487751772*^9}, {3.940212518389887*^9, 
  3.9402125279343605`*^9}, {3.9403844282528973`*^9, 3.940384429300825*^9}, {
  3.940388922519697*^9, 3.9403889245751057`*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"3ade79c2-29a0-4834-bd24-0a269b1fb0a8"],

Cell[BoxData[
 TemplateBox[{
  "IsotopeData", "notent", 
   "\"\\!\\(\\*RowBox[{\\\"\\\\\\\"Neutron\\\\\\\"\\\"}]\\) is not a known \
entity, class, or tag for \\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\). Use \
\\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\)[] for a list of entities.\"", 2, 48,
    1, 24449542068384399174, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.940388936533041*^9},
 CellLabel->
  "During evaluation of \
In[48]:=",ExpressionUUID->"17f0bdfe-716d-7a41-9687-0e859dd2261d"],

Cell[BoxData[
 TemplateBox[{
  "IsotopeData", "notent", 
   "\"\\!\\(\\*RowBox[{\\\"\\\\\\\"Neutron\\\\\\\"\\\"}]\\) is not a known \
entity, class, or tag for \\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\). Use \
\\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\)[] for a list of entities.\"", 2, 48,
    2, 24449542068384399174, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.940388937260517*^9},
 CellLabel->
  "During evaluation of \
In[48]:=",ExpressionUUID->"ef0bc72f-bdfd-e344-a019-4be722bc9dbb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TemplateBox[{"\"neutron\"", 
     RowBox[{"Entity", "[", 
       RowBox[{"\"Particle\"", ",", "\"Neutron\""}], "]"}], 
     "\"Entity[\\\"Particle\\\", \\\"Neutron\\\"]\"", "\"particle\""},
    "Entity"], ",", 
   TemplateBox[{"\"protium\"", 
     RowBox[{"Entity", "[", 
       RowBox[{"\"Isotope\"", ",", "\"Hydrogen1\""}], "]"}], 
     "\"Entity[\\\"Isotope\\\", \\\"Hydrogen1\\\"]\"", "\"isotope\""},
    "Entity"], ",", 
   TemplateBox[{"\"helium-4\"", 
     RowBox[{"Entity", "[", 
       RowBox[{"\"Isotope\"", ",", "\"Helium4\""}], "]"}], 
     "\"Entity[\\\"Isotope\\\", \\\"Helium4\\\"]\"", "\"isotope\""},
    "Entity"]}], "}"}]], "Output",
 CellChangeTimes->{3.9403889372856197`*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"09874259-bf0c-8d4d-92ed-552ffdaf0268"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CanonicalName", "/@", "iso"}]], "Input",
 CellChangeTimes->{{3.9402125523845882`*^9, 3.9402125569419975`*^9}},
 CellLabel->"In[49]:=",ExpressionUUID->"cef6f9b6-59a7-a14d-9450-8224c3153f24"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Neutron\"\>", ",", "\<\"Hydrogen1\"\>", 
   ",", "\<\"Helium4\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.9403889373292484`*^9},
 CellLabel->"Out[49]=",ExpressionUUID->"16a29f24-b768-6842-a66d-daecaddd68de"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/isotopes.dat\>\"", ",", 
   RowBox[{"CanonicalName", "/@", "iso"}]}], "]"}]], "Input",
 CellLabel->"In[50]:=",ExpressionUUID->"3c717ba3-efa0-4050-81c4-44a0cc5a4b6a"],

Cell[BoxData["\<\"data/isotopes.dat\"\>"], "Output",
 CellChangeTimes->{3.940388937352701*^9},
 CellLabel->"Out[50]=",ExpressionUUID->"10363e18-46b8-5a49-9972-b5dda9048ce1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"niso", "=", 
  RowBox[{
   RowBox[{"Dimensions", "[", "iso", "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.403188188495112*^9, 3.403188189676811*^9}, {
  3.403190557341346*^9, 3.403190560676141*^9}, {3.403237638166006*^9, 
  3.40323764987284*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"89f62592-fdb0-4e31-a574-062869f3f86c"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{3.9403889373577175`*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"5bfcdfc0-eb43-7d43-a716-5f3588897018"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"BUG", "?"}], ":", " ", 
    RowBox[{"ponizej", " ", "potencjalny", " ", "blad"}], ":", " ", 
    RowBox[{"nie", " ", "jest", " ", "oczywiste"}]}], ",", " ", 
   RowBox[{
   "ze", " ", "ostatnie", " ", "jadro", " ", "atomowe", " ", "na", " ", 
    "liscie", " ", "ma", " ", "najwiecej", " ", "neutronow", " ", "i", " ", 
    RowBox[{"protonow", "!"}], " ", "Nalezy", " ", "przeszukac", " ", "cala", 
    " ", "liste"}]}], " ", "\[IndentingNewLine]", "*)"}]], "Input",
 CellLabel->"In[52]:=",ExpressionUUID->"d7bc3acf-7edd-4d2c-9dca-f26351fab7c8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"isoZ", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"IsotopeData", "[", 
       RowBox[{"#", ",", "\"\<AtomicNumber\>\""}], "]"}], "&"}], "/@", 
     "iso"}], ")"}], "/.", 
   RowBox[{
    RowBox[{"IsotopeData", "[", 
     RowBox[{
      TemplateBox[{"\"neutron\"", 
        RowBox[{"Entity", "[", 
          RowBox[{"\"Particle\"", ",", "\"Neutron\""}], "]"}], 
        "\"Entity[\\\"Particle\\\", \\\"Neutron\\\"]\"", "\"particle\""},
       "Entity"], ",", "\"\<AtomicNumber\>\""}], "]"}], "->", 
    "0"}]}]}]], "Input",
 CellChangeTimes->{{3.9402126210569134`*^9, 3.9402126414784107`*^9}, {
  3.9402126875990314`*^9, 3.940212689022951*^9}},
 CellLabel->"In[53]:=",ExpressionUUID->"d29fd791-87fa-4ad6-8158-9fb3363ebbe4"],

Cell[BoxData[
 TemplateBox[{
  "IsotopeData", "notent", 
   "\"\\!\\(\\*TemplateBox[List[\\\"\\\\\\\"neutron\\\\\\\"\\\", RowBox[List[\
\\\"Entity\\\", \\\"[\\\", RowBox[List[\\\"\\\\\\\"Particle\\\\\\\"\\\", \
\\\",\\\", \\\"\\\\\\\"Neutron\\\\\\\"\\\"]], \\\"]\\\"]], \
\\\"\\\\\\\"Entity[\\\\\\\\\\\\\\\"Particle\\\\\\\\\\\\\\\", \
\\\\\\\\\\\\\\\"Neutron\\\\\\\\\\\\\\\"]\\\\\\\"\\\", \
\\\"\\\\\\\"particle\\\\\\\"\\\"], \\\"Entity\\\"]\\) is not a known entity, \
class, or tag for \\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\). Use \
\\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\)[] for a list of entities.\"", 2, 53,
    3, 24449542068384399174, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.940388937399885*^9},
 CellLabel->
  "During evaluation of \
In[53]:=",ExpressionUUID->"d7512921-8578-5540-a4e4-b10a9e88e69e"],

Cell[BoxData[
 TemplateBox[{
  "IsotopeData", "notent", 
   "\"\\!\\(\\*TemplateBox[List[\\\"\\\\\\\"neutron\\\\\\\"\\\", RowBox[List[\
\\\"Entity\\\", \\\"[\\\", RowBox[List[\\\"\\\\\\\"Particle\\\\\\\"\\\", \
\\\",\\\", \\\"\\\\\\\"Neutron\\\\\\\"\\\"]], \\\"]\\\"]], \
\\\"\\\\\\\"Entity[\\\\\\\\\\\\\\\"Particle\\\\\\\\\\\\\\\", \
\\\\\\\\\\\\\\\"Neutron\\\\\\\\\\\\\\\"]\\\\\\\"\\\", \
\\\"\\\\\\\"particle\\\\\\\"\\\"], \\\"Entity\\\"]\\) is not a known entity, \
class, or tag for \\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\). Use \
\\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\)[] for a list of entities.\"", 2, 53,
    4, 24449542068384399174, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.9403889374381943`*^9},
 CellLabel->
  "During evaluation of \
In[53]:=",ExpressionUUID->"ef8820e7-260e-5a4a-a001-45fb05e4f815"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.9403889374431953`*^9},
 CellLabel->"Out[53]=",ExpressionUUID->"531008b9-46f5-7444-acb3-90a2ea6a232d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"isoN", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"IsotopeData", "[", 
       RowBox[{"#", ",", "\"\<NeutronNumber\>\""}], "]"}], "&"}], "/@", 
     "iso"}], ")"}], "/.", 
   RowBox[{
    RowBox[{"IsotopeData", "[", 
     RowBox[{
      TemplateBox[{"\"neutron\"", 
        RowBox[{"Entity", "[", 
          RowBox[{"\"Particle\"", ",", "\"Neutron\""}], "]"}], 
        "\"Entity[\\\"Particle\\\", \\\"Neutron\\\"]\"", "\"particle\""},
       "Entity"], ",", "\"\<NeutronNumber\>\""}], "]"}], "->", 
    "1"}]}]}]], "Input",
 CellChangeTimes->{{3.940212691782652*^9, 3.9402127072142982`*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"3f2eae96-94a2-4fd4-b0c1-ec149985eb45"],

Cell[BoxData[
 TemplateBox[{
  "IsotopeData", "notent", 
   "\"\\!\\(\\*TemplateBox[List[\\\"\\\\\\\"neutron\\\\\\\"\\\", RowBox[List[\
\\\"Entity\\\", \\\"[\\\", RowBox[List[\\\"\\\\\\\"Particle\\\\\\\"\\\", \
\\\",\\\", \\\"\\\\\\\"Neutron\\\\\\\"\\\"]], \\\"]\\\"]], \
\\\"\\\\\\\"Entity[\\\\\\\\\\\\\\\"Particle\\\\\\\\\\\\\\\", \
\\\\\\\\\\\\\\\"Neutron\\\\\\\\\\\\\\\"]\\\\\\\"\\\", \
\\\"\\\\\\\"particle\\\\\\\"\\\"], \\\"Entity\\\"]\\) is not a known entity, \
class, or tag for \\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\). Use \
\\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\)[] for a list of entities.\"", 2, 54,
    5, 24449542068384399174, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.94038893746472*^9},
 CellLabel->
  "During evaluation of \
In[54]:=",ExpressionUUID->"51dd2b99-b803-ab4a-baf5-b9b5bd265b85"],

Cell[BoxData[
 TemplateBox[{
  "IsotopeData", "notent", 
   "\"\\!\\(\\*TemplateBox[List[\\\"\\\\\\\"neutron\\\\\\\"\\\", RowBox[List[\
\\\"Entity\\\", \\\"[\\\", RowBox[List[\\\"\\\\\\\"Particle\\\\\\\"\\\", \
\\\",\\\", \\\"\\\\\\\"Neutron\\\\\\\"\\\"]], \\\"]\\\"]], \
\\\"\\\\\\\"Entity[\\\\\\\\\\\\\\\"Particle\\\\\\\\\\\\\\\", \
\\\\\\\\\\\\\\\"Neutron\\\\\\\\\\\\\\\"]\\\\\\\"\\\", \
\\\"\\\\\\\"particle\\\\\\\"\\\"], \\\"Entity\\\"]\\) is not a known entity, \
class, or tag for \\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\). Use \
\\!\\(\\*RowBox[{\\\"IsotopeData\\\"}]\\)[] for a list of entities.\"", 2, 54,
    6, 24449542068384399174, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.940388937494829*^9},
 CellLabel->
  "During evaluation of \
In[54]:=",ExpressionUUID->"6c695c90-816a-bb48-893e-bddfd38151ae"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "0", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.9403889375007305`*^9},
 CellLabel->"Out[54]=",ExpressionUUID->"cf2cb262-ad84-314a-87c7-7a38cd8ea98b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Zmax", "=", 
    RowBox[{
     RowBox[{"IsotopeData", "[", 
      RowBox[{
       RowBox[{"iso", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}], ",", "\"\<AtomicNumber\>\""}], 
      "]"}], " ", "+", 
     RowBox[{"3", " ", 
      RowBox[{"Max", ".", " ", "atomic"}], " ", "number"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Nmax", "=", 
    RowBox[{
     RowBox[{"IsotopeData", "[", 
      RowBox[{
       RowBox[{"iso", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}], ",", "\"\<NeutronNumber\>\""}], 
      "]"}], " ", "+", 
     RowBox[{"2", " ", 
      RowBox[{"Max", ".", " ", "neutron"}], " ", "number"}]}]}], " ", 
   "*)"}]}]], "Input",
 CellLabel->"In[55]:=",ExpressionUUID->"2565439b-ce1a-4475-8b7d-456f124af098"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Zmax", "=", 
   RowBox[{"(", 
    RowBox[{"isoZ", "//", "Max"}], " ", ")"}]}], 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Max", ".", " ", "atomic"}], " ", "number"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Nmax", "=", 
  RowBox[{"(", 
   RowBox[{"isoN", "//", "Max"}], ")"}], 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Max", ".", " ", "neutron"}], " ", "number"}], " ", 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.940212728975401*^9, 3.9402127368719215`*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"4f4bd7a0-746a-4782-a6c5-224e5987f681"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{3.940388937522873*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"b3e9ebf7-31ce-8147-9ae2-51479a3612cb"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{3.940388937526869*^9},
 CellLabel->"Out[57]=",ExpressionUUID->"d56e363d-2218-b749-971c-544a9e27c4da"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"nseH", "=", 
   RowBox[{"\"\<#define kT_MIN_nse \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"tempMIN", " ", "//", "N"}], "]"}], " ", "<>", "\"\<\\n\>\"", "<>",
     "\[IndentingNewLine]", "\"\<#define kT_MAX_nse \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"tempMAX", " ", "//", "N"}], "]"}], " ", "<>", "\"\<\\n\>\"", "<>",
     "\[IndentingNewLine]", "\"\<#define N_kT_nse \>\"", " ", "<>", " ", 
    RowBox[{"ToString", "[", "tempNum", "]"}], "<>", "\"\<\\n\>\"", "<>", 
    "\[IndentingNewLine]", "\"\<#define lg_rho_MIN_nse \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"lgdensMIN", " ", "//", "N"}], "]"}], " ", "<>", "\"\<\\n\>\"", "<>",
     "\[IndentingNewLine]", "\"\<#define lg_rho_MAX_nse \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"lgdensMAX", " ", "//", "N"}], "]"}], " ", "<>", "\"\<\\n\>\"", "<>",
     "\[IndentingNewLine]", "\"\<#define N_lg_rho_nse \>\"", " ", "<>", " ", 
    RowBox[{"ToString", "[", "lgdensNum", "]"}], "<>", "\"\<\\n\>\"", " ", "<>",
     "\[IndentingNewLine]", "\"\<#define N_Ye_nse \>\"", "<>", 
    RowBox[{"ToString", "[", "YeNum", "]"}], " ", "<>", "\"\<\\n\>\"", "<>", 
    "\[IndentingNewLine]", "\"\<#define niso \>\"", "<>", 
    RowBox[{"ToString", "[", "niso", "]"}], "<>", "\"\<\\n\>\"", "<>", 
    "\[IndentingNewLine]", "\"\<#define Z_max_nse \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"Zmax", "+", "1"}], "]"}], "<>", "\"\<\\n\>\"", "<>", 
    "\[IndentingNewLine]", "\"\<#define N_max_nse \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"Nmax", "+", "1"}], "]"}], "<>", "\"\<\\n\>\""}]}], 
  ";"}]], "Input",
 CellLabel->"In[58]:=",ExpressionUUID->"d9a6acd2-7eae-4fe3-ba8e-60b6ebead0e6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Export", "[", 
   RowBox[{"\"\<data/nse_tbl.h\>\"", ",", "nseH", ",", "\"\<Text\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.4224523204375*^9, 3.42245232271875*^9}, {
  3.4276130710939713`*^9, 3.427613072294448*^9}, {3.489463203255787*^9, 
  3.489463204112836*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"f768f217-23f7-4dcb-9c17-92b832086012"],

Cell[BoxData["\<\"data/nse_tbl.h\"\>"], "Output",
 CellChangeTimes->{3.940388937552866*^9},
 CellLabel->"Out[59]=",ExpressionUUID->"2ad2aa4d-fba5-424f-aa3a-69aa92db1f95"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nuclideTBL", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{"iso", ",", 
         RowBox[{"IsotopeData", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"ii", ",", 
             RowBox[{"ii", "+", "jj"}]}], "}"}], ",", 
           "\"\<StandardName\>\""}], "]"}]}], "]"}], "\[Equal]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"iso", ",", 
          RowBox[{"IsotopeData", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"ii", ",", 
              RowBox[{"ii", "+", "jj"}]}], "}"}], ",", 
            "\"\<StandardName\>\""}], "]"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", "1"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "1", ",", "Zmax"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"jj", ",", "1", ",", "Nmax"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{3.940212790574236*^9},
 CellLabel->"In[60]:=",ExpressionUUID->"74be6161-1949-4da0-b038-9a3957125ce9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.940388937558796*^9},
 CellLabel->"Out[60]=",ExpressionUUID->"ee94197b-b4bf-1b4d-a67d-261f723214d7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prepend", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", 
        RowBox[{"Nmax", "-", "1"}]}], "}"}]}], "]"}], ",", "0"}], "]"}], " ", 
  ";"}]], "Input",
 CellLabel->"In[61]:=",ExpressionUUID->"e1ca29ed-6aa9-4acf-9ea5-14c001f90b23"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prepend", "[", 
   RowBox[{"nuclideTBL", ",", "%"}], "]"}], " ", ";"}]], "Input",
 CellLabel->"In[62]:=",ExpressionUUID->"de1e77a3-6cf0-4df8-b82e-667a6a7babc5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "[", "%", "]"}], ";"}]], "Input",
 CellLabel->"In[63]:=",ExpressionUUID->"653822bf-a4ac-4663-b7b0-79379c127c82"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"ii", "\[Equal]", "1"}], ",", "1", ",", 
       RowBox[{"-", "1"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "0", ",", "Zmax"}], "}"}]}], "]"}], ";"}]}]], "Input",
 CellLabel->"In[64]:=",ExpressionUUID->"483aead0-894a-4afd-81ee-5b31b6a43073"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Prepend", "[", 
    RowBox[{"%%", ",", "%"}], "]"}], ";"}]}]], "Input",
 CellLabel->"In[65]:=",ExpressionUUID->"16e5f2ae-9045-4b8c-a337-cad91f474066"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nuclideTBLfinal", "=", 
   RowBox[{"Transpose", "[", "%", "]"}]}], ";"}]], "Input",
 CellLabel->"In[66]:=",ExpressionUUID->"afb460e5-52ac-4db8-8ac3-a5b9539f6a05"],

Cell[BoxData[
 RowBox[{
  RowBox[{"magick", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"17", ",", "16"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"21", ",", "20"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"29", ",", "28"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"51", ",", "50"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Nmax", "+", "1"}], ",", "Nmax"}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.489207050654889*^9, 3.489207052214978*^9}},
 CellLabel->"In[67]:=",ExpressionUUID->"81ddc5a1-f4bf-4db5-bb2b-9e8669c2d162"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixPlot", "[", 
  RowBox[{"nuclideTBLfinal", ",", " ", 
   RowBox[{"DataReversed", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"True", ",", "False"}], "}"}]}], ",", 
   RowBox[{"Mesh", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"FrameTicks", "\[Rule]", 
    RowBox[{"{", " ", 
     RowBox[{"magick", ",", "magick", ",", "None", " ", ",", "None"}], " ", 
     "}"}]}], ",", 
   RowBox[{"ColorRules", "->", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "\[Rule]", "White"}], ",", 
      RowBox[{"_", "\[Rule]", "Black"}]}], "}"}]}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Z\>\"", ",", "\"\<N\>\""}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[68]:=",ExpressionUUID->"23449f0d-e12a-4628-a3c7-4f507a17c05a"],

Cell[BoxData[
 GraphicsBox[{
   RasterBox[SparseArray[
    Automatic, {3, 3}, 0., {
     1, {{0, 2, 5, 8}, {{1}, {3}, {1}, {2}, {3}, {1}, {2}, {3}}}, {1., 1., 0.,
       1., 1., 1., 1., 0.}}], {{0, 0}, {3, 3}}, {0, 1}], {
    {GrayLevel[
      NCache[-1 + GoldenRatio, 0.6180339887498949]], 
     StyleBox[
      LineBox[{{{0, 3}, {3, 3}}, {{0, 2}, {3, 2}}, {{0, 1}, {3, 1}}, {{0, 
       0}, {3, 0}}}],
      Antialiasing->False]}, 
    {GrayLevel[
      NCache[-1 + GoldenRatio, 0.6180339887498949]], 
     StyleBox[
      LineBox[{{{0, 0}, {0, 3}}, {{1, 0}, {1, 3}}, {{2, 0}, {2, 3}}, {{3, 
       0}, {3, 3}}}],
      Antialiasing->False]}}},
  Frame->True,
  FrameLabel->{
    FormBox["\"N\"", TraditionalForm], 
    FormBox["\"Z\"", TraditionalForm]},
  FrameTicks->{{{{1.5, 
       FormBox["1", TraditionalForm]}, {8.5, 
       FormBox["8", TraditionalForm]}, {16.5, 
       FormBox["16", TraditionalForm]}, {20.5, 
       FormBox["20", TraditionalForm]}, {28.5, 
       FormBox["28", TraditionalForm]}, {50.5, 
       FormBox["50", TraditionalForm]}, {2.5, 
       FormBox["2", TraditionalForm]}}, None}, {{{1.5, 
       FormBox["1", TraditionalForm]}, {8.5, 
       FormBox["8", TraditionalForm]}, {16.5, 
       FormBox["16", TraditionalForm]}, {20.5, 
       FormBox["20", TraditionalForm]}, {28.5, 
       FormBox["28", TraditionalForm]}, {50.5, 
       FormBox["50", TraditionalForm]}, {2.5, 
       FormBox["2", TraditionalForm]}}, None}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "GridLinesInFront" -> True, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultPlotStyle" -> 
    Automatic, "DomainPadding" -> Scaled[0.02], "RangePadding" -> 
    Scaled[0.05]}]], "Output",
 CellChangeTimes->{3.9403889376774693`*^9},
 CellLabel->"Out[68]=",ExpressionUUID->"c98746e2-0366-8343-84d8-c8b74d597174"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/Nuclide_chart.pdf\>\"", ",", "%"}], "]"}]], "Input",
 CellChangeTimes->{{3.4898414983523264`*^9, 3.4898415333873262`*^9}, {
  3.5534421016176243`*^9, 3.553442104335987*^9}},
 CellLabel->"In[69]:=",ExpressionUUID->"1fe8c5a0-8515-4979-91d9-d251e18ae62a"],

Cell[BoxData["\<\"data/Nuclide_chart.pdf\"\>"], "Output",
 CellChangeTimes->{3.9403889378026066`*^9},
 CellLabel->"Out[69]=",ExpressionUUID->"857c133a-3e6b-ac4b-af8b-df94bf55ec13"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", "nuclideTBLfinal", "]"}]], "Input",
 CellChangeTimes->{{3.489292782210455*^9, 3.4892927893468637`*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"1e86d045-429b-4b45-9af2-02899ef37421"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{3.940388937810608*^9},
 CellLabel->"Out[70]=",ExpressionUUID->"9123c687-e6b8-5845-bca9-d1273ed8e600"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/N_Z_tbl.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", "nuclideTBLfinal", "]"}], "<>", "\"\<\\n\>\""}], 
   ",", "\"\<Text\>\""}], "]"}]], "Input",
 CellLabel->"In[71]:=",ExpressionUUID->"fb04fffa-6713-40fc-9a4b-ac43e88ecfca"],

Cell[BoxData["\<\"data/N_Z_tbl.dat\"\>"], "Output",
 CellChangeTimes->{3.940388937862011*^9},
 CellLabel->"Out[71]=",ExpressionUUID->"6b079698-b3e1-5441-9610-73270d4ccb41"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"neutron", "=", 
  RowBox[{"{", 
   RowBox[{"0", ",", "\"\<n\>\"", ",", "0", ",", "1", ",", "1", ",", 
    RowBox[{"1", "/", "2"}], ",", "1"}], "}"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Neutron", " ", "data", " ", "must", " ", "be", " ", "insterted", " ", 
     "by", " ", "hand"}], ",", " ", 
    RowBox[{"because", " ", "it", " ", "was", " ", 
     RowBox[{"removed", ".", " ", "Is"}], " ", "neutron", " ", 
     RowBox[{"nuclide", "?"}]}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.940212966808365*^9, 3.9402130016703033`*^9}, {
  3.940384498860815*^9, 3.940384540773464*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"98974bbe-cc28-184e-a8d4-ea9e801c7ec2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "\<\"n\"\>", ",", "0", ",", "1", ",", "1", ",", 
   FractionBox["1", "2"], ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.940388937869999*^9},
 CellLabel->"Out[72]=",ExpressionUUID->"c62c3928-a04c-7944-9a28-0dd770499965"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"id", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", "neutron", "}"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"QuantityMagnitude", "[", 
         RowBox[{
          RowBox[{"IsotopeData", "[", 
           RowBox[{
            RowBox[{"iso", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], ",", "\"\<BindingEnergy\>\""}], 
           "]"}], ",", "\"\<MeV\>\""}], "]"}], ",", 
        RowBox[{"IsotopeData", "[", 
         RowBox[{
          RowBox[{"iso", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], ",", "\"\<Symbol\>\""}], "]"}], 
        ",", 
        RowBox[{"IsotopeData", "[", 
         RowBox[{
          RowBox[{
          "iso", "\[LeftDoubleBracket]", "ii", "\[RightDoubleBracket]"}], 
          ",", "\"\<AtomicNumber\>\""}], "]"}], ",", 
        RowBox[{"IsotopeData", "[", 
         RowBox[{
          RowBox[{"iso", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], ",", "\"\<NeutronNumber\>\""}], 
         "]"}], ",", 
        RowBox[{"IsotopeData", "[", 
         RowBox[{
          RowBox[{"iso", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], ",", "\"\<MassNumber\>\""}], 
         "]"}], ",", 
        RowBox[{"IsotopeData", "[", 
         RowBox[{
          RowBox[{"iso", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], ",", "\"\<Spin\>\""}], "]"}], ",",
         "ii"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "2", ",", "niso", ",", "1"}], "}"}]}], "]"}]}], " ",
    "]"}]}]], "Input",
 CellChangeTimes->{{3.9402128956803207`*^9, 3.9402128957990246`*^9}, {
  3.940213004824997*^9, 3.940213022366333*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"67de780d-a442-4a31-bffb-451a415aaeac"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "\<\"n\"\>", ",", "0", ",", "1", ",", "1", ",", 
     FractionBox["1", "2"], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     TemplateBox[{
       TemplateBox[{"\"\"", "1"}, "Superscript", SyntaxForm -> 
        SuperscriptBox], "\"H\""},
      "RowDefault"], ",", "1", ",", "0", ",", "1", ",", 
     FractionBox["1", "2"], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7.0739156`7.2475998825458765", ",", 
     TemplateBox[{
       TemplateBox[{"\"\"", "4"}, "Superscript", SyntaxForm -> 
        SuperscriptBox], "\"He\""},
      "RowDefault"], ",", "2", ",", "2", ",", "4", ",", "0", ",", "3"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.940388938001173*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"e9a63c72-885a-d344-a1b2-7bcd8b888601"]
}, Open  ]],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"tbl", "=", 
    RowBox[{
     RowBox[{"SetPrecision", "[", 
      RowBox[{
       RowBox[{"id", " ", "/.", 
        RowBox[{"_Missing", "\[Rule]", "0"}]}], ",", "myPrecision"}], "]"}], "//",
      "Rationalize"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.4031882980726767`*^9, 3.4031883021986094`*^9}, 
   3.4031883446296225`*^9, {3.4031902812142944`*^9, 3.4031902917294145`*^9}, {
   3.403190769676669*^9, 3.4031907857798243`*^9}, {3.4031956172170897`*^9, 
   3.4031956181384144`*^9}, 3.40319721968132*^9, {3.403237766440456*^9, 
   3.4032377671815214`*^9}, {3.452755689840343*^9, 3.452755690634221*^9}, {
   3.489230247240658*^9, 3.489230254589078*^9}, {3.489286975867696*^9, 
   3.4892869791958857`*^9}, {3.4893825185313654`*^9, 3.4893825504591913`*^9}},
 CellLabel->"In[74]:=",ExpressionUUID->"689276b1-576d-4ab7-9134-f68a9f6122e2"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"SetPrecision", "[", 
    RowBox[{"id", ",", "100"}], "]"}], " ", ";"}], "*)"}]], "Input",
 CellChangeTimes->{{3.45275573736714*^9, 3.4527557378123407`*^9}, {
  3.4892080232285166`*^9, 3.4892080253056355`*^9}},
 CellLabel->"In[75]:=",ExpressionUUID->"9f043391-9cd9-4283-bd08-9d9da646bc1c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"Table", "[", 
    RowBox[{",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4031688845769887`*^9, 3.403168901801757*^9}, {
   3.403168973104285*^9, 3.403168975387568*^9}, {3.4031690124608765`*^9, 
   3.4031690136325617`*^9}, {3.403170218094493*^9, 3.4031702362405853`*^9}, 
   3.4031883842566032`*^9, 3.403268926316117*^9, {3.41274045947103*^9, 
   3.412740460600136*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"a2292547-1fb4-41f8-87e5-5a8a9a48239d"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Temperature", " ", "dependend", " ", "partition", " ", "function"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.420433197109375*^9, 3.420433213125*^9}},
 CellLabel->"In[77]:=",ExpressionUUID->"a156b7eb-e2f8-4a35-9192-41a03415e363"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QuantityMagnitude", "[", 
  RowBox[{
   RowBox[{"IsotopeData", "[", 
    RowBox[{
     RowBox[{"iso", "[", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}], "]"}], ",", 
     "\"\<ExcitedStateEnergies\>\""}], "]"}], ",", "\"\<MeV\>\""}], 
  "]"}]], "Input",
 CellLabel->"In[78]:=",ExpressionUUID->"cfdfafbb-2242-4d1f-a661-67456d7f30c6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "20.21`5.", ",", "21.01`5.", ",", "21.84`5.", ",", "23.33`5.", ",", 
   "23.64`5.", ",", "24.25`5.", ",", "25.28`5.", ",", "25.95`5.", ",", 
   "27.42`5.", ",", "28.31`5.", ",", "28.37`5.", ",", "28.39`5.", ",", 
   "28.64`5.", ",", "28.67`5.", ",", "29.89`5."}], "}"}]], "Output",
 CellChangeTimes->{3.940388938043371*^9},
 CellLabel->"Out[78]=",ExpressionUUID->"a33b1f33-a702-9845-ac2a-852601e91f2f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{"%", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "]"}]], "Input",
 CellLabel->"In[79]:=",ExpressionUUID->"b3f44829-109b-4a03-a245-e289c820ed35"],

Cell[BoxData[
 TagBox[
  StyleBox["20.21`5.",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.9403889380690403`*^9},
 CellLabel->
  "Out[79]//FullForm=",ExpressionUUID->"750106a5-0b4b-9242-9d7a-399a16cf65a6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"e", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", "}"}], "}"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"SetPrecision", "[", 
        RowBox[{
         RowBox[{"QuantityMagnitude", "[", 
          RowBox[{
           RowBox[{"IsotopeData", "[", 
            RowBox[{
             RowBox[{"iso", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], ",", 
             "\"\<ExcitedStateEnergies\>\""}], "]"}], ",", "\"\<MeV\>\""}], 
          "]"}], ",", "myPrecision"}], "]"}], " ", ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "2", ",", "niso"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.9402130582547607`*^9, 3.940213081135357*^9}},
 CellLabel->"In[80]:=",ExpressionUUID->"fb836d59-b682-4b6d-abd7-237271c11c32"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"jEXP", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", "}"}], "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"IsotopeData", "[", 
         RowBox[{
          RowBox[{"iso", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], ",", 
          "\"\<ExcitedStateSpins\>\""}], "]"}], " ", ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "2", ",", "niso"}], "}"}]}], "]"}]}], " ", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.42994600325*^9, 3.429946005421875*^9}, {
   3.452757115381288*^9, 3.4527571170245323`*^9}, {3.4892305051404085`*^9, 
   3.489230512751844*^9}, {3.489230546897797*^9, 3.4892305649338284`*^9}, 
   3.4892307469902415`*^9, 3.489230829695972*^9, {3.9402130980090733`*^9, 
   3.9402131283190136`*^9}},
 CellLabel->"In[82]:=",ExpressionUUID->"5f020eb9-ac8d-42b4-a0f6-09dd906d3dd6"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"j", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Switch", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Dimensions", "[", 
           RowBox[{"jEXP", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "i"}], "]"}], "]"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"jEXP", "[", 
           RowBox[{"[", 
            RowBox[{"ii", ",", "i"}], "]"}], "]"}], ",", 
          RowBox[{"(*", " ", 
           RowBox[{"Spin", " ", "known"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"{", "1", "}"}], ",", "0", ",", 
          RowBox[{"(*", " ", 
           RowBox[{"Spin", " ", "unknown"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"{", "2", "}"}], ",", 
          RowBox[{
           RowBox[{"jEXP", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "i"}], "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"(*", " ", 
         RowBox[{"Spin", " ", 
          RowBox[{"uncertain", ":", " ", 
           RowBox[{"first", " ", 
            RowBox[{"taken", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"avg", ".", " ", "or"}], " ", "random", " ", 
               "possible"}], ",", " ", 
              RowBox[{"but", " ", "difficult", " ", "to", " ", 
               RowBox[{"reproduce", "!"}]}]}], "]"}]}]}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", 
            RowBox[{"jEXP", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.42994600740625*^9, 3.42994600975*^9}, {
  3.452757128475668*^9, 3.452757130693459*^9}, {3.489230520512288*^9, 
  3.489230521125323*^9}, {3.489231536040373*^9, 3.4892315495131435`*^9}, {
  3.489231670540066*^9, 3.489231701953862*^9}, {3.489231744643304*^9, 
  3.489231776759141*^9}, {3.4892319227574916`*^9, 3.4892319248816133`*^9}},
 CellLabel->"In[83]:=",ExpressionUUID->"bdd32276-5739-4b27-bb7c-22531ebc6ae8"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"TODO", ":", " ", 
   RowBox[{"third", "-", 
    RowBox[{"party", " ", "partition", " ", 
     RowBox[{"function", "!"}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4893890647147856`*^9, 3.4893890762914476`*^9}},
 CellLabel->"In[84]:=",ExpressionUUID->"e8a88925-83c6-4b25-8c4c-a6fbc69412c5"],

Cell[CellGroupData[{

Cell[BoxData["kTtbl"], "Input",
 CellLabel->"In[85]:=",ExpressionUUID->"785050c0-b1db-4a0b-97ce-675460795977"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["3", "10"], ",", 
   FractionBox["7", "20"], ",", 
   FractionBox["2", "5"], ",", 
   FractionBox["9", "20"], ",", 
   FractionBox["1", "2"], ",", 
   FractionBox["11", "20"], ",", 
   FractionBox["3", "5"], ",", 
   FractionBox["13", "20"], ",", 
   FractionBox["7", "10"], ",", 
   FractionBox["3", "4"], ",", 
   FractionBox["4", "5"], ",", 
   FractionBox["17", "20"], ",", 
   FractionBox["9", "10"], ",", 
   FractionBox["19", "20"], ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.9403889381591816`*^9},
 CellLabel->"Out[85]=",ExpressionUUID->"6dd86b8e-1562-d446-adb5-f072e831be6f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"GkT", "=", " ", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "*", 
            RowBox[{"j", "[", 
             RowBox[{"[", 
              RowBox[{"ii", ",", "i"}], "]"}], "]"}]}], "+", "1"}], ")"}], 
         "*", 
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"e", "[", 
             RowBox[{"[", 
              RowBox[{"ii", ",", "i"}], "]"}], "]"}]}], "/", "kT"}], "]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", 
            RowBox[{"e", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], ";"}], 
  " "}]], "Input",
 CellLabel->"In[86]:=",ExpressionUUID->"401ea1e9-2f78-4fb9-80b1-fa6a487d7bb8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LaunchKernels", "[", "8", "]"}], 
  RowBox[{"(*", " ", 
   RowBox[{
   "calculate", " ", "partition", " ", "function", " ", "in", " ", 
    "parallel"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.940213157582863*^9, 3.9402131578458366`*^9}},
 CellLabel->"In[87]:=",ExpressionUUID->"d69aeabd-3454-4ba0-8329-3b6f208289b3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    TemplateBox[{
      RowBox[{
        StyleBox[
         TagBox["KernelObject", "SummaryHead"], "NonInterpretableSummary"], 
        StyleBox["[", "NonInterpretableSummary"], 
        DynamicModuleBox[{
         Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
         TemplateBox[{
           PaneSelectorBox[{False -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                   ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["1", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}], True -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                   ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["1", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"LocalKernels\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"LimitByLicense: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"KernelCommand: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    
                    "\"\\\"C:\\\\Program Files\\\\Wolfram Research\\\\Wolfram\
\\\\14.1\\\\WolframKernel\\\"\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"ProcessID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["13272", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}]}, 
            Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
          "SummaryPanel"], DynamicModuleValues :> {}], 
        StyleBox["]", "NonInterpretableSummary"]}]},
     "CopyTag",
     DisplayFunction->(#& ),
     InterpretationFunction->("Local (8)"& )],
    False,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[
    TemplateBox[{
      RowBox[{
        StyleBox[
         TagBox["KernelObject", "SummaryHead"], "NonInterpretableSummary"], 
        StyleBox["[", "NonInterpretableSummary"], 
        DynamicModuleBox[{
         Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
         TemplateBox[{
           PaneSelectorBox[{False -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                   ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["2", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}], True -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                   ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["2", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"LocalKernels\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"LimitByLicense: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"KernelCommand: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"\\\"C:\\\\Program Files\\\\Wolfram Research\\\\Wolfram\
\\\\14.1\\\\WolframKernel\\\"\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"ProcessID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["5416", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}]}, 
            Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
          "SummaryPanel"], DynamicModuleValues :> {}], 
        StyleBox["]", "NonInterpretableSummary"]}]},
     "CopyTag",
     DisplayFunction->(#& ),
     InterpretationFunction->("Local (8)"& )],
    False,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[
    TemplateBox[{
      RowBox[{
        StyleBox[
         TagBox["KernelObject", "SummaryHead"], "NonInterpretableSummary"], 
        StyleBox["[", "NonInterpretableSummary"], 
        DynamicModuleBox[{
         Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
         TemplateBox[{
           PaneSelectorBox[{False -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                   ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}], True -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                   ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"LocalKernels\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"LimitByLicense: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"KernelCommand: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"\\\"C:\\\\Program Files\\\\Wolfram Research\\\\Wolfram\
\\\\14.1\\\\WolframKernel\\\"\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"ProcessID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["696", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}]}, 
            Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
          "SummaryPanel"], DynamicModuleValues :> {}], 
        StyleBox["]", "NonInterpretableSummary"]}]},
     "CopyTag",
     DisplayFunction->(#& ),
     InterpretationFunction->("Local (8)"& )],
    False,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[
    TemplateBox[{
      RowBox[{
        StyleBox[
         TagBox["KernelObject", "SummaryHead"], "NonInterpretableSummary"], 
        StyleBox["[", "NonInterpretableSummary"], 
        DynamicModuleBox[{
         Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
         TemplateBox[{
           PaneSelectorBox[{False -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                   ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["4", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}], True -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                   ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["4", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"LocalKernels\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"LimitByLicense: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"KernelCommand: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"\\\"C:\\\\Program Files\\\\Wolfram Research\\\\Wolfram\
\\\\14.1\\\\WolframKernel\\\"\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"ProcessID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["19260", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}]}, 
            Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
          "SummaryPanel"], DynamicModuleValues :> {}], 
        StyleBox["]", "NonInterpretableSummary"]}]},
     "CopyTag",
     DisplayFunction->(#& ),
     InterpretationFunction->("Local (8)"& )],
    False,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[
    TemplateBox[{
      RowBox[{
        StyleBox[
         TagBox["KernelObject", "SummaryHead"], "NonInterpretableSummary"], 
        StyleBox["[", "NonInterpretableSummary"], 
        DynamicModuleBox[{
         Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
         TemplateBox[{
           PaneSelectorBox[{False -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                   ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["5", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}], True -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                   ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["5", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"LocalKernels\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"LimitByLicense: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"KernelCommand: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"\\\"C:\\\\Program Files\\\\Wolfram Research\\\\Wolfram\
\\\\14.1\\\\WolframKernel\\\"\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"ProcessID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["13364", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}]}, 
            Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
          "SummaryPanel"], DynamicModuleValues :> {}], 
        StyleBox["]", "NonInterpretableSummary"]}]},
     "CopyTag",
     DisplayFunction->(#& ),
     InterpretationFunction->("Local (8)"& )],
    False,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[
    TemplateBox[{
      RowBox[{
        StyleBox[
         TagBox["KernelObject", "SummaryHead"], "NonInterpretableSummary"], 
        StyleBox["[", "NonInterpretableSummary"], 
        DynamicModuleBox[{
         Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
         TemplateBox[{
           PaneSelectorBox[{False -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                   ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["6", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}], True -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                   ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["6", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"LocalKernels\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"LimitByLicense: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"KernelCommand: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"\\\"C:\\\\Program Files\\\\Wolfram Research\\\\Wolfram\
\\\\14.1\\\\WolframKernel\\\"\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"ProcessID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["15856", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}]}, 
            Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
          "SummaryPanel"], DynamicModuleValues :> {}], 
        StyleBox["]", "NonInterpretableSummary"]}]},
     "CopyTag",
     DisplayFunction->(#& ),
     InterpretationFunction->("Local (8)"& )],
    False,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[
    TemplateBox[{
      RowBox[{
        StyleBox[
         TagBox["KernelObject", "SummaryHead"], "NonInterpretableSummary"], 
        StyleBox["[", "NonInterpretableSummary"], 
        DynamicModuleBox[{
         Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
         TemplateBox[{
           PaneSelectorBox[{False -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                   ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["7", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}], True -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                   ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["7", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"LocalKernels\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"LimitByLicense: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"KernelCommand: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"\\\"C:\\\\Program Files\\\\Wolfram Research\\\\Wolfram\
\\\\14.1\\\\WolframKernel\\\"\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"ProcessID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["10792", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}]}, 
            Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
          "SummaryPanel"], DynamicModuleValues :> {}], 
        StyleBox["]", "NonInterpretableSummary"]}]},
     "CopyTag",
     DisplayFunction->(#& ),
     InterpretationFunction->("Local (8)"& )],
    False,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[
    TemplateBox[{
      RowBox[{
        StyleBox[
         TagBox["KernelObject", "SummaryHead"], "NonInterpretableSummary"], 
        StyleBox["[", "NonInterpretableSummary"], 
        DynamicModuleBox[{
         Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
         TemplateBox[{
           PaneSelectorBox[{False -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                   ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["8", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}], True -> GridBox[{{
                 PaneBox[
                  ButtonBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                   ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                   None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                   "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                 GraphicsBox[{
                   Thickness[0.041666666666666664`], 
                   FaceForm[{
                    RGBColor[0.8670000000000001, 0.067, 0.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0,
                     1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{
                    0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {
                    0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 
                    0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1,
                     0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 
                    2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 
                    1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{1, 4, 3}, {1, 3, 3}, {1, 3, 3}, {1, 3, 
                    3}}, CompressedData["
1:eJxTTMoPSmJiYGDYBsTMQMzIwszIDEUMjAxw9qjIgDtgkIgAAMeOBqk=
                    "]}, {{{15.3311, 13.7891}, {13.498099999999999`, 
                    14.470099999999999`}, {14.598099999999999`, 16.0311}, {
                    16.885099999999998`, 15.5321}}, {{16.510099999999998`, 
                    11.835099999999999`}, {14.9271, 12.3761}, {13.8601, 
                    13.7631}, {15.2531, 13.245099999999999`}}, {{14.4941, 
                    10.8931}, {13.0291, 11.3581}, {14.7571, 
                    11.867099999999999`}, {16.3931, 11.3081}}, {{12.3231, 
                    9.0241}, {12.371099999999998`, 11.0031}, {14.2311, 
                    10.4141}, {14.464099999999998`, 8.0841}}, {{
                    10.982099999999999`, 13.351099999999999`}, {12.9811, 
                    14.024099999999999`}, {14.3121, 12.2951}, {
                    12.216099999999999`, 11.6781}}, {{11.784099999999999`, 
                    8.9271}, {10.8171, 7.2711}, {10.8171, 9.0031}, {11.8211, 
                    10.4691}}, {{10.548099999999998`, 9.5611}, {9.3141, 
                    11.3611}, {10.548099999999998`, 13.0361}, {11.7821, 
                    11.3611}}, {{10.2801, 7.270099999999999}, {9.3121, 
                    8.9271}, {9.275099999999998, 10.4701}, {10.2801, 
                    9.0031}}, {{8.8811, 11.6781}, {6.7851, 12.2951}, {
                    8.115099999999998, 14.024099999999999`}, {10.1141, 
                    13.351099999999999`}}, {{6.632099999999999, 8.0851}, {
                    6.865099999999998, 10.415099999999999`}, {
                    8.726099999999999, 11.0031}, {8.7731, 9.0241}}, {{4.7041, 
                    11.309099999999999`}, {6.339099999999998, 
                    11.867099999999999`}, {8.0671, 11.3581}, {6.6021, 
                    10.8941}}, {{5.8431, 13.2471}, {7.2371, 13.7641}, {6.1701,
                     12.3761}, {4.5861, 11.835099999999999`}}, {{
                    4.2120999999999995`, 15.534099999999999`}, {
                    6.4990999999999985`, 16.0321}, {7.6000999999999985`, 
                    14.470099999999999`}, {5.766099999999998, 
                    13.790099999999999`}}, {{7.6781, 17.0121}, {7.7271, 
                    15.2211}, {6.876099999999997, 16.4291}, {
                    6.684100000000001, 18.353099999999998`}}, {{10.2801, 
                    15.9881}, {10.2801, 13.861099999999999`}, {8.2831, 
                    14.5351}, {8.223099999999999, 16.7201}}, {{
                    8.877099999999999, 17.8791}, {9.7681, 
                    16.740099999999998`}, {8.1101, 17.3291}, {7.1371, 
                    18.643099999999997`}}, {{10.548099999999998`, 20.1371}, {
                    11.7271, 18.1191}, {10.548099999999998`, 16.6131}, {
                    9.370099999999999, 18.1201}}, {{12.874099999999999`, 
                    16.7201}, {12.8141, 14.5351}, {10.8171, 
                    13.861099999999999`}, {10.8171, 15.9881}}, {{14.4141, 
                    18.353099999999998`}, {14.2211, 16.4281}, {
                    13.370099999999999`, 15.2211}, {13.4191, 17.0121}}, {{
                    12.2211, 17.8791}, {13.960099999999999`, 
                    18.643099999999997`}, {12.9861, 17.3291}, {
                    11.330099999999998`, 
                    16.740099999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQAWIQvbn604aAbl2HOM3TAse7DBxs9gZNU9TTc0gMCVJf
sNPY4VdM7tF/QRoOhWu6b2cUGDnwPNCdsEBC1eGgpbJXtbGpwxqQgnuKcPkP
yWdivTkkHNQXdG54CNT/Yvt65uc+kg6qpUyzOLoNHDjOSQbems3p8C7Kye7F
Tn0HC1f3op/+og4HVyzxc/is5XAlP5793ExOhynf2OJn6KjB9a86fzXszXkV
h12sQiL2bBIOGUo5FVVPZeD2CyUevqzNqgh334sejbe8/8QcgK7fVA10f9vJ
kIMrWBQd1qk+aZ6nq+fg+7kvuOSJjAOIe7ZL10HWIt0lE2i+8CfH82lPDR2A
tvuIAu3n3rqs8ninvoOJoJnN3k9aDjdtKyNWAOUva6dKPtqh7wAA/beJig==

                    "], {{10.548099999999998`, 4.790099999999999}, {
                    5.752099999999999, 4.790099999999999}, {
                    1.8640999999999988`, 8.6781}, {1.8640999999999988`, 
                    13.4741}, {1.8640999999999988`, 18.2701}, {
                    5.752099999999999, 22.159100000000002`}, {
                    10.548099999999998`, 22.159100000000002`}, {
                    15.345099999999999`, 22.159100000000002`}, {19.2331, 
                    18.2701}, {19.2331, 13.4741}, {19.2331, 8.6781}, {
                    15.345099999999999`, 4.790099999999999}, {
                    10.548099999999998`, 4.790099999999999}}, CompressedData["
1:eJx1WXl8TdcWvomQRBKZJxK5kTm5N7nDufem+vSsoqTE2BZPqbliqBSvNc+E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                    "]}]}, AspectRatio -> Automatic, ImageSize -> {24., 24.}, 
                  PlotRange -> {{0., 24.}, {0., 24.}}], 
                 GridBox[{{
                    TagBox["\"Local (8)\"", "SummaryItem"]}, {
                    RowBox[{
                    TagBox["\"KernelID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["8", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"LocalKernels\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"LimitByLicense: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"KernelCommand: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"\\\"C:\\\\Program Files\\\\Wolfram Research\\\\Wolfram\
\\\\14.1\\\\WolframKernel\\\"\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"ProcessID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["5820", "SummaryItem"]}]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                  AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                  BaseStyle -> {
                   ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               BaselinePosition -> {1, 1}]}, 
            Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
          "SummaryPanel"], DynamicModuleValues :> {}], 
        StyleBox["]", "NonInterpretableSummary"]}]},
     "CopyTag",
     DisplayFunction->(#& ),
     InterpretationFunction->("Local (8)"& )],
    False,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}], "}"}]], "Output",
 CellChangeTimes->{3.9403889411180115`*^9},
 CellLabel->"Out[87]=",ExpressionUUID->"e5d7a905-29e6-6143-af46-7dbcbde776f3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DistributeDefinitions", "[", 
  RowBox[{"GkT", ",", "tempMIN", ",", "tempMAX", ",", "kTtbl"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.489389099001746*^9, 3.4893891415201783`*^9}, {
  3.489834076879465*^9, 3.489834079957773*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"0eb66dd9-5e7a-40ee-9510-10741d05e3f7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox["GkT",
    HoldForm], ",", 
   TagBox["tempMIN",
    HoldForm], ",", 
   TagBox["tempMAX",
    HoldForm], ",", 
   TagBox["kTtbl",
    HoldForm]}], "}"}]], "Output",
 CellChangeTimes->{3.9403889412512074`*^9},
 CellLabel->"Out[88]=",ExpressionUUID->"ed8c974d-8786-9741-ba13-7e35c0c1143b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"GkTtbl", "=", 
    RowBox[{"ParallelTable", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"kT", "\[Equal]", "0"}], ",", "0", ",", 
          RowBox[{"GkT", "[", 
           RowBox[{"[", "ii", "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"kT", ",", "kTtbl"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.420438605640625*^9, 3.420438613859375*^9}, {
  3.420438976390625*^9, 3.42043901515625*^9}, {3.420439100640625*^9, 
  3.4204391025625*^9}, {3.42043957971875*^9, 3.420439626140625*^9}, {
  3.420439966359375*^9, 3.4204399694375*^9}, {3.420553277765625*^9, 
  3.42055328153125*^9}, {3.4892045101905823`*^9, 3.4892045121446943`*^9}, {
  3.4892870119357586`*^9, 3.489287025232519*^9}, {3.4893891523868*^9, 
  3.4893891534288597`*^9}, {3.489834065054283*^9, 3.4898340674215193`*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"d1b9197f-7429-4300-a7cf-68922798413f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/GkTtbl.m\>\"", ",", "GkTtbl"}], "]"}]], "Input",
 CellChangeTimes->{{3.4896497644312396`*^9, 3.489649780720171*^9}, {
  3.489649905372301*^9, 3.4896499073274126`*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"ca068040-38c3-4a45-a44e-e47bdae99306"],

Cell[BoxData["\<\"data/GkTtbl.m\"\>"], "Output",
 CellChangeTimes->{3.9403889413501244`*^9},
 CellLabel->"Out[90]=",ExpressionUUID->"bee0307d-c5fc-104d-bbc9-c38839c45433"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"GkTtbl", "=", 
   RowBox[{"Import", "[", "\"\<data/GkTtbl.m\>\"", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4896501911006436`*^9, 3.4896502039463787`*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"c9a2f208-efd9-4acd-8488-f6482d16d226"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"GkTtbl", "=", 
    RowBox[{"SetPrecision", "[", 
     RowBox[{
      RowBox[{"Import", "[", 
       RowBox[{"\"\<data/GkT_002.dat\>\"", ",", "\"\<Table\>\""}], "]"}], ",",
       "100"}], "]"}]}], ";"}], "*)"}]], "Input",
 CellChangeTimes->{{3.420451435484375*^9, 3.4204514736875*^9}, {
  3.420553286640625*^9, 3.4205532874375*^9}, {3.420695112412455*^9, 
  3.4206951145122957`*^9}, {3.420696504254094*^9, 3.4206965051602488`*^9}, {
  3.4206968697941732`*^9, 3.420696870337089*^9}, {3.420770181390625*^9, 
  3.420770181859375*^9}, {3.42137750378125*^9, 3.42137751525*^9}, {
  3.42950370978125*^9, 3.429503710375*^9}, {3.429503774171875*^9, 
  3.429503774765625*^9}, {3.48920459318933*^9, 3.489204595575466*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"f471049e-1f78-4768-b581-f23806df58dc"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"(*", " ", 
   RowBox[{"Export", "[", 
    RowBox[{
    "\"\<E://temp/GkT_002.dat\>\"", ",", "GkTtbl", ",", "\"\<Table\>\""}], 
    "]"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.420451442015625*^9, 3.420451445703125*^9}, {
  3.420451479375*^9, 3.42045148175*^9}, {3.42051351403125*^9, 
  3.4205135256875*^9}, {3.42059992109375*^9, 3.42059992359375*^9}},
 CellLabel->"In[93]:=",ExpressionUUID->"f0aea786-c385-4a0c-a169-c7de6764ee17"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GkTtbl", "//", "Dimensions"}]], "Input",
 CellLabel->"In[94]:=",ExpressionUUID->"0cd44265-c4f3-404e-95c8-6036e74a0790"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "15"}], "}"}]], "Output",
 CellChangeTimes->{3.940388941436434*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"d6714cf8-812e-db4d-96d6-892ccc2e3505"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"GkTstring", "=", 
   RowBox[{
    RowBox[{"StringJoin", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{
          RowBox[{"Chop", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"GkTtbl", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], " ", "//", "N"}], ",", 
            RowBox[{"10", "^", 
             RowBox[{"-", "5"}]}]}], "]"}], " ", "//", "N"}], "]"}], "<>", 
        "\"\<,\\n\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "1", ",", 
         RowBox[{"niso", "-", "1"}]}], "}"}]}], "]"}], " ", "]"}], "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"GkTtbl", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], " ", "//", "N"}], ",", 
        RowBox[{"10", "^", 
         RowBox[{"-", "5"}]}]}], "]"}], " ", "//", "N"}], "]"}]}]}], " ", 
  ";"}]], "Input",
 CellChangeTimes->{{3.429681126736472*^9, 3.429681171127837*^9}, {
  3.4296812537258663`*^9, 3.429681264472933*^9}, {3.429681308015745*^9, 
  3.4296813540668364`*^9}, {3.429681529135182*^9, 3.4296815314545937`*^9}, {
  3.429681683064794*^9, 3.42968168811579*^9}, {3.4296817307600813`*^9, 
  3.429681733850766*^9}, {3.429681926322569*^9, 3.4296819521365833`*^9}, {
  3.429681997241164*^9, 3.42968202271765*^9}, {3.429682210345336*^9, 
  3.42968221318606*^9}, {3.429683401168421*^9, 3.429683412358842*^9}, {
  3.429683780711985*^9, 3.429683894118354*^9}, {3.429683927241445*^9, 
  3.429683961296558*^9}, {3.429684002357337*^9, 3.4296840529115868`*^9}, {
  3.429684138215897*^9, 3.4296841426422443`*^9}, {3.4296842100851727`*^9, 
  3.4296842351735477`*^9}, {3.429684309109789*^9, 3.429684369842669*^9}, {
  3.489232309331602*^9, 3.4892323138818626`*^9}, {3.4892323465697327`*^9, 
  3.4892323537251415`*^9}},
 CellLabel->"In[96]:=",ExpressionUUID->"7885d1b9-89ef-423f-a679-f4ce63ce9268"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"ToExpression", "[", 
    RowBox[{"\"\<{\>\"", "<>", "GkTstring", "<>", "\"\<}\>\""}], "]"}], ";", 
   " ", 
   RowBox[{"Read", " ", 
    RowBox[{"this", " ", "^", 
     RowBox[{"^", 
      RowBox[{"^", " ", "using"}]}]}], " ", "this", " ", "line"}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.4892872575298057`*^9, 3.489287266387312*^9}, {
  3.489287675074688*^9, 3.4892876945438013`*^9}, {3.4892882084691963`*^9, 
  3.489288232364563*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"6e3f1abd-f505-4bad-931e-5e49783b8c5f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GkTinterp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"kTtbl", ",", 
          RowBox[{"GkTtbl", "[", 
           RowBox[{"[", "ii", "]"}], "]"}]}], "}"}], "]"}], " ", ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4204385584375*^9, 3.420438600390625*^9}, {
  3.420438683953125*^9, 3.420438694578125*^9}, {3.420439068125*^9, 
  3.4204391185625*^9}, {3.420439977015625*^9, 3.4204399810625*^9}},
 CellLabel->"In[98]:=",ExpressionUUID->"76f2bf66-757b-4929-bcde-7f908c834b08"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"G0", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"tbl", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "6"}], "]"}], "]"}]}], "+", 
       RowBox[{"SetPrecision", "[", 
        RowBox[{"1", ",", "myPrecision"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], " ", ";"}], 
  " "}]], "Input",
 CellChangeTimes->{{3.4031707333554015`*^9, 3.4031707380020833`*^9}, {
   3.4031707840783377`*^9, 3.4031707846892157`*^9}, {3.403171673367072*^9, 
   3.403171703830877*^9}, {3.403188401901976*^9, 3.4031884087418113`*^9}, {
   3.403192842106677*^9, 3.4031928717693295`*^9}, 3.412423552671875*^9, {
   3.41274046307406*^9, 3.412740465080489*^9}, {3.420089203592059*^9, 
   3.42008922295135*^9}, {3.4200892578720417`*^9, 3.42008925795639*^9}, {
   3.420089413900816*^9, 3.420089418817683*^9}, {3.420089746058182*^9, 
   3.420089747119339*^9}, {3.420101967203125*^9, 3.420101971203125*^9}, 
   3.4204385505*^9, {3.4892885050771613`*^9, 3.4892885164798136`*^9}},
 CellLabel->"In[99]:=",ExpressionUUID->"b925c1a2-5e7e-43b1-8737-27d06ea2bbdf"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"G", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"G0", "[", 
        RowBox[{"[", "ii", "]"}], "]"}], "+", 
       RowBox[{
        RowBox[{"GkTinterp", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], "[", "kT", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.420449985609375*^9, 3.420450039125*^9}, {
  3.427613096622208*^9, 3.42761309909496*^9}, {3.429683183043213*^9, 
  3.4296831847849703`*^9}, {3.5536630660871305`*^9, 3.5536630669031773`*^9}, {
  3.553671179928216*^9, 3.553671185903558*^9}, {3.553675146955117*^9, 
  3.553675149395256*^9}},
 CellLabel->
  "In[100]:=",ExpressionUUID->"81ec461a-df91-47c5-8740-ada1be421a83"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"G", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"G0", "[", 
        RowBox[{"[", "ii", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", " ", 
    RowBox[{"Ground", " ", "state", " ", "partition", " ", "function"}]}], 
   "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{
  3.427613112436489*^9, {3.429683188869135*^9, 3.4296831911309433`*^9}, {
   3.429683287085874*^9, 3.4296832971267767`*^9}, {3.4892062190343227`*^9, 
   3.489206223766594*^9}, {3.4892299843746223`*^9, 3.4892299882398434`*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"b610b8d5-754c-404a-ba0e-19b949d66c67"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kTtblPrint", "=", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"kTtbl", "[", 
      RowBox[{"[", "ii", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", 
       RowBox[{
        RowBox[{"Dimensions", "[", "kTtbl", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "}"}]}], "]"}], "//", 
   "N"}]}]], "Input",
 CellChangeTimes->{{3.489725245802123*^9, 3.4897253404455366`*^9}, {
  3.4897276395420375`*^9, 3.48972763976405*^9}, {3.489834333618137*^9, 
  3.489834334466222*^9}, {3.489834371326907*^9, 3.4898343738401585`*^9}, {
  3.4898345787016425`*^9, 3.48983457897567*^9}, {3.489834617632535*^9, 
  3.4898346417279444`*^9}, {3.4898346825903263`*^9, 3.4898346826733265`*^9}, {
  3.4898347136743264`*^9, 3.4898347177153263`*^9}, {3.489894330919961*^9, 
  3.489894388788271*^9}},
 CellLabel->
  "In[102]:=",ExpressionUUID->"a9a98d20-ff5c-4481-99b5-5fc95010c787"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.3`", ",", "0.35`", ",", "0.4`", ",", "0.45`", ",", "0.5`", ",", "0.55`", 
   ",", "0.6`", ",", "0.65`", ",", "0.7`", ",", "0.75`", ",", "0.8`", ",", 
   "0.85`", ",", "0.9`", ",", "0.95`", ",", "1.`"}], "}"}]], "Output",
 CellChangeTimes->{3.940388941498188*^9},
 CellLabel->
  "Out[102]=",ExpressionUUID->"0c417e56-e192-4444-a11a-18280f675cd7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"kTtblPrint", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.6", ",", "0.8", ",", "1.0", ",", "2.0", ",", "5.0", ",", "10.0"}], 
    "}"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.489727674362029*^9, 3.489727704304742*^9}, {
  3.489834631635936*^9, 3.489834633654137*^9}},
 CellLabel->
  "In[103]:=",ExpressionUUID->"5c11e795-cdbd-4ad0-8025-df976cd91427"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kTtblPrintNum", "=", 
  RowBox[{
   RowBox[{"Dimensions", "[", "kTtblPrint", "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4897260017033587`*^9, 3.4897260221015253`*^9}},
 CellLabel->
  "In[104]:=",ExpressionUUID->"269df7e5-188e-4d8b-8c8b-88c17106f9d9"],

Cell[BoxData["15"], "Output",
 CellChangeTimes->{3.9403889415218086`*^9},
 CellLabel->
  "Out[104]=",ExpressionUUID->"51e8fcae-6677-6e45-a028-d16da12fa0c9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"trunc", "=", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"#", "<", "0.01"}], ",", "\"\<0.00\>\"", ",", 
     RowBox[{"ToString", "[", 
      RowBox[{"PaddedForm", "[", 
       RowBox[{
        RowBox[{"N", "[", "#", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2"}], "}"}]}], "]"}], "]"}]}], "]"}], 
   "&"}]}]], "Input",
 CellChangeTimes->{{3.4897256417047677`*^9, 3.4897257195022173`*^9}, {
  3.4897273328984985`*^9, 3.4897273460912533`*^9}, {3.4897274211925488`*^9, 
  3.489727464615032*^9}},
 CellLabel->
  "In[105]:=",ExpressionUUID->"60654657-3182-401c-a386-98fd12af3046"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"#1", "<", "0.01`"}], ",", "\<\"0.00\"\>", ",", 
    RowBox[{"ToString", "[", 
     TagBox[
      RowBox[{"N", "[", 
       RowBox[{"Slot", "[", 
        InterpretationBox[
         StyleBox["\<\"   1\"\>",
          ShowStringCharacters->False],
         1,
         Editable->False], "]"}], "]"}],
      PaddedForm[#, {3, 2}]& ], "]"}]}], "]"}], "&"}]], "Output",
 CellChangeTimes->{3.940388941526806*^9},
 CellLabel->
  "Out[105]=",ExpressionUUID->"96493d81-998c-304e-b1ff-79514aa69784"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"trunc", "[", 
  RowBox[{"10", "^", 
   RowBox[{"-", "3"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.48972570574343*^9, 3.489725712423813*^9}, {
  3.4897273891067133`*^9, 3.4897273895647397`*^9}, {3.489727432449192*^9, 
  3.489727432874217*^9}},
 CellLabel->
  "In[106]:=",ExpressionUUID->"ad100360-6b75-46f1-a1e7-ada87b575ec5"],

Cell[BoxData["\<\"0.00\"\>"], "Output",
 CellChangeTimes->{3.9403889415308075`*^9},
 CellLabel->
  "Out[106]=",ExpressionUUID->"0f660b3f-c842-2f4a-80d8-bff184e64b8f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"GkTinterp", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "[", "0.6", "]"}], ",", "4"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4897256017384815`*^9, 3.4897256390946183`*^9}},
 CellLabel->
  "In[107]:=",ExpressionUUID->"cc2e1e5c-1ead-4c77-804b-50bd518f3e77"],

Cell[BoxData["3.8475421878884984`*^-15"], "Output",
 CellChangeTimes->{3.9403889415532665`*^9},
 CellLabel->
  "Out[107]=",ExpressionUUID->"195003d8-1c8e-0e40-8e6b-7da1584a49b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"[", "ii", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"kT", ",", "tempMIN", ",", "tempMAX"}], "}"}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", "\"\<Partition function\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4898351937323265`*^9, 3.4898352023513265`*^9}, {
  3.4898352570183263`*^9, 3.4898352576563263`*^9}, {3.5536751650831537`*^9, 
  3.5536751759557753`*^9}},
 CellLabel->
  "In[108]:=",ExpressionUUID->"9a3cee2b-e1cf-483a-a522-2b3250be2857"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/ZOty8nY+LI9AwQ4uCl+sDq0GMGfZB1mHChyBc6/
uP37ijiOq3D+dh2JG/ZvEPyZWzTXrzh9Dc5XbBHgZtx3Hc4P8ClT0F1wA85X
jdm4y2PqTTj/W93dP69bb8H5ebM6fiSl3Ybze/5yVJ6MvAPnB0ZybGa2vQvn
C5/4MeWo9D04v6pu3+8y3vtwfqcus8yfdwi+/KS+hB2FD+D872Ii7dteIvhK
EpFd8yIfwvkKezkC/l1C8IvulX9yd3kE509fHBjOuR/Bt/qkPKHP/DGcb7B3
69K/yxH8n9qbap8oPoHzxcTzjLZORvA3divt9mR+inDvEke2sBoE/6GFgp7P
WwS/tDBTYlf6Mzi/3Xj1tdf3Efy3hWsK2QOew/lqIRLnZ51E8DdvcuaUsH4B
5++blS4euQrBn6P27bmg8ks4/6yey9QtkxH8i7f+sJznfQXnazKXBl6uR/D/
b3laOPs9gr+C62DI7YzXcP6SO9EirLcQ/OKgxGnLQt7A+QcC499wn0XwE8/K
yEfbvoXzr75xEVHajuDP6dB5dknjHSK81vL0uM9A8H+WhX8xFnwP56fuSbTk
akLwHTVvS7AeRPBlp4X8+P8fwQcAnMPeyQ==
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ], 
       TagBox[
        {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/ZOty8nY+LI9AwQ4uCl+sDq0GMGfZB1mHChyBc6/
uP37ijiOq3D+dh2JG/ZvEPyZWzTXrzh9Dc5XbBHgZtx3Hc4P8ClT0F1wA85X
jdm4y2PqTTj/W93dP69bb8H5ebM6fiSl3Ybze/5yVJ6MvAPnB0ZybGa2vQvn
C5/4MeWo9D04v6pu3+8y3vtwfqcus8yfdwi+/KS+hB2FD+D872Ii7dteIvhK
EpFd8yIfwvkKezkC/l1C8IvulX9yd3kE509fHBjOuR/Bt/qkPKHP/DGcb7B3
69K/yxH8n9qbap8oPoHzxcTzjLZORvA3divt9mR+inDvEke2sBoE/6GFgp7P
WwS/tDBTYlf6Mzi/3Xj1tdf3Efy3hWsK2QOew/lqIRLnZ51E8DdvcuaUsH4B
5++blS4euQrBn6P27bmg8ks4/6yey9QtkxH8i7f+sJznfQXnazKXBl6uR/D/
b3laOPs9gr+C62DI7YzXcP6SO9EirLcQ/OKgxGnLQt7A+QcC499wn0XwE8/K
yEfbvoXzr75xEVHajuDP6dB5dknjHSK81vL0uM9A8H+WhX8xFnwP56fuSbTk
akLwHTVvS7AeRPBlp4X8+P8fwQcAnMPeyQ==
          "]]},
        Annotation[#, "Charting`Private`Tag#2"]& ], 
       TagBox[
        {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJxF0n9MzHEYB/Cru6vr0lRu3U3hrsbEaa1jSqtH3CS/1lWyk1GdpK1wrPxY
MmSStFuU5MdQTqNm+nWJjhpWaClFdaGuu+t+n2FdiMPn8933nu3Zs9d/z957
89L3J2S4UiiUjf/2//3hVrxGIHgHFDRfYB3vy6rOaqfLIpMFItYA6T6FvXYn
Y5C0gs8ZArPTV5qCH9S+fk+aV+jt6aL8QDp+Ux532c0h0gt3PGxbXz5Meqrg
44zpzAjpfVVF0+l7VKRLfjOOdotHSYvEjEZq1EfSc7qmL73w/0T6WIHyV57X
Z9LnllEDZqxOLygrTW2VjpG2+7HOthicDuSIi2+Ix8GF8C1jaM6WCqe57Yz4
P/3jQCXcvXk1r9pTDXTCBz8d/horVAODMK1DU1N7Ug1MwperRds8nqrBi7D+
Vdu3jb/UMJvwqq9BstKVE8Ai3PzBPPfl/glYTji0vfnO77sTkEj4x9KG4xqe
BioJF/G8h95s18Ajwn7sfWHNFzUwTHi3qCvvxGsNTBN+eD7wcRxVCzxX4h92
w1gvaCGLSuRVE+OWnK+FBhr2eDg3ZJNFC2x37KWDwqDTS3QgYWDnSrM4bZk6
UHlgFyQU2/urdTDmi31WcP+96bMONP7YFmmd1D1+Elr42ExJOrevZBIGV2Av
SuL0VnVPwvdo7GxqSLbYVQ8+cdiNDWs9OJF6CDqC3SrfKms9qIdYObayKpMt
vqeH7AHsa4umJn2CDCALd0FuWnI9WpJigNhM7J4QYXnTRQM4yrF7C7k9HW8N
wM9yRe4bmaH1ehnh1GYqcjA1V/TuhBGsdhoya0d9mkJhBHsXHdnRpJVetRnB
ccUNeWBXoiSSb4In+e7ItcyOJNVeE7DKmMjyQ6XLD9wygb3FC7lmNIVFHzGB
SuWNfCghrUKeZAZRHRt5bkJqzLDMDHKaP/Iz0S6zZ48ZGBnzkWWzlWcEdAt0
1i9GTusJWJASZYH8qTDkQbOQFaiwQN/aOJxfW/jxnzYLWOoScV5FfF3/Yisw
/HYiR18NiLiQagXlhr24D/WzSmIrrSChFSLn+IY9ax+wwrHEGtzPvG3fBT42
KLv9HDnjSVoE85QNiqwUl/+OCVZx6B02mFcRiDyvImna4bBBY5QQ+S9LErmn

          "]]},
        Annotation[#, "Charting`Private`Tag#3"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/ZOty8nY+LI9AwQ4uCl+sDq0GMGfZB1mHChyBc6/
uP37ijiOq3D+dh2JG/ZvEPyZWzTXrzh9Dc5XbBHgZtx3Hc4P8ClT0F1wA85X
jdm4y2PqTTj/W93dP69bb8H5ebM6fiSl3Ybze/5yVJ6MvAPnB0ZybGa2vQvn
C5/4MeWo9D04v6pu3+8y3vtwfqcus8yfdwi+/KS+hB2FD+D872Ii7dteIvhK
EpFd8yIfwvkKezkC/l1C8IvulX9yd3kE509fHBjOuR/Bt/qkPKHP/DGcb7B3
69K/yxH8n9qbap8oPoHzxcTzjLZORvA3divt9mR+inDvEke2sBoE/6GFgp7P
WwS/tDBTYlf6Mzi/3Xj1tdf3Efy3hWsK2QOew/lqIRLnZ51E8DdvcuaUsH4B
5++blS4euQrBn6P27bmg8ks4/6yey9QtkxH8i7f+sJznfQXnazKXBl6uR/D/
b3laOPs9gr+C62DI7YzXcP6SO9EirLcQ/OKgxGnLQt7A+QcC499wn0XwE8/K
yEfbvoXzr75xEVHajuDP6dB5dknjHSK81vL0uM9A8H+WhX8xFnwP56fuSbTk
akLwHTVvS7AeRPBlp4X8+P8fwQcAnMPeyQ==
              "]]}, "Charting`Private`Tag#1"], 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.880722, 0.611041, 0.142051], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/ZOty8nY+LI9AwQ4uCl+sDq0GMGfZB1mHChyBc6/
uP37ijiOq3D+dh2JG/ZvEPyZWzTXrzh9Dc5XbBHgZtx3Hc4P8ClT0F1wA85X
jdm4y2PqTTj/W93dP69bb8H5ebM6fiSl3Ybze/5yVJ6MvAPnB0ZybGa2vQvn
C5/4MeWo9D04v6pu3+8y3vtwfqcus8yfdwi+/KS+hB2FD+D872Ii7dteIvhK
EpFd8yIfwvkKezkC/l1C8IvulX9yd3kE509fHBjOuR/Bt/qkPKHP/DGcb7B3
69K/yxH8n9qbap8oPoHzxcTzjLZORvA3divt9mR+inDvEke2sBoE/6GFgp7P
WwS/tDBTYlf6Mzi/3Xj1tdf3Efy3hWsK2QOew/lqIRLnZ51E8DdvcuaUsH4B
5++blS4euQrBn6P27bmg8ks4/6yey9QtkxH8i7f+sJznfQXnazKXBl6uR/D/
b3laOPs9gr+C62DI7YzXcP6SO9EirLcQ/OKgxGnLQt7A+QcC499wn0XwE8/K
yEfbvoXzr75xEVHajuDP6dB5dknjHSK81vL0uM9A8H+WhX8xFnwP56fuSbTk
akLwHTVvS7AeRPBlp4X8+P8fwQcAnMPeyQ==
              "]]}, "Charting`Private`Tag#2"], 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.560181, 0.691569, 0.194885], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJxF0n9MzHEYB/Cru6vr0lRu3U3hrsbEaa1jSqtH3CS/1lWyk1GdpK1wrPxY
MmSStFuU5MdQTqNm+nWJjhpWaClFdaGuu+t+n2FdiMPn8933nu3Zs9d/z957
89L3J2S4UiiUjf/2//3hVrxGIHgHFDRfYB3vy6rOaqfLIpMFItYA6T6FvXYn
Y5C0gs8ZArPTV5qCH9S+fk+aV+jt6aL8QDp+Ux532c0h0gt3PGxbXz5Meqrg
44zpzAjpfVVF0+l7VKRLfjOOdotHSYvEjEZq1EfSc7qmL73w/0T6WIHyV57X
Z9LnllEDZqxOLygrTW2VjpG2+7HOthicDuSIi2+Ix8GF8C1jaM6WCqe57Yz4
P/3jQCXcvXk1r9pTDXTCBz8d/horVAODMK1DU1N7Ug1MwperRds8nqrBi7D+
Vdu3jb/UMJvwqq9BstKVE8Ai3PzBPPfl/glYTji0vfnO77sTkEj4x9KG4xqe
BioJF/G8h95s18Ajwn7sfWHNFzUwTHi3qCvvxGsNTBN+eD7wcRxVCzxX4h92
w1gvaCGLSuRVE+OWnK+FBhr2eDg3ZJNFC2x37KWDwqDTS3QgYWDnSrM4bZk6
UHlgFyQU2/urdTDmi31WcP+96bMONP7YFmmd1D1+Elr42ExJOrevZBIGV2Av
SuL0VnVPwvdo7GxqSLbYVQ8+cdiNDWs9OJF6CDqC3SrfKms9qIdYObayKpMt
vqeH7AHsa4umJn2CDCALd0FuWnI9WpJigNhM7J4QYXnTRQM4yrF7C7k9HW8N
wM9yRe4bmaH1ehnh1GYqcjA1V/TuhBGsdhoya0d9mkJhBHsXHdnRpJVetRnB
ccUNeWBXoiSSb4In+e7ItcyOJNVeE7DKmMjyQ6XLD9wygb3FC7lmNIVFHzGB
SuWNfCghrUKeZAZRHRt5bkJqzLDMDHKaP/Iz0S6zZ48ZGBnzkWWzlWcEdAt0
1i9GTusJWJASZYH8qTDkQbOQFaiwQN/aOJxfW/jxnzYLWOoScV5FfF3/Yisw
/HYiR18NiLiQagXlhr24D/WzSmIrrSChFSLn+IY9ax+wwrHEGtzPvG3fBT42
KLv9HDnjSVoE85QNiqwUl/+OCVZx6B02mFcRiDyvImna4bBBY5QQ+S9LErmn

              "]]}, "Charting`Private`Tag#3"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|"PanelPlotLayout" -> <||>, "PlotRange" -> {{
              Rational[3, 10], 1}, {1., 2.}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0.30000000000000066`, 1.0000000000000022`}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.560181, 0.691569, 0.194885], 
              AbsoluteThickness[2]], 
             Directive[
              Opacity[1.], 
              RGBColor[0.880722, 0.611041, 0.142051], 
              AbsoluteThickness[2]], 
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|"PanelPlotLayout" -> <||>, "PlotRange" -> {{
             Rational[3, 10], 1}, {1., 2.}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0.30000000000000066`, 1.0000000000000022`}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.560181, 0.691569, 0.194885], 
             AbsoluteThickness[2]], 
            Directive[
             Opacity[1.], 
             RGBColor[0.880722, 0.611041, 0.142051], 
             AbsoluteThickness[2]], 
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/ZOty8nY+LI9AwQ4uCl+sDq0GMGfZB1mHChyBc6/
uP37ijiOq3D+dh2JG/ZvEPyZWzTXrzh9Dc5XbBHgZtx3Hc4P8ClT0F1wA85X
jdm4y2PqTTj/W93dP69bb8H5ebM6fiSl3Ybze/5yVJ6MvAPnB0ZybGa2vQvn
C5/4MeWo9D04v6pu3+8y3vtwfqcus8yfdwi+/KS+hB2FD+D872Ii7dteIvhK
EpFd8yIfwvkKezkC/l1C8IvulX9yd3kE509fHBjOuR/Bt/qkPKHP/DGcb7B3
69K/yxH8n9qbap8oPoHzxcTzjLZORvA3divt9mR+inDvEke2sBoE/6GFgp7P
WwS/tDBTYlf6Mzi/3Xj1tdf3Efy3hWsK2QOew/lqIRLnZ51E8DdvcuaUsH4B
5++blS4euQrBn6P27bmg8ks4/6yey9QtkxH8i7f+sJznfQXnazKXBl6uR/D/
b3laOPs9gr+C62DI7YzXcP6SO9EirLcQ/OKgxGnLQt7A+QcC499wn0XwE8/K
yEfbvoXzr75xEVHajuDP6dB5dknjHSK81vL0uM9A8H+WhX8xFnwP56fuSbTk
akLwHTVvS7AeRPBlp4X8+P8fwQcAnMPeyQ==
          "]]}, "Charting`Private`Tag#1"], 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/ZOty8nY+LI9AwQ4uCl+sDq0GMGfZB1mHChyBc6/
uP37ijiOq3D+dh2JG/ZvEPyZWzTXrzh9Dc5XbBHgZtx3Hc4P8ClT0F1wA85X
jdm4y2PqTTj/W93dP69bb8H5ebM6fiSl3Ybze/5yVJ6MvAPnB0ZybGa2vQvn
C5/4MeWo9D04v6pu3+8y3vtwfqcus8yfdwi+/KS+hB2FD+D872Ii7dteIvhK
EpFd8yIfwvkKezkC/l1C8IvulX9yd3kE509fHBjOuR/Bt/qkPKHP/DGcb7B3
69K/yxH8n9qbap8oPoHzxcTzjLZORvA3divt9mR+inDvEke2sBoE/6GFgp7P
WwS/tDBTYlf6Mzi/3Xj1tdf3Efy3hWsK2QOew/lqIRLnZ51E8DdvcuaUsH4B
5++blS4euQrBn6P27bmg8ks4/6yey9QtkxH8i7f+sJznfQXnazKXBl6uR/D/
b3laOPs9gr+C62DI7YzXcP6SO9EirLcQ/OKgxGnLQt7A+QcC499wn0XwE8/K
yEfbvoXzr75xEVHajuDP6dB5dknjHSK81vL0uM9A8H+WhX8xFnwP56fuSbTk
akLwHTVvS7AeRPBlp4X8+P8fwQcAnMPeyQ==
          "]]}, "Charting`Private`Tag#2"], 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.560181, 0.691569, 0.194885], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJxF0n9MzHEYB/Cru6vr0lRu3U3hrsbEaa1jSqtH3CS/1lWyk1GdpK1wrPxY
MmSStFuU5MdQTqNm+nWJjhpWaClFdaGuu+t+n2FdiMPn8933nu3Zs9d/z957
89L3J2S4UiiUjf/2//3hVrxGIHgHFDRfYB3vy6rOaqfLIpMFItYA6T6FvXYn
Y5C0gs8ZArPTV5qCH9S+fk+aV+jt6aL8QDp+Ux532c0h0gt3PGxbXz5Meqrg
44zpzAjpfVVF0+l7VKRLfjOOdotHSYvEjEZq1EfSc7qmL73w/0T6WIHyV57X
Z9LnllEDZqxOLygrTW2VjpG2+7HOthicDuSIi2+Ix8GF8C1jaM6WCqe57Yz4
P/3jQCXcvXk1r9pTDXTCBz8d/horVAODMK1DU1N7Ug1MwperRds8nqrBi7D+
Vdu3jb/UMJvwqq9BstKVE8Ai3PzBPPfl/glYTji0vfnO77sTkEj4x9KG4xqe
BioJF/G8h95s18Ajwn7sfWHNFzUwTHi3qCvvxGsNTBN+eD7wcRxVCzxX4h92
w1gvaCGLSuRVE+OWnK+FBhr2eDg3ZJNFC2x37KWDwqDTS3QgYWDnSrM4bZk6
UHlgFyQU2/urdTDmi31WcP+96bMONP7YFmmd1D1+Elr42ExJOrevZBIGV2Av
SuL0VnVPwvdo7GxqSLbYVQ8+cdiNDWs9OJF6CDqC3SrfKms9qIdYObayKpMt
vqeH7AHsa4umJn2CDCALd0FuWnI9WpJigNhM7J4QYXnTRQM4yrF7C7k9HW8N
wM9yRe4bmaH1ehnh1GYqcjA1V/TuhBGsdhoya0d9mkJhBHsXHdnRpJVetRnB
ccUNeWBXoiSSb4In+e7ItcyOJNVeE7DKmMjyQ6XLD9wygb3FC7lmNIVFHzGB
SuWNfCghrUKeZAZRHRt5bkJqzLDMDHKaP/Iz0S6zZ48ZGBnzkWWzlWcEdAt0
1i9GTusJWJASZYH8qTDkQbOQFaiwQN/aOJxfW/jxnzYLWOoScV5FfF3/Yisw
/HYiR18NiLiQagXlhr24D/WzSmIrrSChFSLn+IY9ax+wwrHEGtzPvG3fBT42
KLv9HDnjSVoE85QNiqwUl/+OCVZx6B02mFcRiDyvImna4bBBY5QQ+S9LErmn

          "]]}, "Charting`Private`Tag#3"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|"PanelPlotLayout" -> <||>, "PlotRange" -> {{
          Rational[3, 10], 1}, {1., 2.}}, 
       "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {0.30000000000000066`, 1.0000000000000022`}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.560181, 0.691569, 0.194885], 
          AbsoluteThickness[2]], 
         Directive[
          Opacity[1.], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[2]], 
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0.30000000000000066`, 1.0000000000000022`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotLabel->FormBox["\"Partition function\"", TraditionalForm],
  PlotRange->NCache[{{
      Rational[3, 10], 1}, {1., 2.}}, {{0.3, 1}, {1., 2.}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.9403889416255016`*^9},
 CellLabel->
  "Out[108]=",ExpressionUUID->"5db50ee0-212c-d341-a5bb-a4c69fed3d58"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"A", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"tbl", "[", 
     RowBox[{"[", 
      RowBox[{"i", ",", "5"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "niso"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4031705328771276`*^9, 3.40317054494448*^9}, {
   3.4031717147866306`*^9, 3.4031717347954016`*^9}, 3.412423557921875*^9, {
   3.412740468690016*^9, 3.412740469827417*^9}, {3.420449947734375*^9, 
   3.420449959203125*^9}, {3.489207992584764*^9, 3.489208007237602*^9}, {
   3.4892303011977434`*^9, 3.4892303114593306`*^9}, {3.489389414601798*^9, 
   3.4893894154908485`*^9}},
 CellLabel->
  "In[109]:=",ExpressionUUID->"52853832-38b5-4a97-8877-8cf82d10793b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{3.940388941653681*^9},
 CellLabel->
  "Out[109]=",ExpressionUUID->"934b3e77-5ae2-9845-8861-f4235fab7dfd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Z", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"tbl", "[", 
     RowBox[{"[", 
      RowBox[{"i", ",", "3"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "niso"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4031705507027597`*^9, 3.4031705545282607`*^9}, {
   3.403171737859808*^9, 3.403171745140277*^9}, 3.412423562640625*^9, {
   3.412740482956698*^9, 3.4127404845897923`*^9}, 3.4892080037684035`*^9, {
   3.489230314717517*^9, 3.489230316607625*^9}, {3.4893894170599384`*^9, 
   3.489389417948989*^9}},
 CellLabel->
  "In[110]:=",ExpressionUUID->"cecd6ba1-75da-4ef8-a120-4bc73134910f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.940388941677662*^9},
 CellLabel->
  "Out[110]=",ExpressionUUID->"230fafb2-cce8-834f-aaae-f947f02012ba"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ne", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"tbl", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", "4"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "niso"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4031705581234303`*^9, 3.4031705734554768`*^9}, {
   3.4031717519100113`*^9, 3.403171758108925*^9}, 3.4124235669375*^9, {
   3.412740486857237*^9, 3.412740488142302*^9}, 3.4892077970795817`*^9, 
   3.489208129889618*^9, {3.4892303191147685`*^9, 3.4892303236120257`*^9}, {
   3.489389420255121*^9, 3.489389422576254*^9}},
 CellLabel->
  "In[111]:=",ExpressionUUID->"31d24fc9-c508-4669-8242-1c92ea190195"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q", "=", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"tbl", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "1"}], "]"}], "]"}], "*", 
       RowBox[{"tbl", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "5"}], "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "niso"}], "}"}]}], "]"}], " ", "//", 
    "Chop"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4031706509168606`*^9, 3.403170656775285*^9}, {
   3.403171766150488*^9, 3.4031717720689983`*^9}, {3.4031934120361953`*^9, 
   3.4031934272280397`*^9}, {3.403239793635419*^9, 3.403239795007392*^9}, 
   3.412423574171875*^9, 3.412434757046875*^9, 3.412533782578125*^9, {
   3.412740490893846*^9, 3.412740493139194*^9}, {3.4892303270682235`*^9, 
   3.4892303349946766`*^9}, {3.4893894270275087`*^9, 3.4893894349609623`*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"53e641d9-0458-4d68-9261-f0b65784bde5"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/A.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"N", "[", "A", "]"}], "]"}], "<>", "\"\<\\n\\n\>\""}], ",", 
   "\"\<Text\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/Z.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"N", "[", "Z", "]"}], "]"}], "<>", "\"\<\\n\\n\>\""}], ",", 
   "\"\<Text\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/N.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"N", "[", "Ne", "]"}], "]"}], "<>", "\"\<\\n\\n\>\""}], ",", 
   "\"\<Text\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/Q.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"N", "[", "Q", "]"}], "]"}], "<>", "\"\<\\n\\n\>\""}], ",", 
   "\"\<Text\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/G0.dat\>\"", ",", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"N", "[", "G0", "]"}], "]"}], "<>", "\"\<\\n\\n\>\""}], ",", 
   "\"\<Text\>\""}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.420089824126528*^9, 3.4200898453047047`*^9}, {
   3.420090159256853*^9, 3.420090162285914*^9}, {3.42009020452654*^9, 
   3.420090205237154*^9}, {3.42068694671875*^9, 3.4206869659375*^9}, {
   3.420687007734375*^9, 3.420687025640625*^9}, 3.420687065359375*^9, {
   3.42068710890625*^9, 3.420687112125*^9}, {3.4206872190625*^9, 
   3.420687220484375*^9}, {3.420687274453125*^9, 3.420687283328125*^9}, {
   3.420687346875*^9, 3.42068736375*^9}, {3.420687441359375*^9, 
   3.420687452375*^9}, {3.420695140740995*^9, 3.420695165884004*^9}, {
   3.422452331921875*^9, 3.422452335703125*^9}, {3.4276131205415907`*^9, 
   3.4276131229485283`*^9}, {3.4296823713706827`*^9, 3.4296823824686823`*^9}, 
   3.429721788625*^9},
 CellLabel->
  "In[113]:=",ExpressionUUID->"b10b0198-91a7-4908-9acd-02be13faa124"],

Cell[BoxData["\<\"data/A.dat\"\>"], "Output",
 CellChangeTimes->{3.940388941704529*^9},
 CellLabel->
  "Out[113]=",ExpressionUUID->"1d02922f-1b1d-1840-95da-11d2b9b5096a"],

Cell[BoxData["\<\"data/Z.dat\"\>"], "Output",
 CellChangeTimes->{3.9403889417144527`*^9},
 CellLabel->
  "Out[114]=",ExpressionUUID->"e45e38c7-6c4f-2044-878c-7d63c073bd06"],

Cell[BoxData["\<\"data/N.dat\"\>"], "Output",
 CellChangeTimes->{3.9403889417176895`*^9},
 CellLabel->
  "Out[115]=",ExpressionUUID->"76cb72e6-032d-c54a-8737-c45a29dc96bd"],

Cell[BoxData["\<\"data/Q.dat\"\>"], "Output",
 CellChangeTimes->{3.94038894172176*^9},
 CellLabel->
  "Out[116]=",ExpressionUUID->"e52dfa69-294c-1e4f-9767-d1ec16fc86ac"],

Cell[BoxData["\<\"data/G0.dat\"\>"], "Output",
 CellChangeTimes->{3.940388941723881*^9},
 CellLabel->
  "Out[117]=",ExpressionUUID->"ee9d213e-69ab-2145-bc5e-62cda912c794"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<data/GkT.dat\>\"", ",", 
   RowBox[{"GkTstring", "<>", "\"\<\\n\\n\>\""}], ",", "\"\<Text\>\""}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.429681754929573*^9, 3.4296817721089153`*^9}, {
  3.429684181875979*^9, 3.429684184717842*^9}, {3.4892323624936433`*^9, 
  3.4892323635647044`*^9}},
 CellLabel->
  "In[118]:=",ExpressionUUID->"21f0dbb9-094d-461f-896c-d2c2e9815ea0"],

Cell[BoxData["\<\"data/GkT.dat\"\>"], "Output",
 CellChangeTimes->{3.9403889417450027`*^9},
 CellLabel->
  "Out[118]=",ExpressionUUID->"148566dd-4147-364d-9baa-36fd5ad8be92"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"qe", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{
     RowBox[{"1.6021892", "*", 
      RowBox[{"10", "^", 
       RowBox[{"(", 
        RowBox[{"-", "19"}], ")"}]}]}], ",", "myPrecision"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"h", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{
     RowBox[{"6.626176", " ", 
      RowBox[{"10", "^", 
       RowBox[{"(", 
        RowBox[{"-", "34"}], ")"}]}]}], ",", "myPrecision"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{
     RowBox[{"1.380662", " ", 
      RowBox[{"10", "^", 
       RowBox[{"(", 
        RowBox[{"-", "23"}], ")"}]}]}], ",", "myPrecision"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mp", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{
     RowBox[{"1.672", "  ", 
      RowBox[{"10", "^", 
       RowBox[{"(", 
        RowBox[{"-", "27"}], ")"}]}]}], ",", "myPrecision"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.4031889676755185`*^9, 3.4031889761176577`*^9}, {
   3.403189052287184*^9, 3.403189054109805*^9}, {3.403189268718397*^9, 
   3.4031892801147842`*^9}, {3.412740845280095*^9, 3.412740847680279*^9}, 
   3.412740892960257*^9, {3.412741071805765*^9, 3.412741072583486*^9}, {
   3.412741166795598*^9, 3.41274116756287*^9}, 3.419913286515625*^9, {
   3.420089070547717*^9, 3.420089071977702*^9}, {3.4892078090722675`*^9, 
   3.489207835880801*^9}, {3.489288561336379*^9, 3.4892885739531007`*^9}, {
   3.489288609770149*^9, 3.4892886481513443`*^9}, {3.4893887507008247`*^9, 
   3.4893887520219*^9}, {3.4893899169545307`*^9, 3.489389917362554*^9}},
 CellLabel->
  "In[119]:=",ExpressionUUID->"af11f8f5-aeba-4c9c-962f-71782682b8c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "=", 
  RowBox[{"kT", " ", 
   RowBox[{"10", "^", "6"}], " ", 
   RowBox[{"qe", " ", "/", "k"}]}]}]], "Input",
 CellChangeTimes->{{3.4031893017559023`*^9, 3.403189416681157*^9}, {
  3.4126876512921247`*^9, 3.412687653586686*^9}, {3.412740978269887*^9, 
  3.412740984928582*^9}},
 CellLabel->
  "In[123]:=",ExpressionUUID->"a2ce1441-854b-4f27-a388-8652522936f4"],

Cell[BoxData[
 RowBox[{"1.\
160449987035204718794195164022325201100244573483992639009586342074788297220681\
2556863658766468918429170039`95.69897000433602*^10", " ", "kT"}]], "Output",
 CellChangeTimes->{3.940388941766178*^9},
 CellLabel->
  "Out[123]=",ExpressionUUID->"c2c6a60d-ee99-8547-bf91-7abc003e2a45"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Precision", "[", "T", "]"}]], "Input",
 CellChangeTimes->{{3.4127411836891813`*^9, 3.4127411865190573`*^9}},
 CellLabel->
  "In[124]:=",ExpressionUUID->"ef4e35a3-ff55-4c1e-987e-6f90ba3c111e"],

Cell[BoxData["95.69897000433602`"], "Output",
 CellChangeTimes->{3.940388941793947*^9},
 CellLabel->
  "Out[124]=",ExpressionUUID->"f091b302-2c52-e042-8f21-7bf95d39005f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"thermal", " ", "de", " ", "Broglie", " ", "wavelength"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.412676907046875*^9, 3.412676920140625*^9}},
 CellLabel->
  "In[125]:=",ExpressionUUID->"6af85109-d19d-46be-84a9-434cc0b458bc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Lambda]", "=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    RowBox[{"h", "^", "2"}], "/", 
    RowBox[{"(", 
     RowBox[{"2", " ", "Pi", " ", "mp", " ", "k", " ", "T"}], ")"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.40318893276532*^9, 3.403188959153264*^9}, 
   3.4031892995527344`*^9},
 CellLabel->
  "In[126]:=",ExpressionUUID->"cc8f9808-bf0b-49c9-a657-61f0a96112d6"],

Cell[BoxData[
 RowBox[{"1.\
615094716584860569639840561985421087548028967240966745403786616753101045590910\
7394516490255625522377433340668207087247614`95.52287874528035*^-14", " ", 
  SqrtBox[
   FractionBox["1", "kT"]]}]], "Output",
 CellChangeTimes->{3.9403889418236656`*^9},
 CellLabel->
  "Out[126]=",ExpressionUUID->"fd93f521-195c-a64d-b385-3f6c4ce19d43"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"abundance", " ", "table"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.41267693128125*^9, 3.412676943234375*^9}},
 CellLabel->
  "In[127]:=",ExpressionUUID->"24b66ac9-7982-4353-86c5-f29fda748d91"],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "/", "2"}], ")"}], "*", 
      RowBox[{"G", "[", 
       RowBox[{"[", "k", "]"}], "]"}], "*", "\n", "     ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1000", 
         RowBox[{"\[Rho]", "/", 
          RowBox[{"(", 
           RowBox[{"2", "*", "mp"}], ")"}]}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"A", "[", 
          RowBox[{"[", "k", "]"}], "]"}], " ", "-", " ", "1"}], ")"}]}], "*", 
      "\n", "     ", 
      RowBox[{"\[Lambda]", "^", 
       RowBox[{"(", 
        RowBox[{"3", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"A", "[", 
            RowBox[{"[", "k", "]"}], "]"}], " ", "-", " ", "1"}], ")"}]}], 
        ")"}]}], "*", "\n", "     ", 
      RowBox[{
       RowBox[{"A", "[", 
        RowBox[{"[", "k", "]"}], "]"}], "^", 
       RowBox[{"(", 
        RowBox[{"5", "/", "2"}], ")"}]}], "*", 
      RowBox[{"Xn", "^", 
       RowBox[{"Ne", "[", 
        RowBox[{"[", "k", "]"}], "]"}]}], "*", "\n", "     ", 
      RowBox[{"Xp", "^", 
       RowBox[{"Z", "[", 
        RowBox[{"[", "k", "]"}], "]"}]}], "*", 
      RowBox[{"E", "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Q", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "/", "kT"}], ")"}]}]}], ",", " ", 
     "\n", "    ", 
     RowBox[{"{", 
      RowBox[{"k", ",", " ", "1", ",", " ", "niso"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.4031702054463053`*^9, 3.403170207519286*^9}, {
   3.4031702663538866`*^9, 3.4031703048191967`*^9}, {3.4031704164296846`*^9, 
   3.4031705172146063`*^9}, {3.4031705866143985`*^9, 
   3.4031705891981134`*^9}, {3.403170759573101*^9, 3.4031707764273357`*^9}, {
   3.4031888498561025`*^9, 3.403188876985112*^9}, 3.403260787923683*^9, {
   3.412434131*^9, 3.412434135046875*^9}, {3.412434989828125*^9, 
   3.412434992*^9}, {3.412436472671875*^9, 3.412436501375*^9}, {
   3.412436543109375*^9, 3.412436546421875*^9}, {3.412437315265625*^9, 
   3.412437321359375*^9}, {3.4124374028125*^9, 3.41243740678125*^9}, {
   3.41244004446875*^9, 3.4124400895*^9}, {3.4124401408125*^9, 
   3.4124401859375*^9}, {3.4124402671875*^9, 3.412440279140625*^9}, {
   3.412440589875*^9, 3.41244062146875*^9}, {3.412440651890625*^9, 
   3.412440656203125*^9}, {3.41244112096875*^9, 3.412441121046875*^9}, {
   3.41244119253125*^9, 3.412441194515625*^9}, {3.412441308421875*^9, 
   3.41244131446875*^9}, {3.41244141615625*^9, 3.4124414583125*^9}, {
   3.4892062000422363`*^9, 3.4892062006552715`*^9}, 3.489210500327199*^9, {
   3.4893899224738464`*^9, 3.4893899229478736`*^9}},
 CellLabel->
  "In[128]:=",ExpressionUUID->"14b97858-2a6a-470a-8174-81d7cd4da9f8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"X", "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellLabel->
  "In[129]:=",ExpressionUUID->"3048bc88-f706-43d2-a5c0-889d04de48ad"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "Xn", " ", 
  RowBox[{"(", 
   RowBox[{"2.`96.30102999566398", "+", 
    RowBox[{
     InterpretationBox[
      RowBox[{
       TagBox["InterpolatingFunction",
        "SummaryHead"], "[", 
       DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
        "Ready"}, 
        TemplateBox[{
          PaneSelectorBox[{False -> GridBox[{{
                PaneBox[
                 ButtonBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "FEBitmaps", "SummaryBoxOpener"]], 
                  ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                  None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                  "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                 Dynamic[{
                   Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQPbvsg72x8WV7BihYsCwxXfMdgj85fFHZzR1X4PzT
CtZ/pcquwvnaqisVlulfg/MrVz3Tfv0DwefxqFl3cMt1OL837aFEUMMNON/s
gLSCjsdNOF/FaN286Uy34HwGVQHWvWcQfEWDU4+KO2/D+dllkbElTnfg/EW2
O/brcd+F8+Vk82dWHUPwO2q/RjVMvAfnS0kG7jwfcR/h/rQm9wjOB3D+HQaX
Zap5CH7S8o0HrM8g+PF87Of1jB7C+R+Ejq92m4bgL1Y2dln+GcE/+6XtwpOI
Rwj7L7VJZG9H8H/7fNQTE3kM5wd3OFvOq0Dwz553/J93DcHfd119p4zNEzjf
ubbC8f18BP+1Xmkr118En2th5F6mpKdwvrf8qw3OBxB8BeunRStlnsH5OeIn
NN40IPi3/4fNKr+H4B9ccfb/fefncP7J2A8KExch+KkbagXS/yP4FYc/fZZM
eQHnr3skPFn0EIIffUhG7Z36Szh/jv2E9tfdCD7DyfVLDF8i+LeEtm8N8XsF
51/PyGo6sAbBz4jpkA3kfA3nFwj0rdmXi+DPvmD/veQ0gm8TeNOUw/ANnF+Y
f9fpwBQE/+TMXu6DHxH8GS2qJ+aFvYXzu6ozHY5uQfA/GU1dc0LqHZz/rl37
+Yc6BJ/3Ze7dxDsI/mKuGcfXO76H82Ms8nLdFiD4PnELf/7/j+ADACIu97g=

                    "]]}, Annotation[#, "Charting`Private`Tag#1"]& ]}}, {}}, {
                 DisplayFunction -> Identity, Ticks -> {Automatic, Automatic},
                   AxesOrigin -> {0.30000000000000066`, 0}, 
                  FrameTicks -> {{{}, {}}, {{}, {}}}, 
                  GridLines -> {None, None}, DisplayFunction -> Identity, 
                  PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                  All, DisplayFunction -> Identity, AspectRatio -> 1, 
                  Axes -> {False, False}, AxesLabel -> {None, None}, 
                  AxesOrigin -> {0.3, 0}, DisplayFunction :> Identity, 
                  Frame -> {{True, True}, {True, True}}, 
                  FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                  Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                  FrameTicks -> {{None, None}, {None, None}}, 
                  GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                  Method -> {
                   "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> NCache[{{
                    Rational[3, 10], 1}, {-1., 1.}}, {{0.3, 1}, {-1., 1.}}], 
                  PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                GridBox[{{
                   RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    FractionBox["3", "10"], ",", "1"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                 BaseStyle -> {
                  ShowStringCharacters -> False, NumberMarks -> False, 
                   PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
              GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
              AutoDelete -> False, 
              GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              BaselinePosition -> {1, 1}], True -> GridBox[{{
                PaneBox[
                 ButtonBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "FEBitmaps", "SummaryBoxCloser"]], 
                  ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                  None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                  "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                 Dynamic[{
                   Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQPbvsg72x8WV7BihYsCwxXfMdgj85fFHZzR1X4PzT
CtZ/pcquwvnaqisVlulfg/MrVz3Tfv0DwefxqFl3cMt1OL837aFEUMMNON/s
gLSCjsdNOF/FaN286Uy34HwGVQHWvWcQfEWDU4+KO2/D+dllkbElTnfg/EW2
O/brcd+F8+Vk82dWHUPwO2q/RjVMvAfnS0kG7jwfcR/h/rQm9wjOB3D+HQaX
Zap5CH7S8o0HrM8g+PF87Of1jB7C+R+Ejq92m4bgL1Y2dln+GcE/+6XtwpOI
Rwj7L7VJZG9H8H/7fNQTE3kM5wd3OFvOq0Dwz553/J93DcHfd119p4zNEzjf
ubbC8f18BP+1Xmkr118En2th5F6mpKdwvrf8qw3OBxB8BeunRStlnsH5OeIn
NN40IPi3/4fNKr+H4B9ccfb/fefncP7J2A8KExch+KkbagXS/yP4FYc/fZZM
eQHnr3skPFn0EIIffUhG7Z36Szh/jv2E9tfdCD7DyfVLDF8i+LeEtm8N8XsF
51/PyGo6sAbBz4jpkA3kfA3nFwj0rdmXi+DPvmD/veQ0gm8TeNOUw/ANnF+Y
f9fpwBQE/+TMXu6DHxH8GS2qJ+aFvYXzu6ozHY5uQfA/GU1dc0LqHZz/rl37
+Yc6BJ/3Ze7dxDsI/mKuGcfXO76H82Ms8nLdFiD4PnELf/7/j+ADACIu97g=

                    "]]}, Annotation[#, "Charting`Private`Tag#1"]& ]}}, {}}, {
                 DisplayFunction -> Identity, Ticks -> {Automatic, Automatic},
                   AxesOrigin -> {0.30000000000000066`, 0}, 
                  FrameTicks -> {{{}, {}}, {{}, {}}}, 
                  GridLines -> {None, None}, DisplayFunction -> Identity, 
                  PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                  All, DisplayFunction -> Identity, AspectRatio -> 1, 
                  Axes -> {False, False}, AxesLabel -> {None, None}, 
                  AxesOrigin -> {0.3, 0}, DisplayFunction :> Identity, 
                  Frame -> {{True, True}, {True, True}}, 
                  FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                  Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                  FrameTicks -> {{None, None}, {None, None}}, 
                  GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                  Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                  Method -> {
                   "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> NCache[{{
                    Rational[3, 10], 1}, {-1., 1.}}, {{0.3, 1}, {-1., 1.}}], 
                  PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                GridBox[{{
                   RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    FractionBox["3", "10"], ",", "1"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["1", "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                 BaseStyle -> {
                  ShowStringCharacters -> False, NumberMarks -> False, 
                   PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
              GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
              AutoDelete -> False, 
              GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              BaselinePosition -> {1, 1}]}, 
           Dynamic[Typeset`open$$], ImageSize -> Automatic]},
         "SummaryPanel"],
        DynamicModuleValues:>{}], "]"}],
      InterpolatingFunction[{{
         Rational[3, 10], 1}}, {
       5, 3, 0, {15}, {2}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{
         Rational[3, 10], 
         Rational[7, 20], 
         Rational[2, 5], 
         Rational[9, 20], 
         Rational[1, 2], 
         Rational[11, 20], 
         Rational[3, 5], 
         Rational[13, 20], 
         Rational[7, 10], 
         Rational[3, 4], 
         Rational[4, 5], 
         Rational[17, 20], 
         Rational[9, 10], 
         Rational[19, 20], 1}}, {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {
       0}, {0}, {0}, {0}, {0}, {0}, {0}}, {Automatic}],
      Editable->False,
      SelectWithContents->True,
      Selectable->False], "[", "kT", "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.9403889418646717`*^9},
 CellLabel->
  "Out[129]=",ExpressionUUID->"8d68b97e-5f69-6b48-8531-8a731605b1ac"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "sum", " ", "of", " ", "the", " ", "abundances", " ", "equals", " ", "to", 
   " ", "1"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.412676949671875*^9, 3.41267696234375*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"161d34b7-ec5a-40e5-9443-4588fdf678cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"X", "[", 
       RowBox[{"[", "ii", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}], "-", "1"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.4031895012828083`*^9, 3.4031895262487073`*^9}, {
   3.4031898503647633`*^9, 3.4031898507252817`*^9}, 3.403194111782381*^9, {
   3.403196508007984*^9, 3.403196508388531*^9}, {3.4031965618153553`*^9, 
   3.403196564409085*^9}, {3.403196803252525*^9, 3.403196803312611*^9}, 
   3.403197020775307*^9, 3.403260792440178*^9, {3.412740777756969*^9, 
   3.412740778915289*^9}, {3.422153020671875*^9, 3.422153022046875*^9}, 
   3.489206258047554*^9, 3.4892105100837564`*^9},
 CellLabel->
  "In[131]:=",ExpressionUUID->"d450a635-fb76-4934-8be0-aedbcbb4de32"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"electron", " ", "fraction"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.412676974796875*^9, 3.412677001703125*^9}},
 CellLabel->
  "In[132]:=",ExpressionUUID->"1bdb74a0-0bed-44d5-b27f-030ca7a97618"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq2", "=", 
   RowBox[{
    RowBox[{"Sum", "[", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Z", "[", 
         RowBox[{"[", "ii", "]"}], "]"}], "/", 
        RowBox[{"A", "[", 
         RowBox[{"[", "ii", "]"}], "]"}]}], "*", " ", 
       RowBox[{"X", "[", 
        RowBox[{"[", "ii", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "niso"}], "}"}]}], "]"}], "-", "Ye"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.4031895334090033`*^9, 3.4031895509442177`*^9}, {
   3.4031895847027597`*^9, 3.403189657227045*^9}, {3.4031966141005373`*^9, 
   3.4031966163437634`*^9}, {3.403197131574629*^9, 3.403197131915118*^9}, 
   3.403260794302856*^9, {3.412740783179884*^9, 3.412740784439331*^9}, {
   3.422153026453125*^9, 3.422153027203125*^9}, 3.489206267820113*^9, 
   3.4892105130349255`*^9},
 CellLabel->
  "In[133]:=",ExpressionUUID->"f72fd286-a406-41f1-b0a2-54bcdf31ba69"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"eq11", " ", "=", " ", 
   RowBox[{"eq1", " ", "/.", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Xn", "\[Rule]", 
       RowBox[{"10", "^", "n"}]}], ",", 
      RowBox[{"Xp", "\[Rule]", 
       RowBox[{"10", "^", "p"}]}]}], "}"}]}]}], "  ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eq22", " ", "=", " ", 
   RowBox[{"eq2", " ", "/.", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Xn", "\[Rule]", 
       RowBox[{"10", "^", "n"}]}], ",", 
      RowBox[{"Xp", "\[Rule]", 
       RowBox[{"10", "^", "p"}]}]}], "}"}]}]}], "  ", ";"}]}], "Input",
 CellChangeTimes->{{3.403238495038128*^9, 3.403238527665043*^9}, {
  3.403239082572962*^9, 3.403239089542984*^9}, {3.4032404950540094`*^9, 
  3.4032405014632254`*^9}, {3.403241723129896*^9, 3.4032417291585646`*^9}, {
  3.403258617703059*^9, 3.403258618374024*^9}, {3.4032607967864275`*^9, 
  3.4032607980782847`*^9}},
 CellLabel->
  "In[134]:=",ExpressionUUID->"fe057f95-352e-44a8-b1f4-152417079543"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"(*", " ", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"eq11", ",", "eq22"}], "}"}], " ", "/.", " ", 
      RowBox[{"kT", "\[Rule]", "0.6"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"-", "16"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"p", ",", 
       RowBox[{"-", "16"}], ",", "0"}], "}"}], ",", 
     RowBox[{"PlotPoints", "\[Rule]", "15"}]}], "]"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.4032608677484655`*^9, 3.403260870812872*^9}, {
   3.4032609688638625`*^9, 3.403261053175096*^9}, {3.4032613850823555`*^9, 
   3.4032614149452963`*^9}, 3.4032618644816976`*^9, {3.40387150075*^9, 
   3.403871501390625*^9}, {3.4071797926875*^9, 3.4071797946875*^9}, {
   3.412434570765625*^9, 3.41243457915625*^9}, {3.412434786578125*^9, 
   3.41243479109375*^9}, {3.412434923546875*^9, 3.412434944*^9}, {
   3.412435010796875*^9, 3.412435012921875*^9}, {3.412440414609375*^9, 
   3.412440417359375*^9}},
 CellLabel->
  "In[136]:=",ExpressionUUID->"e19eb766-d1c4-4b44-8290-5183287582ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{"np", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"temp", ",", "lgdens", ",", 
       RowBox[{"{", ",", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"temp", ",", "kTtbl"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"lgdens", ",", "lgdenstbl"}], "}"}]}], "]"}]}], " ", 
  ";"}]], "Input",
 CellChangeTimes->{{3.412677290203125*^9, 3.412677317453125*^9}, {
  3.4126773895625*^9, 3.412677418203125*^9}, {3.412677457265625*^9, 
  3.41267753246875*^9}, {3.41267767421875*^9, 3.4126776756875*^9}, {
  3.4892051103699107`*^9, 3.489205123002633*^9}, {3.489230419723523*^9, 
  3.489230425238838*^9}, {3.5534428142019157`*^9, 3.553442823541305*^9}},
 CellLabel->
  "In[137]:=",ExpressionUUID->"11a5772a-001f-408b-ac0c-23c3866ce907"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", "np", "]"}]], "Input",
 CellChangeTimes->{{3.41267755090625*^9, 3.41267755765625*^9}},
 CellLabel->
  "In[138]:=",ExpressionUUID->"10800f08-d99e-4fd3-9329-8c0b76220c69"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"15", ",", "9", ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{3.9403889419007473`*^9},
 CellLabel->
  "Out[138]=",ExpressionUUID->"9492ac02-ac65-f34b-bec4-fde6c7dcf8fb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"J11", "=", 
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{"eq11", ",", "n"}], "]"}], "//", "Simplify"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.42215311821875*^9, 3.42215313946875*^9}, {
  3.422157013984375*^9, 3.422157037234375*^9}, {3.4893899671824036`*^9, 
  3.4893900129680223`*^9}, {3.5534430677332563`*^9, 3.553443105433309*^9}, {
  3.5534917434017897`*^9, 3.553491756267159*^9}, {3.5536631007501135`*^9, 
  3.55366312464648*^9}},
 CellLabel->
  "In[139]:=",ExpressionUUID->"b3ebcdbe-e53d-4254-870c-3ec724da9fa6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"J12", "=", 
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{"eq11", ",", "p"}], "]"}], "//", "Simplify"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.422153143078125*^9, 3.422153151953125*^9}, 
   3.422157039484375*^9, {3.4893900152971554`*^9, 3.4893900169122477`*^9}, {
   3.55344307229987*^9, 3.553443073451058*^9}, 3.553663133894009*^9},
 CellLabel->
  "In[140]:=",ExpressionUUID->"977f4b72-13b1-49fb-b450-ad0802e0fcda"],

Cell[BoxData[
 RowBox[{
  RowBox[{"J21", "=", 
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{"eq22", ",", "n"}], "]"}], "//", "Simplify"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.422153154828125*^9, 3.422153164859375*^9}, 
   3.42215704134375*^9, {3.4893900200294266`*^9, 3.489390024740696*^9}, {
   3.553443077172022*^9, 3.553443078810707*^9}, 3.5536631362061415`*^9},
 CellLabel->
  "In[141]:=",ExpressionUUID->"50ab60c5-3335-491a-85f0-93f8b43148d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"J22", "=", 
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{"eq22", ",", "p"}], "]"}], "//", "Simplify"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.42215316628125*^9, 3.4221531765*^9}, 
   3.422157043234375*^9, {3.489390029837987*^9, 3.489390032955166*^9}, {
   3.5534430813230057`*^9, 3.55344308199415*^9}, 3.55366313792724*^9},
 CellLabel->
  "In[142]:=",ExpressionUUID->"89ea6c85-3890-448c-b17c-fafa7160dece"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"TODO", ",", " ", 
    RowBox[{"ParallelTable", " ", "-", " ", 
     RowBox[{"not", " ", "easy", " ", "in", " ", "this", " ", "form"}]}], ",",
     " ", 
    RowBox[{"some", " ", "work", " ", "required"}], ",", " ", 
    RowBox[{"np", " ", "could", " ", "be", " ", 
     RowBox[{"overwritten", " ", "!"}], "  ", "Each", " ", "kernel", " ", 
     "must", " ", "create", " ", "own", " ", 
     RowBox[{"copy", ".", " ", "Testing"}], " ", 
     RowBox[{"required", " ", "!"}]}]}], "*)"}], " "}]], "Input",
 CellChangeTimes->{{3.4893901530880365`*^9, 3.4893902041659584`*^9}, {
  3.4893902467573943`*^9, 3.4893902624162903`*^9}},
 CellLabel->
  "In[143]:=",ExpressionUUID->"0b2bdab9-cdce-47e4-bff4-643abe760210"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"kk", "=", "1"}], ",", " ", 
      RowBox[{"kk", "\[LessEqual]", 
       RowBox[{
        RowBox[{"Dimensions", "[", "np", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"kk", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ii", "=", 
           RowBox[{
            RowBox[{"Dimensions", "[", "np", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";", 
          RowBox[{"guessn", "=", 
           RowBox[{"Log10", "[", 
            RowBox[{"1", "-", "Ye"}], "]"}]}], ";", 
          RowBox[{"guessp", "=", 
           RowBox[{"Log10", "[", "Ye", "]"}]}]}], ",", 
         RowBox[{"ii", "\[GreaterEqual]", "1"}], ",", 
         RowBox[{"ii", "--"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp", " ", "=", " ", 
           RowBox[{
            RowBox[{"np", "[", 
             RowBox[{"[", 
              RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"dens", " ", "=", " ", 
           RowBox[{
            RowBox[{"np", "[", 
             RowBox[{"[", 
              RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"sol", "=", 
           RowBox[{"FindRoot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"eq11", ",", "eq22"}], "}"}], " ", "/.", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"kT", "\[Rule]", "temp"}], ",", 
                RowBox[{"\[Rho]", "\[Rule]", 
                 RowBox[{"10", "^", "dens"}]}]}], "}"}]}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"n", ",", "guessn"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"p", ",", "guessp"}], "}"}]}], "}"}], ",", 
             RowBox[{"WorkingPrecision", "\[Rule]", "64"}], ",", " ", 
             RowBox[{"Jacobian", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"J11", ",", "J12"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"J21", ",", "J22"}], "}"}]}], "}"}], "/.", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"kT", "\[Rule]", "temp"}], ",", 
                  RowBox[{"\[Rho]", "\[Rule]", 
                   RowBox[{"10", "^", "dens"}]}]}], "}"}]}], ")"}]}], ",", 
             RowBox[{"MaxIterations", "\[Rule]", "2000"}]}], "]"}]}], ";", 
          " ", "\[IndentingNewLine]", 
          RowBox[{"nse", "=", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Xn", "->", 
               RowBox[{"10", "^", "n"}]}], ",", 
              RowBox[{"Xp", "->", 
               RowBox[{"10", "^", "p"}]}]}], "}"}], " ", "/.", "sol"}]}], ";",
           "\[IndentingNewLine]", 
          RowBox[{"guessn", "=", 
           RowBox[{"n", " ", "/.", "sol"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"guessp", "=", 
           RowBox[{"p", " ", "/.", " ", "sol"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"np", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk", ",", "3"}], "]"}], "]"}], "=", 
           RowBox[{"{", 
            RowBox[{"guessn", ",", "guessp"}], "}"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"abundances", "=", 
           RowBox[{
            RowBox[{"X", " ", "/.", " ", "nse"}], " ", "/.", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"kT", "\[Rule]", "temp"}], ",", 
              RowBox[{"\[Rho]", "\[Rule]", 
               RowBox[{"10", "^", "dens"}]}]}], "}"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{
               RowBox[{"Tr", "[", "abundances", "]"}], "-", "1"}], "]"}], ">",
              "\[InvisibleSpace]", 
             RowBox[{"10", "^", 
              RowBox[{"-", "52"}]}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"Print", "[", 
             RowBox[{"\"\<Ye=\>\"", ",", "Ye", ",", "\"\<\\tkT=\>\"", ",", 
              RowBox[{"N", "[", 
               RowBox[{"temp", ",", "3"}], "]"}], ",", "\"\<\\t\>\"", ",", 
              "\"\<lg \[Rho]=\>\"", ",", 
              RowBox[{"N", "[", 
               RowBox[{"dens", ",", "3"}], " ", "]"}], ",", "\"\<\\t\>\"", 
              ",", 
              RowBox[{
               RowBox[{"Tr", "[", "abundances", "]"}], "-", "1"}], ",", 
              "\"\<\\t\>\"", ",", 
              RowBox[{"Select", "[", 
               RowBox[{
                RowBox[{"Flatten", "[", "abundances", "]"}], ",", 
                RowBox[{
                 RowBox[{"#", ">", "1"}], "&"}]}], "]"}], ",", "\"\<\\t\>\"", 
              ",", 
              RowBox[{"Select", "[", 
               RowBox[{
                RowBox[{"Flatten", "[", "abundances", "]"}], ",", 
                RowBox[{
                 RowBox[{"#", "<", "0"}], "&"}]}], "]"}]}], 
             "\[IndentingNewLine]", "]"}]}], 
           RowBox[{"(*", 
            RowBox[{"If", " ", "ends"}], "*)"}], "\[IndentingNewLine]", 
           "]"}]}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
     "\[IndentingNewLine]", " ", "]"}], ";", "\[IndentingNewLine]", "   ", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"\"\<data/np_P_GkT_\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"NumberForm", "[", 
         RowBox[{
          RowBox[{"N", "[", "Ye", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "]"}], "<>", 
       "\"\<.dat\>\""}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"np", "[", 
              RowBox[{"[", 
               RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"np", "[", 
              RowBox[{"[", 
               RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"np", "[", 
              RowBox[{"[", 
               RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"np", "[", 
              RowBox[{"[", 
               RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"3", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ii", ",", "1", ",", 
            RowBox[{
             RowBox[{"Dimensions", "[", "np", "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"kk", ",", "1", ",", 
            RowBox[{
             RowBox[{"Dimensions", "[", "np", "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}], ",", "1"}], 
       "]"}], ",", "\"\<Table\>\""}], "]"}]}], " ", "\[IndentingNewLine]", 
   ",", 
   RowBox[{"{", 
    RowBox[{"Ye", ",", 
     RowBox[{"Yetbl", "[", 
      RowBox[{"[", 
       RowBox[{"2", ";;", 
        RowBox[{"-", "2"}]}], "]"}], "]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.412677566109375*^9, 3.4126776393125*^9}, {
   3.41267769934375*^9, 3.41267774259375*^9}, {3.412677778640625*^9, 
   3.4126779165625*^9}, {3.412677972828125*^9, 3.412677997609375*^9}, {
   3.412678092078125*^9, 3.41267809271875*^9}, {3.41267814571875*^9, 
   3.41267815253125*^9}, {3.412678214*^9, 3.41267823028125*^9}, {
   3.412680032919641*^9, 3.412680063219988*^9}, {3.412680619624016*^9, 
   3.4126806220944843`*^9}, {3.4126824321126328`*^9, 
   3.4126824334259377`*^9}, {3.412684081653717*^9, 3.412684150430872*^9}, {
   3.412684318367856*^9, 3.412684336715495*^9}, {3.412739813186948*^9, 
   3.4127398174299*^9}, {3.412740812144854*^9, 3.412740817832402*^9}, {
   3.412773984154405*^9, 3.412774013559862*^9}, {3.420462269078125*^9, 
   3.420462278125*^9}, {3.420466162703125*^9, 3.420466177578125*^9}, {
   3.4204673479375*^9, 3.4204673931875*^9}, {3.42046975725*^9, 
   3.420469813984375*^9}, {3.42047056478125*^9, 3.42047058346875*^9}, {
   3.420513579828125*^9, 3.420513581765625*^9}, {3.420599984484375*^9, 
   3.42059999946875*^9}, {3.420605097953125*^9, 3.420605136296875*^9}, {
   3.420613492828125*^9, 3.42061353728125*^9}, {3.42063125625*^9, 
   3.4206312684375*^9}, {3.4207702678125*^9, 3.420770350046875*^9}, {
   3.420770418671875*^9, 3.420770428578125*^9}, {3.42077051078125*^9, 
   3.420770517234375*^9}, {3.42077055325*^9, 3.42077056046875*^9}, {
   3.420771249546875*^9, 3.420771251875*^9}, {3.420779478359375*^9, 
   3.420779488203125*^9}, {3.422153182375*^9, 3.4221531959375*^9}, {
   3.422153255171875*^9, 3.42215330725*^9}, {3.42215374625*^9, 
   3.422153755890625*^9}, {3.422154702125*^9, 3.422154704328125*^9}, {
   3.422156906296875*^9, 3.422156941875*^9}, {3.42215712734375*^9, 
   3.42215713171875*^9}, {3.423364089*^9, 3.423364110921875*^9}, {
   3.427613397780407*^9, 3.4276134031783133`*^9}, {3.427617655389537*^9, 
   3.4276176564002237`*^9}, 3.427623000971496*^9, {3.42950386259375*^9, 
   3.4295038748125*^9}, {3.429504015984375*^9, 3.42950402084375*^9}, {
   3.429685728967615*^9, 3.4296857488555813`*^9}, {3.489204785547332*^9, 
   3.4892047873734365`*^9}, {3.4892054164934196`*^9, 3.489205426691003*^9}, {
   3.4892054909646797`*^9, 3.4892054913287*^9}, {3.489210188172344*^9, 
   3.489210213057768*^9}, {3.489211791223034*^9, 3.489211791596055*^9}, {
   3.4892118326344023`*^9, 3.489211835268553*^9}, {3.4892119503701363`*^9, 
   3.489211952297247*^9}, {3.4893046587627554`*^9, 3.489304758835479*^9}, {
   3.489649498594034*^9, 3.4896495588224792`*^9}, {3.489649675483152*^9, 
   3.4896496789023476`*^9}, {3.4896504093631277`*^9, 3.48965043265546*^9}, {
   3.489650467209436*^9, 3.4896504905237694`*^9}, 3.553443505774599*^9, {
   3.553517005151204*^9, 3.553517031430708*^9}, {3.553522244979168*^9, 
   3.553522247256772*^9}, {3.5535224350967016`*^9, 3.553522436235504*^9}, {
   3.5535224981832123`*^9, 3.5535225158580437`*^9}, {3.553663017253338*^9, 
   3.5536630422117653`*^9}, {3.5536631551832266`*^9, 3.55366316135858*^9}, 
   3.5536632035569935`*^9, {3.553666581535203*^9, 3.5536665928768516`*^9}, 
   3.553666678589754*^9},
 CellLabel->
  "In[144]:=",ExpressionUUID->"951c8572-060c-44fa-b448-d198cdb948fa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"data/np_P_GkT_0.0010.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.0100.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.0500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.1000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.1500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.2000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.2500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.3000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.3500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.3750.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.4000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.4250.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.4500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.4750.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.5000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.5250.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.5500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.6000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.6500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.7000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.7500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.8000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.8500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.9000.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.9500.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.9900.dat\"\>", 
   ",", "\<\"data/np_P_GkT_0.9990.dat\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.940388965659092*^9},
 CellLabel->
  "Out[144]=",ExpressionUUID->"513d5048-c3dc-ba44-8d7c-a060ce9351f2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Case", " ", "Ye"}], "=", "0"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"np0", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"temp", ",", "lgdens", ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "Infinity"}]}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"temp", ",", "kTtbl"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"lgdens", ",", "lgdenstbl"}], "}"}]}], "]"}]}], " ", 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.553517241323713*^9, 3.5535172529313765`*^9}, {
  3.5535173145789027`*^9, 3.553517316291001*^9}, {3.553518207627387*^9, 
  3.553518226971421*^9}, {3.5536753631114807`*^9, 3.553675374538134*^9}},
 CellLabel->
  "In[145]:=",ExpressionUUID->"c60b8915-5945-4f15-9c06-1786bbe38521"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"\"\<data/np_P_GkT_\>\"", "<>", 
     RowBox[{"ToString", "[", 
      RowBox[{"NumberForm", "[", 
       RowBox[{
        RowBox[{"N", "[", 
         RowBox[{"Yetbl", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "]"}], "<>", 
     "\"\<.dat\>\""}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"np0", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"np0", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"np0", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"np0", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"3", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "np0", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"kk", ",", "1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "np0", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}], ",", "1"}], 
     "]"}], ",", "\"\<Table\>\""}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.553517258672705*^9, 3.553517289376461*^9}},
 CellLabel->
  "In[146]:=",ExpressionUUID->"4bcfa3f5-9d68-4c16-b583-071ee082450f"],

Cell[BoxData["\<\"data/np_P_GkT_0.0000.dat\"\>"], "Output",
 CellChangeTimes->{3.9403889663733864`*^9},
 CellLabel->
  "Out[146]=",ExpressionUUID->"01cb201e-cbad-4d40-92e4-ae20a4f7bb44"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Case", " ", "Ye"}], "=", "1"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"np1", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"temp", ",", "lgdens", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "Infinity"}], ",", "0"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"temp", ",", "kTtbl"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"lgdens", ",", "lgdenstbl"}], "}"}]}], "]"}]}], " ", 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.553517340426381*^9, 3.553517344417609*^9}, {
  3.553518218672206*^9, 3.5535182342410336`*^9}, {3.55367537848736*^9, 
  3.5536753830896235`*^9}},
 CellLabel->
  "In[147]:=",ExpressionUUID->"75d2164b-9aca-4996-b1e5-5d60b126a031"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"np", "[", 
           RowBox[{"[", 
            RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"np", "[", 
           RowBox[{"[", 
            RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"np", "[", 
           RowBox[{"[", 
            RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"np", "[", 
           RowBox[{"[", 
            RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "1", ",", 
         RowBox[{
          RowBox[{"Dimensions", "[", "np", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"kk", ",", "1", ",", 
         RowBox[{
          RowBox[{"Dimensions", "[", "np", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}], ",", "1"}], "]"}],
    "  ", ";"}], "*)"}]], "Input",
 CellChangeTimes->{{3.412686962794311*^9, 3.4126870908551817`*^9}, {
  3.4126872785482197`*^9, 3.412687297754813*^9}, {3.4126876912014933`*^9, 
  3.4126876980795593`*^9}, {3.412742996233801*^9, 3.412743017226914*^9}, {
  3.41291938078125*^9, 3.41291938128125*^9}, {3.4892348203362236`*^9, 
  3.4892348228033648`*^9}},
 CellLabel->
  "In[148]:=",ExpressionUUID->"87678e99-72ea-4557-bb47-ceea3fff094f"],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{"(*", "  ", 
   RowBox[{"Export", "[", 
    RowBox[{
    "\"\<H:/misiek/tmp/np_800_fine096.dat\>\"", ",", "%", ",", 
     "\"\<Table\>\""}], "]"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.412687303338442*^9, 3.4126873439164047`*^9}, {
  3.412765013707158*^9, 3.412765021401678*^9}, {3.41291939109375*^9, 
  3.412919413203125*^9}, {3.420102044375*^9, 3.420102057046875*^9}, {
  3.420115781140625*^9, 3.42011578359375*^9}, {3.420115994859375*^9, 
  3.420115996796875*^9}, {3.420293798125*^9, 3.420293800265625*^9}, {
  3.489234810167642*^9, 3.4892348122007585`*^9}},
 CellLabel->
  "In[149]:=",ExpressionUUID->"6cca4b53-428e-43f9-abe8-b5d928ec2399"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"(*", " ", 
   RowBox[{"Export", "[", 
    RowBox[{
    "\"\<E://temp/np_3181_fine.dat\>\"", ",", "%", ",", "\"\<Table\>\""}], 
    "]"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.412948203296875*^9, 3.41294821071875*^9}, {
  3.489234825181501*^9, 3.4892348273106227`*^9}},
 CellLabel->
  "In[150]:=",ExpressionUUID->"d10da448-3990-41e9-893b-4f95331a9e3a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"\"\<data/np_P_GkT_\>\"", "<>", 
     RowBox[{"ToString", "[", 
      RowBox[{"NumberForm", "[", 
       RowBox[{
        RowBox[{"N", "[", 
         RowBox[{"Yetbl", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "]"}], "<>", 
     "\"\<.dat\>\""}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"np1", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"np1", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"np1", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"np1", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "kk"}], "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"3", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "np1", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"kk", ",", "1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "np1", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}], ",", "1"}], 
     "]"}], ",", "\"\<Table\>\""}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.5535173608195477`*^9, 3.553517374592335*^9}},
 CellLabel->
  "In[151]:=",ExpressionUUID->"fe38530b-ec26-44a1-ad0a-e76b13181b28"],

Cell[BoxData["\<\"data/np_P_GkT_1.0000.dat\"\>"], "Output",
 CellChangeTimes->{3.940388967013708*^9},
 CellLabel->
  "Out[151]=",ExpressionUUID->"ddeb5d8b-7f0c-164c-9b6f-d870225c1bd7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"npTMP", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
       RowBox[{"\"\<data/np_P_GkT_\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"NumberForm", "[", 
          RowBox[{
           RowBox[{"N", "[", "Ye", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "]"}], "<>", 
        "\"\<.dat\>\""}], ",", "\"\<Lines\>\""}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"Ye", ",", "Yetbl"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4126879790252647`*^9, 3.412687989054743*^9}, {
  3.412688875860096*^9, 3.412688907595745*^9}, {3.412745173927246*^9, 
  3.412745175681745*^9}, {3.412745617600683*^9, 3.412745618201742*^9}, {
  3.412830369946026*^9, 3.412830371081655*^9}, {3.412951519546875*^9, 
  3.412951536421875*^9}, {3.4131176541121283`*^9, 3.4131176653376827`*^9}, {
  3.4199133431875*^9, 3.41991335578125*^9}, {3.420696943397766*^9, 
  3.420697016153656*^9}, {3.42762986983383*^9, 3.427629941622101*^9}, {
  3.4297017960497513`*^9, 3.429701812959354*^9}, {3.489233023393444*^9, 
  3.489233025529567*^9}},
 CellLabel->
  "In[152]:=",ExpressionUUID->"553f8818-9400-4fc1-828b-3b17d1bf5aae"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", "npTMP", "]"}]], "Input",
 CellChangeTimes->{{3.412745675037365*^9, 3.412745681092573*^9}},
 CellLabel->
  "In[153]:=",ExpressionUUID->"bfeada03-8ac2-4be5-8e3c-3e10f2f8bc49"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"29", ",", "135"}], "}"}]], "Output",
 CellChangeTimes->{3.94038896843503*^9},
 CellLabel->
  "Out[153]=",ExpressionUUID->"784452e2-2195-bf43-acfd-f3dcd268f574"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"npTMP", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.429701849054968*^9, 3.42970187272334*^9}},
 CellLabel->
  "In[154]:=",ExpressionUUID->"5ae8ca1d-0cfd-4e07-a4e8-bb794fdd2aef"],

Cell[BoxData["\<\"3/10\\t13/2\\t0\\t-Infinity\"\>"], "Output",
 CellChangeTimes->{3.9403889684630337`*^9},
 CellLabel->
  "Out[154]=",ExpressionUUID->"84c5569e-d855-a14f-9764-f97417f9797a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Imports", " ", "rational", " ", "and", " ", "arbitrary", " ", "precision", 
   " ", "numbers"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4127457406273737`*^9, 3.4127457589493504`*^9}},
 CellLabel->
  "In[155]:=",ExpressionUUID->"07ad8e44-2019-4b35-b866-ba127688f30a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"np", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"npTMP", "[", 
            RowBox[{"[", "jj", "]"}], "]"}], "[", 
           RowBox[{"[", "ii", "]"}], "]"}], " ", "//", "StringSplit"}], " ", "//",
          " ", "ToExpression"}], " ", "//", "N"}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "1", ",", 
         RowBox[{
          RowBox[{"Dimensions", "[", 
           RowBox[{"npTMP", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "1", ",", "YeNum"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.412745622080611*^9, 3.41274571628834*^9}, {
  3.419913383515625*^9, 3.419913384140625*^9}, {3.4206970542570457`*^9, 
  3.420697072622479*^9}, {3.4206984966362762`*^9, 3.420698497825294*^9}, {
  3.420698537326693*^9, 3.420698591675563*^9}},
 CellLabel->
  "In[156]:=",ExpressionUUID->"caee246d-ff93-4ed1-8355-4928fbe55043"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", "np", "]"}]], "Input",
 CellChangeTimes->{{3.4126898199550743`*^9, 3.412689823507022*^9}},
 CellLabel->
  "In[157]:=",ExpressionUUID->"5b196356-06d9-405b-9d5d-b15d4482141f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"29", ",", "135", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{3.940388968610178*^9},
 CellLabel->
  "Out[157]=",ExpressionUUID->"594d39cb-4ad1-e949-97ed-d483e3279c95"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"np", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "[", 
    RowBox[{"[", "3", "]"}], "]"}], "[", 
   RowBox[{"[", "4", "]"}], "]"}], "  ", "//", "FullForm"}]], "Input",
 CellChangeTimes->{{3.4126879906984873`*^9, 3.412688007727594*^9}, {
  3.412688274806573*^9, 3.4126882800386763`*^9}, {3.412688461837751*^9, 
  3.412688466423355*^9}, {3.4126885101177607`*^9, 3.4126885145324*^9}, {
  3.412688583062499*^9, 3.4126885907105103`*^9}, {3.412688891265593*^9, 
  3.41268891915495*^9}, {3.4127431901764708`*^9, 3.412743198487307*^9}, {
  3.412743670682555*^9, 3.412743712015421*^9}, {3.4127438005931892`*^9, 
  3.412743812268169*^9}, {3.412745770993454*^9, 3.4127457716092863`*^9}, {
  3.420698600119286*^9, 3.420698601049478*^9}, {3.489896610844365*^9, 
  3.4898966117474165`*^9}},
 CellLabel->
  "In[158]:=",ExpressionUUID->"07d8f4a1-6ea2-4ddb-8a8d-71a3666cdc22"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"DirectedInfinity", "[", 
    RowBox[{"-", "1"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.940388968632841*^9},
 CellLabel->
  "Out[158]//FullForm=",ExpressionUUID->"0f72a490-37d3-454b-9b3e-\
f0fca863cbfd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kT", " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{"kT", "\[Rule]", 
    RowBox[{
     RowBox[{"np", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.412743746791945*^9, 3.412743755848199*^9}, {
  3.4206986123985367`*^9, 3.420698613005637*^9}},
 CellLabel->
  "In[159]:=",ExpressionUUID->"65dd366c-57fd-4e1f-8896-c55ccc5da431"],

Cell[BoxData["0.3`"], "Output",
 CellChangeTimes->{3.9403889686368446`*^9},
 CellLabel->
  "Out[159]=",ExpressionUUID->"4788063c-c883-0a45-8026-01192ba7fa49"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "[", 
   RowBox[{"[", "2", "]"}], "]"}], "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"kT", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"np", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ",", 
    RowBox[{"\[Rho]", "\[Rule]", 
     RowBox[{"10", "^", 
      RowBox[{
       RowBox[{
        RowBox[{"np", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], ",", 
    RowBox[{"Xn", "\[Rule]", 
     RowBox[{"10", "^", 
      RowBox[{
       RowBox[{
        RowBox[{"np", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], "[", 
       RowBox[{"[", "3", "]"}], "]"}]}]}], ",", 
    RowBox[{"Xp", "\[Rule]", 
     RowBox[{"10", "^", 
      RowBox[{
       RowBox[{
        RowBox[{"np", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], "[", 
       RowBox[{"[", "4", "]"}], "]"}]}]}]}], "}"}], "  "}]], "Input",
 CellChangeTimes->{{3.412688198643341*^9, 3.412688200199301*^9}, {
  3.412688419845793*^9, 3.41268847336268*^9}, {3.412743726644389*^9, 
  3.412743730971986*^9}, {3.420698618331818*^9, 3.420698630197276*^9}, {
  3.4898966204909167`*^9, 3.489896626500261*^9}},
 CellLabel->
  "In[160]:=",ExpressionUUID->"d3adb5a1-9b29-4350-a35b-008120cddb68"],

Cell[BoxData["0.`"], "Output",
 CellChangeTimes->{3.9403889686584587`*^9},
 CellLabel->
  "Out[160]=",ExpressionUUID->"9b9f18f1-364f-de4f-bdf3-b4dec5b1e5ed"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MinPrecision", "=", "$MachinePrecision"}]], "Input",
 CellChangeTimes->{{3.4127460391126432`*^9, 3.412746048420809*^9}},
 CellLabel->
  "In[161]:=",ExpressionUUID->"b9ce807d-191f-4ba5-bbbe-889847453a89"],

Cell[BoxData["15.954589770191003`"], "Output",
 CellChangeTimes->{3.9403889686695023`*^9},
 CellLabel->
  "Out[161]=",ExpressionUUID->"cb431ab1-1b92-6244-b0bc-7e3c3cc0ff18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Precision", "[", 
  RowBox[{"10", "^", 
   RowBox[{
    RowBox[{"np", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"12", ",", "4"}], "]"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4127707249683123`*^9, 3.412770750952982*^9}, {
   3.4206986370889482`*^9, 3.420698637602644*^9}, 3.489288926025238*^9},
 CellLabel->
  "In[162]:=",ExpressionUUID->"24453626-036a-46e5-abd4-67a85069342b"],

Cell[BoxData["\[Infinity]"], "Output",
 CellChangeTimes->{3.9403889686906166`*^9},
 CellLabel->
  "Out[162]=",ExpressionUUID->"65ed4d96-c99a-dc4d-9a6a-6569879664dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"X", " ", "/.", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"kT", "\[Rule]", 
           RowBox[{
            RowBox[{
             RowBox[{"np", "[", 
              RowBox[{"[", "jj", "]"}], "]"}], "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ",", 
          RowBox[{"\[Rho]", "\[Rule]", 
           RowBox[{"10", "^", 
            RowBox[{
             RowBox[{
              RowBox[{"np", "[", 
               RowBox[{"[", "jj", "]"}], "]"}], "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], ",", 
          RowBox[{"Xn", "\[Rule]", 
           RowBox[{"10", "^", 
            RowBox[{
             RowBox[{
              RowBox[{"np", "[", 
               RowBox[{"[", "jj", "]"}], "]"}], "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "[", 
             RowBox[{"[", "3", "]"}], "]"}]}]}], ",", 
          RowBox[{"Xp", "\[Rule]", 
           RowBox[{"10", "^", 
            RowBox[{
             RowBox[{
              RowBox[{"np", "[", 
               RowBox[{"[", "jj", "]"}], "]"}], "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "[", 
             RowBox[{"[", "4", "]"}], "]"}]}]}]}], "}"}]}], "//", "Tr"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", 
        RowBox[{
         RowBox[{"Dimensions", "[", 
          RowBox[{"np", "[", 
           RowBox[{"[", "jj", "]"}], "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "10"}], "}"}]}], "]"}], " ", "//",
     "Sort"}], " ", ",", 
   RowBox[{"{", 
    RowBox[{"jj", ",", "1", ",", "YeNum"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Simple", " ", "test"}], ";", " ", 
    RowBox[{"Expected", " ", 
     RowBox[{"result", ":", " ", 
      RowBox[{"only", " ", "\"\<1.\>\""}]}]}]}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4126880345495033`*^9, 3.4126881623354053`*^9}, {
   3.412688239355435*^9, 3.412688267402017*^9}, {3.412688315004375*^9, 
   3.412688334432125*^9}, {3.412688364814514*^9, 3.41268837674251*^9}, {
   3.41268847855945*^9, 3.412688531639578*^9}, {3.41268864782197*^9, 
   3.412688659814129*^9}, {3.4126897488518963`*^9, 3.41268979786123*^9}, {
   3.4126898297918453`*^9, 3.412689866502842*^9}, {3.412690122432417*^9, 
   3.4126901249327593`*^9}, {3.4127437740929728`*^9, 3.41274378038837*^9}, {
   3.4127457932773314`*^9, 3.4127457969916897`*^9}, {3.412746016184225*^9, 
   3.412746017191827*^9}, {3.412766016233251*^9, 3.412766024323864*^9}, {
   3.419913417484375*^9, 3.41991342909375*^9}, {3.420698649681958*^9, 
   3.420698707020276*^9}, {3.4892347503972235`*^9, 3.489234773728558*^9}, {
   3.4892889439922657`*^9, 3.4892889477304797`*^9}, 3.553492155681384*^9},
 CellLabel->
  "In[163]:=",ExpressionUUID->"6ce59430-8cf6-410c-9252-edbf7f137133"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", 
     "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", 
     "1.`", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999999`", ",", "0.9999999999999999`", ",", 
     "0.9999999999999999`", ",", "0.9999999999999999`", ",", 
     "0.9999999999999999`", ",", "0.9999999999999999`", ",", "1.`", ",", 
     "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", 
     "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999998`", ",", "0.9999999999999999`", ",", 
     "0.9999999999999999`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", 
     ",", "1.`", ",", "1.`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000002`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999993`", ",", "0.9999999999999996`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000007`", ",", 
     "1.0000000000000009`", ",", "1.0000000000000009`", ",", 
     "1.000000000000001`", ",", "1.0000000000000013`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999988`", ",", "0.9999999999999994`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000007`", ",", 
     "1.000000000000001`", ",", "1.0000000000000022`", ",", 
     "1.0000000000000022`", ",", "1.0000000000000024`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999977`", ",", "0.9999999999999994`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000002`", ",", "1.0000000000000002`", ",",
      "1.0000000000000007`", ",", "1.0000000000000018`", ",", 
     "1.0000000000000018`", ",", "1.0000000000000018`", ",", 
     "1.000000000000003`", ",", "1.0000000000000036`", ",", 
     "1.000000000000004`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999982`", ",", "0.9999999999999996`", ",", "1.`", ",", "1.`",
      ",", "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000007`", ",", 
     "1.0000000000000016`", ",", "1.0000000000000024`", ",", 
     "1.0000000000000029`", ",", "1.0000000000000033`", ",", 
     "1.0000000000000036`", ",", "1.0000000000000058`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999974`", ",", "0.9999999999999987`", ",", 
     "0.9999999999999999`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000018`", ",", 
     "1.0000000000000024`", ",", "1.0000000000000033`", ",", 
     "1.0000000000000038`", ",", "1.0000000000000047`", ",", 
     "1.0000000000000056`", ",", "1.0000000000000062`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999969`", ",", "0.9999999999999992`", ",", "1.`", ",", "1.`",
      ",", "1.0000000000000002`", ",", "1.0000000000000004`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000004`", ",", 
     "1.0000000000000024`", ",", "1.0000000000000029`", ",", 
     "1.0000000000000036`", ",", "1.0000000000000049`", ",", 
     "1.0000000000000049`", ",", "1.0000000000000075`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999976`", ",", "0.9999999999999984`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000002`", ",", "1.0000000000000004`", ",",
      "1.0000000000000029`", ",", "1.000000000000003`", ",", 
     "1.000000000000004`", ",", "1.000000000000005`", ",", 
     "1.0000000000000053`", ",", "1.0000000000000064`", ",", 
     "1.0000000000000098`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999946`", ",", "0.9999999999999983`", ",", "1.`", ",", "1.`",
      ",", "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000022`", ",", 
     "1.0000000000000033`", ",", "1.0000000000000049`", ",", 
     "1.0000000000000062`", ",", "1.0000000000000064`", ",", 
     "1.0000000000000069`", ",", "1.0000000000000084`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999951`", ",", "0.9999999999999973`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000004`", ",", "1.0000000000000004`", ",",
      "1.000000000000001`", ",", "1.000000000000003`", ",", 
     "1.000000000000005`", ",", "1.0000000000000064`", ",", 
     "1.0000000000000064`", ",", "1.0000000000000073`", ",", 
     "1.000000000000012`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999956`", ",", "0.9999999999999974`", ",", "1.`", ",", "1.`",
      ",", "1.0000000000000002`", ",", "1.0000000000000004`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000024`", ",", 
     "1.0000000000000042`", ",", "1.0000000000000064`", ",", 
     "1.0000000000000073`", ",", "1.000000000000008`", ",", 
     "1.0000000000000082`", ",", "1.0000000000000102`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999953`", ",", "0.9999999999999984`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000004`", ",", "1.0000000000000004`", ",",
      "1.0000000000000022`", ",", "1.0000000000000042`", ",", 
     "1.0000000000000044`", ",", "1.0000000000000056`", ",", 
     "1.0000000000000078`", ",", "1.0000000000000084`", ",", 
     "1.0000000000000095`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999963`", ",", "0.9999999999999991`", ",", "1.`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000007`", ",", 
     "1.0000000000000013`", ",", "1.0000000000000027`", ",", 
     "1.000000000000005`", ",", "1.0000000000000053`", ",", 
     "1.000000000000006`", ",", "1.0000000000000109`", ",", 
     "1.0000000000000115`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999953`", ",", "0.9999999999999978`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000004`", ",", "1.0000000000000004`", ",",
      "1.0000000000000033`", ",", "1.0000000000000038`", ",", 
     "1.0000000000000042`", ",", "1.000000000000007`", ",", 
     "1.0000000000000093`", ",", "1.0000000000000115`", ",", 
     "1.0000000000000142`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999963`", ",", "0.9999999999999991`", ",", "1.`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000007`", ",", 
     "1.0000000000000013`", ",", "1.0000000000000027`", ",", 
     "1.0000000000000049`", ",", "1.0000000000000053`", ",", 
     "1.000000000000006`", ",", "1.0000000000000109`", ",", 
     "1.0000000000000115`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999951`", ",", "0.9999999999999982`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000004`", ",", "1.0000000000000004`", ",",
      "1.0000000000000022`", ",", "1.0000000000000042`", ",", 
     "1.0000000000000044`", ",", "1.0000000000000056`", ",", 
     "1.0000000000000078`", ",", "1.0000000000000084`", ",", 
     "1.0000000000000095`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999951`", ",", "0.9999999999999972`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000004`", ",", "1.0000000000000004`", ",",
      "1.000000000000001`", ",", "1.0000000000000033`", ",", 
     "1.000000000000005`", ",", "1.0000000000000064`", ",", 
     "1.0000000000000064`", ",", "1.000000000000007`", ",", 
     "1.000000000000012`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999977`", ",", "0.9999999999999984`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000002`", ",", "1.0000000000000004`", ",",
      "1.0000000000000029`", ",", "1.0000000000000029`", ",", 
     "1.000000000000004`", ",", "1.0000000000000049`", ",", 
     "1.0000000000000056`", ",", "1.0000000000000064`", ",", 
     "1.0000000000000098`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999969`", ",", "0.9999999999999993`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000004`", ",", "1.0000000000000004`", ",",
      "1.0000000000000004`", ",", "1.0000000000000027`", ",", 
     "1.000000000000003`", ",", "1.0000000000000036`", ",", 
     "1.0000000000000049`", ",", "1.0000000000000049`", ",", 
     "1.0000000000000075`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999976`", ",", "0.9999999999999987`", ",", 
     "0.9999999999999999`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000018`", ",", 
     "1.0000000000000024`", ",", "1.000000000000003`", ",", 
     "1.0000000000000036`", ",", "1.0000000000000047`", ",", 
     "1.0000000000000056`", ",", "1.0000000000000062`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999982`", ",", "0.9999999999999996`", ",", "1.`", ",", "1.`",
      ",", "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000007`", ",", 
     "1.0000000000000016`", ",", "1.0000000000000024`", ",", 
     "1.0000000000000029`", ",", "1.0000000000000036`", ",", 
     "1.0000000000000036`", ",", "1.0000000000000056`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999977`", ",", "0.9999999999999994`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.0000000000000002`", ",", "1.0000000000000002`", ",",
      "1.0000000000000007`", ",", "1.0000000000000018`", ",", 
     "1.0000000000000018`", ",", "1.0000000000000018`", ",", 
     "1.000000000000003`", ",", "1.0000000000000036`", ",", 
     "1.000000000000004`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999987`", ",", "0.9999999999999996`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000007`", ",", 
     "1.000000000000001`", ",", "1.0000000000000022`", ",", 
     "1.0000000000000022`", ",", "1.0000000000000024`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999993`", ",", "0.9999999999999997`", ",", "1.`", ",", "1.`",
      ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000004`", ",", "1.0000000000000007`", ",", 
     "1.0000000000000009`", ",", "1.0000000000000009`", ",", 
     "1.000000000000001`", ",", "1.0000000000000013`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999998`", ",", "0.9999999999999999`", ",", 
     "0.9999999999999999`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", 
     ",", "1.`", ",", "1.`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000002`", ",", 
     "1.0000000000000002`", ",", "1.0000000000000002`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.9999999999999999`", ",", "0.9999999999999999`", ",", 
     "0.9999999999999999`", ",", "0.9999999999999999`", ",", 
     "0.9999999999999999`", ",", "0.9999999999999999`", ",", "1.`", ",", 
     "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", 
     "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", 
     "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", "1.`", ",", 
     "1.`", ",", "1.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.940388968719248*^9},
 CellLabel->
  "Out[163]=",ExpressionUUID->"88b89135-2d86-b144-9987-7274107df197"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToString", "[", 
  RowBox[{"NumberForm", "[", 
   RowBox[{
    RowBox[{"N", "[", 
     RowBox[{"Yetbl", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.429702082727171*^9, 3.429702111777278*^9}},
 CellLabel->
  "In[164]:=",ExpressionUUID->"bd5cae24-87a6-47f1-b0cd-9f8cbc8829b7"],

Cell[BoxData["\<\"0.0000\"\>"], "Output",
 CellChangeTimes->{3.9403889687435417`*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"d33808da-4725-aa42-823e-23cb69fb2788"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Export", " ", "files", " ", "for", " ", "NSE_pn", "_table", 
    RowBox[{"_parser", ".", "c"}]}], ";", " ", 
   RowBox[{"NOTE", ":", " ", 
    RowBox[{
    "NumberForm", " ", "assume", " ", "that", " ", "4", " ", "digits", " ", 
     "is", " ", "enough", " ", "for", " ", "Ye", " ", "tabulation"}]}]}], " ",
   "*)"}]], "Input",
 CellChangeTimes->{{3.4892889836125317`*^9, 3.4892890433279476`*^9}},
 CellLabel->
  "In[165]:=",ExpressionUUID->"88273c22-ac60-47c6-979b-75062c0937d1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"kk", "=", "1"}], ",", 
   RowBox[{"kk", "\[LessEqual]", "YeNum"}], ",", 
   RowBox[{"kk", "++"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Xntbl", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{"np", "[", 
            RowBox[{"[", "kk", "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"jj", ",", "1"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"np", "[", 
             RowBox[{"[", "kk", "]"}], "]"}], "[", 
            RowBox[{"[", "jj", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{"10", "^", 
           RowBox[{
            RowBox[{
             RowBox[{"np", "[", 
              RowBox[{"[", "kk", "]"}], "]"}], "[", 
             RowBox[{"[", "jj", "]"}], "]"}], "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"jj", ",", "1", ",", 
         RowBox[{
          RowBox[{"Dimensions", "[", 
           RowBox[{"np", "[", 
            RowBox[{"[", "kk", "]"}], "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Xptbl", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{"np", "[", 
            RowBox[{"[", "kk", "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"jj", ",", "1"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"np", "[", 
             RowBox[{"[", "kk", "]"}], "]"}], "[", 
            RowBox[{"[", "jj", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{"10", "^", 
           RowBox[{
            RowBox[{
             RowBox[{"np", "[", 
              RowBox[{"[", "kk", "]"}], "]"}], "[", 
             RowBox[{"[", "jj", "]"}], "]"}], "[", 
            RowBox[{"[", "4", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"jj", ",", "1", ",", 
         RowBox[{
          RowBox[{"Dimensions", "[", 
           RowBox[{"np", "[", 
            RowBox[{"[", "kk", "]"}], "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"name1", "=", 
     RowBox[{"\"\<data/X_n_\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"NumberForm", "[", 
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"Yetbl", "[", 
           RowBox[{"[", "kk", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "]"}], "<>", 
      "\"\<.dat\>\""}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"name2", "=", 
     RowBox[{"\"\<data/X_p_\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"NumberForm", "[", 
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"Yetbl", "[", 
           RowBox[{"[", "kk", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "]"}], "<>", 
      "\"\<.dat\>\""}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"name1", "<>", "\"\<\\n\>\""}], "]"}], ";", 
    "\[IndentingNewLine]", "   ", 
    RowBox[{"Export", "[", 
     RowBox[{"name1", ",", "Xntbl", ",", "\"\<TSV\>\""}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{"name2", ",", "Xptbl", ",", "\"\<TSV\>\""}], "]"}]}]}], 
  "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "DO", " ", "NOT", " ", "FORGET", " ", "to", " ", "run", " ", 
     "\"\<./NSE_pn_table_parser >../data/np_table.c\>\"", " ", "from", " ", 
     "libnse", " ", "directory", " ", "before", " ", "re"}], "-", 
    RowBox[{
     RowBox[{
      RowBox[{"build", " ", "!!"}], "!!"}], "!"}]}], "\[IndentingNewLine]", 
   "*)"}]}]}], "Input",
 CellLabel->
  "In[166]:=",ExpressionUUID->"8438e8bd-4b91-4fea-8265-f2ee62c629c7"],

Cell[CellGroupData[{

Cell[BoxData["\<\"data/X_n_0.0000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889687715244`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"0eeae978-b832-d144-8269-4a0fae24229a"],

Cell[BoxData["\<\"data/X_n_0.0010.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388968927717*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"2a840f15-e062-1846-8615-efeb88659e89"],

Cell[BoxData["\<\"data/X_n_0.0100.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889691115723`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"b2fadf3a-6c32-0340-9b31-bfe858426d37"],

Cell[BoxData["\<\"data/X_n_0.0500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889692866135`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"c3d90e85-6f98-024a-bedd-51dbcb834d33"],

Cell[BoxData["\<\"data/X_n_0.1000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889694399357`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"c3bba82a-ecc6-a044-bbc3-d39341ebd61f"],

Cell[BoxData["\<\"data/X_n_0.1500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388969613714*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"136b1959-64bf-e84c-b445-a9be15c03d40"],

Cell[BoxData["\<\"data/X_n_0.2000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388969774252*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"f0fc3b0a-e84e-6042-8c2a-749813630df2"],

Cell[BoxData["\<\"data/X_n_0.2500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388969958908*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"bbceac5e-8d5e-a241-8dfe-fab97d30e3c3"],

Cell[BoxData["\<\"data/X_n_0.3000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388970096199*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"757ba077-3e07-5f4e-8cf5-522653ca6d3c"],

Cell[BoxData["\<\"data/X_n_0.3500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889702635536`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"40219333-fac0-9e4d-b40d-8027c969ff9f"],

Cell[BoxData["\<\"data/X_n_0.3750.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889704327526`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"056a6e3a-87dd-d647-b386-be0e094bc27e"],

Cell[BoxData["\<\"data/X_n_0.4000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388970604126*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"d1876375-7386-7044-95bb-def3f2786e53"],

Cell[BoxData["\<\"data/X_n_0.4250.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388970784609*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"f6371986-beb7-cc4b-a407-628667155dba"],

Cell[BoxData["\<\"data/X_n_0.4500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388970949316*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"3591a585-a2c0-1143-bc74-f0ee1d7f8be9"],

Cell[BoxData["\<\"data/X_n_0.4750.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889711279373`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"0b7327fe-a397-504a-8ed2-a354ea5d16fd"],

Cell[BoxData["\<\"data/X_n_0.5000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388971299549*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"897f4306-0c51-8c4f-b846-489b63262f0f"],

Cell[BoxData["\<\"data/X_n_0.5250.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388971451227*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"9186fc27-4454-ff40-aba6-82361f445b3b"],

Cell[BoxData["\<\"data/X_n_0.5500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889716185284`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"962ca79d-3102-b64f-844f-bfacb41acc10"],

Cell[BoxData["\<\"data/X_n_0.6000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388971788271*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"54846a79-4667-1947-b403-94fa91e85d70"],

Cell[BoxData["\<\"data/X_n_0.6500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889719666805`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"9a0a42e2-694a-2548-9c89-e6ac7eca4a93"],

Cell[BoxData["\<\"data/X_n_0.7000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388972131916*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"abc77b3c-8009-9e45-8e75-c2a6dfea17b3"],

Cell[BoxData["\<\"data/X_n_0.7500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388972293497*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"478890c5-841a-5647-9688-060ab32627b1"],

Cell[BoxData["\<\"data/X_n_0.8000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889724571686`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"b3583f93-26bd-ae4a-9b9c-486781477c13"],

Cell[BoxData["\<\"data/X_n_0.8500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889726446857`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"c2db6ca9-7acb-6e49-aa22-7348fee024e7"],

Cell[BoxData["\<\"data/X_n_0.9000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889728152084`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"36575fd9-798a-854c-aac2-59f042592a69"],

Cell[BoxData["\<\"data/X_n_0.9500.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889729834023`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"c8e5c2ad-0478-184b-8975-91e18c1c67f3"],

Cell[BoxData["\<\"data/X_n_0.9900.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889731454144`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"9b2a8b9d-b62c-054e-9c65-29dd95043928"],

Cell[BoxData["\<\"data/X_n_0.9990.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.940388973297676*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"1fd5ae68-a8e1-5040-879b-09e1ee868084"],

Cell[BoxData["\<\"data/X_n_1.0000.dat\\n\"\>"], "Print",
 CellChangeTimes->{3.9403889734899063`*^9},
 CellLabel->
  "During evaluation of \
In[166]:=",ExpressionUUID->"c3b3f6f7-29f4-7f49-bef7-5248e61c90db"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MaxMemoryUsed", "[", "]"}]], "Input",
 CellChangeTimes->{{3.4892975913465223`*^9, 3.4892975940826783`*^9}},
 CellLabel->
  "In[167]:=",ExpressionUUID->"719a1ae9-24e0-4ff5-b841-bb8e2d3c7a11"],

Cell[BoxData["204189808"], "Output",
 CellChangeTimes->{3.9403889736763897`*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"7ef1d919-f897-064f-9b4b-e65c01021126"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], 
   RowBox[{"!", "!"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "END", 
   " ", "of", " ", "section", " ", "required", " ", "for", " ", 
   RowBox[{"libnse", ".", " ", "Enter"}], " ", 
   RowBox[{"src", "/", " ", "subdir"}], " ", "and", " ", "run", " ", 
   RowBox[{"command", ":", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"gcc", " ", "NSE_pn", "_table", 
           RowBox[{"_parser", ".", "c"}]}], " ", "-", 
          RowBox[{"o", " ", "NSE_pn", "_table", 
           RowBox[{
            RowBox[{
            "_parser", " ", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "."}], "/", "NSE_pn"}], "_table", "_parser"}]}], " ", ">"}], 
        ".."}], "/", "data"}], "/", 
      RowBox[{"np_table", ".", "c"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", " ", "Then", " ", "go", " ", "to", " ", "main", 
     " ", "libNSE", " ", "dir", " ", "and", " ", "recompile", " ", "library", 
     " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"make", ";", " ", 
        RowBox[{"make", " ", "install"}]}], ")"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "!!"}], 
     RowBox[{
      RowBox[{"!", "!"}], 
      RowBox[{
       RowBox[{"!", "!"}], 
       RowBox[{
        RowBox[{"!", "!"}], 
        RowBox[{
         RowBox[{"!", "!"}], 
         RowBox[{
          RowBox[{"!", "!"}], 
          RowBox[{
           RowBox[{"!", "!"}], 
           RowBox[{
            RowBox[{"!", "!"}], 
            RowBox[{
             RowBox[{"!", "!"}], 
             RowBox[{
              RowBox[{"!", "!"}], 
              RowBox[{
               RowBox[{"!", "!"}], 
               RowBox[{
                RowBox[{"!", "!"}], 
                RowBox[{
                 RowBox[{"!", "!"}], 
                 RowBox[{
                  RowBox[{"!", "!"}], 
                  RowBox[{
                   RowBox[{"!", "!"}], 
                   RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    RowBox[{
                    RowBox[{"!", "!"}], 
                    "!"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}],
   "\[IndentingNewLine]", "*)"}]], "Input",
 CellChangeTimes->{{3.489234684795471*^9, 3.4892347110769744`*^9}, {
  3.489234843286536*^9, 3.4892349188868604`*^9}, {3.553681825805125*^9, 
  3.553681880508254*^9}, {3.9403848240122585`*^9, 3.9403848366198215`*^9}, {
  3.940384907035784*^9, 3.940384933564213*^9}, {3.9403849799074726`*^9, 
  3.9403849819795322`*^9}},
 CellLabel->
  "In[168]:=",ExpressionUUID->"6c3611a1-ff97-4eab-aaa0-31dbac26fff5"],

Cell[BoxData[
 RowBox[{"(*", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
  "This", " ", "section", " ", "is", " ", "required", " ", "for", " ", "NSE", 
   " ", "neutrinos"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.4892347170933185`*^9, 3.4892347356553802`*^9}},
 CellLabel->
  "In[169]:=",ExpressionUUID->"5343d982-089c-4350-a08b-29f1570bcd63"],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5536701385296516`*^9, 3.553670139340698*^9}},
 CellLabel->
  "In[170]:=",ExpressionUUID->"595bc42f-5250-4028-b8ee-7622d50c49cd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fuller1", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<E:/temp/fullerdat_nue.txt\>\"", ",", "\"\<Lines\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fuller2", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<E:/temp/fullerdat_nuebar.txt\>\"", ",", "\"\<Lines\>\""}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.420183181782917*^9, 3.420183192711773*^9}, {
  3.42069786955933*^9, 3.420697875015703*^9}, {3.430485426734375*^9, 
  3.430485440265625*^9}},ExpressionUUID->"2c76fb9a-2909-4519-b41d-\
26ccb27af502"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Convert", " ", "ffn", " ", "isotope", " ", "names", " ", "to", " ", 
   "mathematica", " ", "format", " ", 
   RowBox[{"(", 
    RowBox[{"strings", " ", 
     RowBox[{"only", "!"}]}], " ", ")"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4071677749375*^9, 
  3.407167800125*^9}},ExpressionUUID->"2c2ddb85-957f-493d-83eb-fcb040c71311"],

Cell[BoxData[
 RowBox[{
  RowBox[{"namefix", "[", "s_", "]"}], ":=", 
  RowBox[{
   RowBox[{"ToUpperCase", "[", 
    RowBox[{
     RowBox[{"Characters", "[", 
      RowBox[{"StringReplace", "[", 
       RowBox[{"s", ",", 
        RowBox[{"\"\< \>\"", "\[Rule]", "\"\<\>\""}]}], "]"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}], " ", "<>", 
   RowBox[{"StringDrop", "[", 
    RowBox[{
     RowBox[{"StringReplace", "[", 
      RowBox[{"s", ",", 
       RowBox[{"\"\< \>\"", "\[Rule]", "\"\<\>\""}]}], "]"}], ",", "1"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.407167710140625*^9, 
  3.407167733453125*^9}},ExpressionUUID->"d038852a-8bfd-4e91-a209-\
a239a4e4136b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ffniso1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ii", ",", 
       RowBox[{"namefix", "[", 
        RowBox[{"StringTake", "[", 
         RowBox[{
          RowBox[{"fuller1", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"ii", "*", "149"}], "+", "3"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"29", ",", "32"}], "}"}]}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "0", ",", "188", ",", "1"}], "}"}]}], "]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ffniso2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ii", ",", 
       RowBox[{"namefix", "[", 
        RowBox[{"StringTake", "[", 
         RowBox[{
          RowBox[{"fuller2", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"ii", "*", "149"}], "+", "3"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"28", ",", "31"}], "}"}]}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "0", ",", "188"}], "}"}]}], "]"}]}], " ", 
  ";"}]}], "Input",
 CellChangeTimes->{{3.40716782921875*^9, 3.40716787075*^9}, {
   3.407170901640625*^9, 3.40717090746875*^9}, {3.407170975921875*^9, 
   3.407170992921875*^9}, 3.407172031734375*^9, 3.4071727919375*^9, {
   3.420185556763042*^9, 
   3.4201855590539503`*^9}},ExpressionUUID->"e939b264-8a10-4266-b252-\
6236323c039c"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "positions", " ", "of", " ", "FFN", " ", "isotopes", " ", "in", " ", "our",
     " ", "NSE", " ", "table"}], ",", " ", 
   RowBox[{
   "required", " ", "for", " ", "calculating", " ", "neutrino", " ", 
    "spectra"}], ",", " ", 
   RowBox[{
   "not", " ", "required", " ", "for", " ", "pure", " ", "NSE", " ", 
    "calculations"}]}], "  ", "*)"}]], "Input",
 CellChangeTimes->{{3.4206981276852922`*^9, 3.420698144706402*^9}, {
  3.420698196881386*^9, 
  3.42069824163701*^9}},ExpressionUUID->"64a806fd-7f44-43f3-a165-\
18ae1c35724e"],

Cell[BoxData[
 RowBox[{"ffniso1", "[", 
  RowBox[{"[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.4928371554471335`*^9, 
  3.4928371810866003`*^9}},ExpressionUUID->"e51dba6a-7172-4df7-af58-\
196485c9a3ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FFNiso1", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"IsotopeData", "[", 
       RowBox[{
        RowBox[{"ffniso1", "[", 
         RowBox[{"[", 
          RowBox[{"ii", ",", "2"}], "]"}], "]"}], ",", 
        "\"\<StandardName\>\""}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "189"}], "}"}]}], "]"}]}], ";"}], 
  " "}]], "Input",
 CellChangeTimes->{{3.492837777517714*^9, 
  3.4928378250064306`*^9}},ExpressionUUID->"51761045-81f8-4456-b278-\
e7db0665c923"],

Cell[BoxData[
 RowBox[{"FFNiso2", "=", 
  RowBox[{"Prepend", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"IsotopeData", "[", 
       RowBox[{
        RowBox[{"ffniso2", "[", 
         RowBox[{"[", 
          RowBox[{"ii", ",", "2"}], "]"}], "]"}], ",", 
        "\"\<StandardName\>\""}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "2", ",", "189"}], "}"}]}], "]"}], ",", 
    "\"\<Neutron\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.492838891308419*^9, 
  3.492838946234561*^9}},ExpressionUUID->"5fa58271-8d2a-48e4-829a-\
0cfb98c20732"],

Cell[BoxData[
 RowBox[{"A", "=", 
  RowBox[{"Prepend", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"IsotopeData", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ffniso2", "[", 
          RowBox[{"[", "ii", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<AtomicNumber\>\""}], "]"}],
       ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "2", ",", "189"}], "}"}]}], "]"}], ",", "1"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.492835482803464*^9, 3.4928355385626535`*^9}, {
  3.4928361516117177`*^9, 3.4928361518047285`*^9}, {3.492836930863288*^9, 
  3.492836931017297*^9}, {3.4928372744009376`*^9, 3.492837274651952*^9}, {
  3.4928389533099656`*^9, 
  3.4928389650766387`*^9}},ExpressionUUID->"ab9ae850-167b-490c-ac4f-\
07396d65855a"],

Cell[BoxData[
 RowBox[{"Z", "=", 
  RowBox[{"Prepend", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"IsotopeData", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ffniso2", "[", 
          RowBox[{"[", "ii", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<MassNumber\>\""}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "2", ",", "189"}], "}"}]}], "]"}], ",", "0"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.4928359064926977`*^9, 3.4928359073877487`*^9}, {
  3.492836228304104*^9, 3.492836228525117*^9}, {3.4928369345214977`*^9, 
  3.492836934881518*^9}, {3.4928372764440546`*^9, 3.49283727671507*^9}, {
  3.492838971776022*^9, 
  3.492838983446689*^9}},ExpressionUUID->"23123d4d-1363-4abb-af86-\
1a1fd2c7bb60"],

Cell[BoxData[
 RowBox[{"Nn", "=", 
  RowBox[{"Prepend", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"IsotopeData", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ffniso2", "[", 
          RowBox[{"[", "ii", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<NeutronNumber\>\""}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "2", ",", "189"}], "}"}]}], "]"}], ",", "1"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.4928375678097196`*^9, 3.4928375804534426`*^9}, {
  3.4928389900230656`*^9, 
  3.4928390039898643`*^9}},ExpressionUUID->"3583de37-2e8b-4aab-aee5-\
5daab7161d0a"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"FFNiso2", ",", 
          RowBox[{"IsotopeData", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"iz", ",", 
              RowBox[{"iz", "+", "in"}]}], "}"}], ",", 
            "\"\<StandardName\>\""}], "]"}]}], "]"}], "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{"Position", "[", 
        RowBox[{"FFNiso2", ",", 
         RowBox[{"IsotopeData", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"iz", ",", 
             RowBox[{"iz", "+", "in"}]}], "}"}], ",", 
           "\"\<StandardName\>\""}], "]"}]}], "]"}]}], "]"}], "//", "First"}],
     "//", "First"}], ",", 
   RowBox[{"{", 
    RowBox[{"iz", ",", "0", ",", "39"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"in", ",", "0", ",", "39"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.492837654045652*^9, 3.4928377343612456`*^9}, {
  3.492837832155839*^9, 3.492837979749281*^9}, {3.4928384046755857`*^9, 
  3.492838434914315*^9}, {3.4928386648664675`*^9, 3.492838694189145*^9}, {
  3.492838725089912*^9, 3.4928387909566793`*^9}, {3.4928390086311297`*^9, 
  3.492839037008753*^9}},ExpressionUUID->"db36ee0d-2e15-4161-bf4b-\
d1c0dbb613f1"],

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{"18", ",", "%"}], "]"}]], "Input",
 CellChangeTimes->{{3.492838702755635*^9, 
  3.492838715399358*^9}},ExpressionUUID->"593251ca-3af5-4dfa-a664-\
b4cf418e6a02"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.492837646305209*^9, 
  3.492837652630571*^9}},ExpressionUUID->"c3666edd-477a-4dac-a14f-\
7791b0a5f1d6"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.492837597681428*^9, 
  3.4928376097671194`*^9}},ExpressionUUID->"21d3b3cc-390b-44a2-bf7b-\
c2277e590c77"],

Cell[BoxData[
 RowBox[{"nueEnum", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{"iso", ",", 
        RowBox[{"IsotopeData", "[", 
         RowBox[{
          RowBox[{"ffniso1", "[", 
           RowBox[{"[", 
            RowBox[{"ii", ",", "2"}], "]"}], "]"}], ",", 
          "\"\<StandardName\>\""}], "]"}]}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", "1"}], ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "1", ",", "189"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.420185888618153*^9, 3.420185890819214*^9}, {
  3.420194875309742*^9, 3.42019487545518*^9}, {3.420698051508486*^9, 
  3.4206980555019693`*^9}},ExpressionUUID->"09be30cc-0346-4bab-944f-\
fd8a6c6fcb63"],

Cell[BoxData[
 RowBox[{"nuebarEnum", "=", 
  RowBox[{"Insert", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"iso", ",", 
          RowBox[{"IsotopeData", "[", 
           RowBox[{
            RowBox[{"ffniso2", "[", 
             RowBox[{"[", 
              RowBox[{"ii", ",", "2"}], "]"}], "]"}], ",", 
            "\"\<StandardName\>\""}], "]"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", "1"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "2", ",", "189"}], "}"}]}], "]"}], ",", "0", ",", 
    "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.42018509576962*^9, 3.420185155474464*^9}, {
  3.4201852724755163`*^9, 3.420185284050425*^9}, {3.4201854691202374`*^9, 
  3.420185492607573*^9}, {3.420185574470991*^9, 3.420185588492607*^9}, {
  3.420185664589267*^9, 3.420185681460239*^9}, {3.420185748931885*^9, 
  3.4201857561604567`*^9}, {3.4201948520435467`*^9, 3.4201948656854553`*^9}, {
  3.420698067573826*^9, 
  3.420698071087452*^9}},ExpressionUUID->"7e03cd6d-4543-4438-8c45-\
67e2bea804d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nuclideTBL", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"iso", ",", 
          RowBox[{"IsotopeData", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"ii", ",", 
              RowBox[{"ii", "+", "jj"}]}], "}"}], ",", 
            "\"\<StandardName\>\""}], "]"}]}], "]"}], "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"-", "1"}], ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "0", ",", "Zmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "0", ",", "Nmax"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.43048598015625*^9, 
  3.4304860148125*^9}},ExpressionUUID->"97ad2bfa-ca63-4988-873a-af0171cf027b"],

Cell[BoxData[
 RowBox[{"MatrixPlot", "[", "nuclideTBL", "]"}]], "Input",
 CellChangeTimes->{{3.430485989140625*^9, 
  3.430485994296875*^9}},ExpressionUUID->"08ac2f72-b354-4cb6-bd2b-\
264548ab8ee0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FFNnue", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"IsotopeData", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ffniso1", " ", "//", "Transpose"}], " ", "//", "Last"}], 
         ")"}], "[", 
        RowBox[{"[", "ii", "]"}], "]"}], ",", "\"\<Symbol\>\""}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", "189"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.43048654009375*^9, {3.430486596796875*^9, 
   3.4304866058125*^9}},ExpressionUUID->"1eedd566-55c8-469e-b694-\
e5d62902ef5c"],

Cell[BoxData[
 RowBox[{"ffniso2", "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.4304865699375*^9, 
  3.43048657209375*^9}},ExpressionUUID->"dc30c09c-18a1-48e6-8214-\
290e967c243e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FFNnuebar", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"IsotopeData", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ffniso2", " ", "//", "Transpose"}], " ", "//", "Last"}], 
         ")"}], "[", 
        RowBox[{"[", "ii", "]"}], "]"}], ",", "\"\<Symbol\>\""}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "2", ",", "189"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4304865455625*^9, 3.43048654834375*^9}, {
  3.430486609875*^9, 
  3.430486609953125*^9}},ExpressionUUID->"c3e27683-7f46-4719-a2ea-\
848577b40af9"],

Cell[BoxData[""], "Input",ExpressionUUID->"81406e04-59b8-4cc2-9695-5a1b94e0732f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nueTBL", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"FFNnue", ",", 
          RowBox[{"IsotopeData", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"ii", ",", 
              RowBox[{"ii", "+", "jj"}]}], "}"}], ",", "\"\<Symbol\>\""}], 
           "]"}]}], "]"}], "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", "0", ",", "1"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "0", ",", "Zmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "0", ",", "Nmax"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.430485929875*^9, 3.4304859311875*^9}, {
  3.430486049390625*^9, 3.430486073984375*^9}, {3.43048611334375*^9, 
  3.430486116859375*^9}, {3.43048632725*^9, 3.43048632946875*^9}, {
  3.430486768625*^9, 
  3.430486770671875*^9}},ExpressionUUID->"f44517a7-88a4-4bca-bd5d-\
4a84af2ed98b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nuebarTBL", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"FFNnuebar", ",", 
          RowBox[{"IsotopeData", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"ii", ",", 
              RowBox[{"ii", "+", "jj"}]}], "}"}], ",", "\"\<Symbol\>\""}], 
           "]"}]}], "]"}], "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", "0", ",", "2"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "0", ",", "Zmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"jj", ",", "0", ",", "Nmax"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.43048662065625*^9, 3.43048664928125*^9}, {
  3.43048675759375*^9, 3.43048676334375*^9}, {3.430486824203125*^9, 
  3.43048683675*^9}},ExpressionUUID->"cbd92bc9-28ad-4351-9694-7fafe965b3b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nueTBL", "+", "nuebarTBL", "+", "nuclideTBL"}], " ", "//", 
  "TableForm"}]], "Input",
 CellChangeTimes->{{3.430487040578125*^9, 
  3.43048704728125*^9}},ExpressionUUID->"80006343-ac93-4f12-9998-\
1c36aaaa43a6"],

Cell[BoxData[
 RowBox[{"magick", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"9", ",", "8"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"17", ",", "16"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"21", ",", "20"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"29", ",", "28"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"51", ",", "50"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Nmax", "+", "1"}], ",", "Nmax"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.4304911320625*^9, 3.430491169328125*^9}, {
   3.430491221640625*^9, 3.430491307359375*^9}, {3.43049139915625*^9, 
   3.430491409296875*^9}, 
   3.43049149984375*^9},ExpressionUUID->"d36b5143-fc3a-408f-bec6-\
db7459abb1ee"],

Cell[BoxData[
 RowBox[{"MatrixPlot", "[", 
  RowBox[{
   RowBox[{"nueTBL", "+", "nuebarTBL", "+", "nuclideTBL"}], ",", 
   RowBox[{"ColorRules", "->", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "\[Rule]", "White"}], ",", 
      RowBox[{"0", "\[Rule]", "Black"}], ",", 
      RowBox[{"1", "->", "Blue"}], ",", 
      RowBox[{"2", "\[Rule]", "Green"}], ",", 
      RowBox[{"3", "\[Rule]", "Red"}]}], "}"}]}], ",", " ", 
   RowBox[{"DataReversed", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"True", ",", "False"}], "}"}]}], ",", 
   RowBox[{"Mesh", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"FrameTicks", "\[Rule]", 
    RowBox[{"{", " ", 
     RowBox[{"magick", ",", "magick", ",", "None", " ", ",", "None"}], " ", 
     "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.430486078046875*^9, 3.430486082203125*^9}, {
  3.4304863415625*^9, 3.430486345203125*^9}, {3.4304866294375*^9, 
  3.4304867398125*^9}, {3.4304868439375*^9, 3.430486846421875*^9}, {
  3.430486973953125*^9, 3.4304869761875*^9}, {3.430487027328125*^9, 
  3.430487029421875*^9}, {3.43048709446875*^9, 3.43048713303125*^9}, {
  3.430487179296875*^9, 3.430487189484375*^9}, {3.430487221515625*^9, 
  3.430487224375*^9}, {3.43049092121875*^9, 3.430491056046875*^9}, {
  3.430491090625*^9, 
  3.430491148640625*^9}},ExpressionUUID->"357b43b3-e124-4869-8001-\
766cf6226105"],

Cell[BoxData[
 RowBox[{"IsotopeData", "[", "\"\<Properties\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.430486172265625*^9, 
  3.43048617803125*^9}},ExpressionUUID->"8e771171-4cd1-4eca-aed7-\
7fe2f74823b7"],

Cell[BoxData[
 RowBox[{"IsotopeData", "[", 
  RowBox[{
   RowBox[{"iso", "[", 
    RowBox[{"[", "34", "]"}], "]"}], ",", "\"\<Symbol\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.430486135046875*^9, 3.430486165671875*^9}, {
  3.43048621621875*^9, 3.430486216765625*^9}, {3.43048627734375*^9, 
  3.4304862901875*^9}},ExpressionUUID->"0ecf63ef-58ff-4c74-a29b-7e93d2274bde"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.430485936046875*^9, 3.430485961140625*^9}, {
   3.43048624584375*^9, 3.43048632046875*^9}, 
   3.430486521765625*^9},ExpressionUUID->"ffef3e0f-6088-4b0e-a4d0-\
1107b308cbf1"],

Cell[BoxData[
 RowBox[{"IsotopeData", "[", 
  RowBox[{"\"\<Nickel56\>\"", ",", "\"\<FullSymbol\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.492840203246458*^9, 
  3.492840216695227*^9}},ExpressionUUID->"4f928199-2eae-4b81-969e-\
f95c8f446831"]
},
WindowSize->{1269, 727},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
FrontEndVersion->"14.1 for Microsoft Windows (64-bit) (July 16, 2024)",
StyleDefinitions->"Default.nb",
PrivateNotebookOptions -> {"NotebookAuthor" -> ""},
ExpressionUUID->"54351ac8-5be4-6f4d-b9ec-f96522ee181a"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 634, 13, 66, "Input",ExpressionUUID->"19fa1b95-7fd4-43ef-bdfa-c0f2ac877b16"],
Cell[CellGroupData[{
Cell[1216, 37, 200, 3, 28, "Input",ExpressionUUID->"85db82bf-e65c-4e35-904a-30434f00d25b"],
Cell[1419, 42, 275, 6, 32, "Output",ExpressionUUID->"138af5cb-9277-254c-b2e2-a2b750eb236c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1731, 53, 112, 1, 28, "Input",ExpressionUUID->"2efee145-9b28-4183-8f04-019577cea4f8"],
Cell[1846, 56, 212, 3, 32, "Output",ExpressionUUID->"e67b9187-cade-1d49-a539-cd85f24d3396"]
}, Open  ]],
Cell[2073, 62, 756, 15, 28, "Input",ExpressionUUID->"625d2b90-416f-4186-bff5-dee56cfa16be"],
Cell[CellGroupData[{
Cell[2854, 81, 288, 5, 28, "Input",ExpressionUUID->"dff45a32-b0d1-489b-9e1c-dea2d5c48b9a"],
Cell[3145, 88, 205, 3, 32, "Output",ExpressionUUID->"bbf8aa55-b285-0849-a847-fd7fa47061ca"]
}, Open  ]],
Cell[3365, 94, 438, 8, 28, "Input",ExpressionUUID->"3f7dbdb6-6e58-4d88-834e-88d32bea376d"],
Cell[3806, 104, 421, 7, 66, "Input",ExpressionUUID->"966afd46-a483-4947-9682-df6eb40f1746"],
Cell[CellGroupData[{
Cell[4252, 115, 255, 4, 28, "Input",ExpressionUUID->"9f98e6bd-f85f-42e0-9e92-605f9f69e225"],
Cell[4510, 121, 148, 2, 32, "Output",ExpressionUUID->"f85ef974-4cf3-dd45-a8e2-e1e515408232"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4695, 128, 423, 7, 28, "Input",ExpressionUUID->"1d91a6e3-7cca-4e76-85f8-f58a9215a03f"],
Cell[5121, 137, 151, 2, 32, "Output",ExpressionUUID->"d91fe4e0-52b7-f246-ae7e-65adedf23140"]
}, Open  ]],
Cell[5287, 142, 446, 9, 28, "Input",ExpressionUUID->"0d51edc7-8184-4a37-9847-19b91719988e"],
Cell[5736, 153, 1084, 23, 47, "Input",ExpressionUUID->"45c5685b-0d3d-4aa8-ad1d-c80aaa918826"],
Cell[6823, 178, 319, 6, 28, "Input",ExpressionUUID->"495f8663-9ca7-4449-8513-2d1fd459586b"],
Cell[7145, 186, 590, 10, 28, "Input",ExpressionUUID->"be6fb0f6-1e7c-481b-af35-4e706f4766f6"],
Cell[7738, 198, 586, 12, 28, "Input",ExpressionUUID->"9a4aabef-d19c-462b-a81a-bbf658ace73a"],
Cell[8327, 212, 569, 11, 28, "Input",ExpressionUUID->"35bf6b4b-e9ea-46ad-b657-b20afc3b87a1"],
Cell[8899, 225, 639, 17, 28, "Input",ExpressionUUID->"f76e19ed-fa3c-4648-a374-da4ba0c29a9a"],
Cell[CellGroupData[{
Cell[9563, 246, 1034, 16, 28, "Input",ExpressionUUID->"958e0879-2902-40db-9625-585685f2ba52"],
Cell[10600, 264, 151, 2, 32, "Output",ExpressionUUID->"8522951f-e530-f044-9748-ddc1f4dce1a3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10788, 271, 200, 4, 28, "Input",ExpressionUUID->"3c501a2d-a347-4723-a237-d7b8840728dd"],
Cell[10991, 277, 172, 3, 46, "Output",ExpressionUUID->"df5b4939-3ac4-6a45-8133-32820f04b016"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11200, 285, 1405, 29, 104, "Input",ExpressionUUID->"33557eba-f662-4c19-82e7-a4ab4e56f966"],
Cell[12608, 316, 170, 3, 46, "Output",ExpressionUUID->"0a853754-3b76-4e45-b982-8d23a8a56c63"]
}, Open  ]],
Cell[12793, 322, 378, 8, 28, "Input",ExpressionUUID->"a79e13bb-561f-48a7-b756-b1f022b955ab"],
Cell[13174, 332, 535, 14, 28, "Input",ExpressionUUID->"9a289158-98c7-4e86-bf15-25be67babac5"],
Cell[13712, 348, 581, 14, 28, "Input",ExpressionUUID->"6822d631-37db-4a19-b870-68f6f55bd6ef"],
Cell[CellGroupData[{
Cell[14318, 366, 295, 6, 28, "Input",ExpressionUUID->"9fa38111-4217-4bf3-99d7-fcabdde0fe9d"],
Cell[14616, 374, 152, 2, 32, "Output",ExpressionUUID->"e8ccd1f2-27db-9641-990a-9798b169f82b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14805, 381, 376, 8, 28, "Input",ExpressionUUID->"7dbc7269-9c82-4be1-9da1-22474519e46f"],
Cell[15184, 391, 167, 2, 32, "Output",ExpressionUUID->"c372326b-6870-c142-93a5-a2aa7fd55d35"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15388, 398, 204, 3, 28, "Input",ExpressionUUID->"d2bb59fb-bffb-5f48-b136-01672058b5e5"],
Cell[15595, 403, 208, 3, 32, "Output",ExpressionUUID->"7d9cd8fa-7329-0a44-b70f-68b9343a1dee"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15840, 411, 692, 10, 28, "Input",ExpressionUUID->"3b742155-193e-4098-b996-a414f73e69af"],
Cell[16535, 423, 152, 2, 32, "Output",ExpressionUUID->"89506158-ed6b-fe4b-ba24-dac6a9075d1f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16724, 430, 868, 12, 28, "Input",ExpressionUUID->"b783a075-f7cc-49ab-b6bb-bb22e01488d5"],
Cell[17595, 444, 151, 2, 32, "Output",ExpressionUUID->"59083ee8-1634-fb49-bd62-41ddc1f275b5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17783, 451, 623, 12, 28, "Input",ExpressionUUID->"b2e5d326-1e42-4bf5-9274-3b4ce3435d06"],
Cell[18409, 465, 169, 3, 45, "Output",ExpressionUUID->"7834adfc-3676-784d-98f7-15e7189f4cb7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18615, 473, 332, 8, 28, "Input",ExpressionUUID->"a9bb0946-12b7-4a14-9e07-0620236e1c5d"],
Cell[18950, 483, 359, 8, 46, "Output",ExpressionUUID->"6dfaefe4-4e2a-ae4f-b888-abc658f91b0e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19346, 496, 318, 6, 28, "Input",ExpressionUUID->"58042146-a9dc-436d-a5b9-82b887b37f33"],
Cell[19667, 504, 149, 2, 32, "Output",ExpressionUUID->"c7f839b0-8c14-f640-9849-a3133495b569"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19853, 511, 384, 8, 28, "Input",ExpressionUUID->"f17bb2f9-66a3-4369-8f34-4d2e91bb93f9"],
Cell[20240, 521, 173, 2, 32, "Output",ExpressionUUID->"1a80fea9-540b-7647-afc2-3c8ee505714d"]
}, Open  ]],
Cell[20428, 526, 936, 19, 85, "Input",ExpressionUUID->"f1905761-961d-4ff6-b172-7533b88ff9c7"],
Cell[CellGroupData[{
Cell[21389, 549, 480, 12, 28, "Input",ExpressionUUID->"f3cf726c-59ba-4483-b71b-1c1399ee3141"],
Cell[21872, 563, 474, 13, 46, "Output",ExpressionUUID->"1fe1a402-f2b5-5d4b-bffc-406bd14951ff"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22383, 581, 1441, 32, 66, "Input",ExpressionUUID->"12559e9e-40d1-4ee2-a219-ad5696483428"],
Cell[23827, 615, 405, 11, 46, "Output",ExpressionUUID->"45de8a17-c41c-b64d-888e-fda24414d41c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24269, 631, 743, 14, 28, "Input",ExpressionUUID->"64a00a82-8522-462b-99ec-e7fe0332c5b2"],
Cell[25015, 647, 474, 13, 46, "Output",ExpressionUUID->"1a1cd90b-6e51-e742-bbfd-63bf4d067c35"]
}, Open  ]],
Cell[25504, 663, 1110, 26, 28, "Input",ExpressionUUID->"2916ffd7-df2c-45ea-9a0c-103334a7d6f9"],
Cell[CellGroupData[{
Cell[26639, 693, 1375, 29, 28, "Input",ExpressionUUID->"2687c39e-0fc6-41ef-a6e2-cdb956b7bb49"],
Cell[28017, 724, 1093, 31, 46, "Output",ExpressionUUID->"f78b9869-35d9-5b47-8cc0-c11ae72261dd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29147, 760, 363, 7, 28, "Input",ExpressionUUID->"74a7e304-4a15-4041-a965-67aad3d70727"],
Cell[29513, 769, 152, 2, 32, "Output",ExpressionUUID->"e21810ff-0fc3-d543-a9aa-9fa807f22574"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29702, 776, 283, 5, 28, "Input",ExpressionUUID->"af775fd8-e782-477c-9c21-4cc8a47aa251"],
Cell[29988, 783, 329, 4, 51, "Output",ExpressionUUID->"01697e5b-ec53-9442-9f87-6b652fa13a2f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30354, 792, 375, 8, 28, "Input",ExpressionUUID->"d37c07c8-8bde-47ef-8bf1-2243cdf550f8"],
Cell[30732, 802, 169, 2, 32, "Output",ExpressionUUID->"87c251fa-54bc-6c47-95d7-38db42b18381"]
}, Open  ]],
Cell[30916, 807, 3637, 67, 161, "Input",ExpressionUUID->"ba9f117c-4650-4d8d-93bd-3d2da80073e7"],
Cell[34556, 876, 1071, 22, 47, "Input",ExpressionUUID->"544755f9-9350-4891-8737-d37b53410fbe"],
Cell[35630, 900, 1314, 25, 66, "Input",ExpressionUUID->"4f289380-687b-412d-9249-d853ee800a46"],
Cell[36947, 927, 1944, 34, 85, "Input",ExpressionUUID->"3484365f-e60a-469b-bfd3-8078ac3cb9b0"],
Cell[38894, 963, 743, 18, 47, "Input",ExpressionUUID->"f229cc15-e2ca-4f0e-a0ce-fd3278d4dd89"],
Cell[39640, 983, 352, 7, 28, "Input",ExpressionUUID->"ef40f7ac-a719-4b1f-84e4-ef1a6968dbd0"],
Cell[CellGroupData[{
Cell[40017, 994, 226, 3, 28, "Input",ExpressionUUID->"7db0ab35-aa96-c74a-a70d-e7e6cf4b5d62"],
Cell[40246, 999, 343, 7, 39, "Output",ExpressionUUID->"bcb501a1-8289-6e43-b38b-dbd41c743b7e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40626, 1011, 710, 16, 28, "Input",ExpressionUUID->"3ade79c2-29a0-4834-bd24-0a269b1fb0a8"],
Cell[41339, 1029, 514, 11, 26, "Message",ExpressionUUID->"17f0bdfe-716d-7a41-9687-0e859dd2261d"],
Cell[41856, 1042, 514, 11, 26, "Message",ExpressionUUID->"ef0bc72f-bdfd-e344-a019-4be722bc9dbb"],
Cell[42373, 1055, 817, 19, 40, "Output",ExpressionUUID->"09874259-bf0c-8d4d-92ed-552ffdaf0268"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43227, 1079, 213, 3, 28, "Input",ExpressionUUID->"cef6f9b6-59a7-a14d-9450-8224c3153f24"],
Cell[43443, 1084, 254, 5, 32, "Output",ExpressionUUID->"16a29f24-b768-6842-a66d-daecaddd68de"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43734, 1094, 224, 4, 28, "Input",ExpressionUUID->"3c717ba3-efa0-4050-81c4-44a0cc5a4b6a"],
Cell[43961, 1100, 173, 2, 32, "Output",ExpressionUUID->"10363e18-46b8-5a49-9972-b5dda9048ce1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44171, 1107, 386, 8, 28, "Input",ExpressionUUID->"89f62592-fdb0-4e31-a574-062869f3f86c"],
Cell[44560, 1117, 151, 2, 32, "Output",ExpressionUUID->"5bfcdfc0-eb43-7d43-a716-5f3588897018"]
}, Open  ]],
Cell[44726, 1122, 639, 12, 66, "Input",ExpressionUUID->"d7bc3acf-7edd-4d2c-9dca-f26351fab7c8"],
Cell[CellGroupData[{
Cell[45390, 1138, 778, 20, 36, "Input",ExpressionUUID->"d29fd791-87fa-4ad6-8158-9fb3363ebbe4"],
Cell[46171, 1160, 842, 16, 27, "Message",ExpressionUUID->"d7512921-8578-5540-a4e4-b10a9e88e69e"],
Cell[47016, 1178, 844, 16, 27, "Message",ExpressionUUID->"ef8820e7-260e-5a4a-a001-45fb05e4f815"],
Cell[47863, 1196, 206, 4, 32, "Output",ExpressionUUID->"531008b9-46f5-7444-acb3-90a2ea6a232d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48106, 1205, 727, 19, 36, "Input",ExpressionUUID->"3f2eae96-94a2-4fd4-b0c1-ec149985eb45"],
Cell[48836, 1226, 841, 16, 27, "Message",ExpressionUUID->"51dd2b99-b803-ab4a-baf5-b9b5bd265b85"],
Cell[49680, 1244, 842, 16, 27, "Message",ExpressionUUID->"6c695c90-816a-bb48-893e-bddfd38151ae"],
Cell[50525, 1262, 206, 4, 32, "Output",ExpressionUUID->"cf2cb262-ad84-314a-87c7-7a38cd8ea98b"]
}, Open  ]],
Cell[50746, 1269, 865, 26, 47, "Input",ExpressionUUID->"2565439b-ce1a-4475-8b7d-456f124af098"],
Cell[CellGroupData[{
Cell[51636, 1299, 601, 17, 47, "Input",ExpressionUUID->"4f4bd7a0-746a-4782-a6c5-224e5987f681"],
Cell[52240, 1318, 149, 2, 32, "Output",ExpressionUUID->"b3e9ebf7-31ce-8147-9ae2-51479a3612cb"],
Cell[52392, 1322, 149, 2, 32, "Output",ExpressionUUID->"d56e363d-2218-b749-971c-544a9e27c4da"]
}, Open  ]],
Cell[52556, 1327, 1750, 30, 199, "Input",ExpressionUUID->"d9a6acd2-7eae-4fe3-ba8e-60b6ebead0e6"],
Cell[CellGroupData[{
Cell[54331, 1361, 392, 8, 28, "Input",ExpressionUUID->"f768f217-23f7-4dcb-9c17-92b832086012"],
Cell[54726, 1371, 170, 2, 32, "Output",ExpressionUUID->"2ad2aa4d-fba5-424f-aa3a-69aa92db1f95"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54933, 1378, 1208, 34, 47, "Input",ExpressionUUID->"74be6161-1949-4da0-b038-9a3957125ce9"],
Cell[56144, 1414, 355, 11, 32, "Output",ExpressionUUID->"ee94197b-b4bf-1b4d-a67d-261f723214d7"]
}, Open  ]],
Cell[56514, 1428, 369, 11, 28, "Input",ExpressionUUID->"e1ca29ed-6aa9-4acf-9ea5-14c001f90b23"],
Cell[56886, 1441, 195, 4, 28, "Input",ExpressionUUID->"de1e77a3-6cf0-4df8-b82e-667a6a7babc5"],
Cell[57084, 1447, 159, 3, 28, "Input",ExpressionUUID->"653822bf-a4ac-4663-b7b0-79379c127c82"],
Cell[57246, 1452, 394, 11, 28, "Input",ExpressionUUID->"483aead0-894a-4afd-81ee-5b31b6a43073"],
Cell[57643, 1465, 202, 5, 28, "Input",ExpressionUUID->"16e5f2ae-9045-4b8c-a337-cad91f474066"],
Cell[57848, 1472, 197, 4, 28, "Input",ExpressionUUID->"afb460e5-52ac-4db8-8ac3-a5b9539f6a05"],
Cell[58048, 1478, 732, 22, 28, "Input",ExpressionUUID->"81ddc5a1-f4bf-4db5-bb2b-9e8669c2d162"],
Cell[CellGroupData[{
Cell[58805, 1504, 799, 20, 47, "Input",ExpressionUUID->"23449f0d-e12a-4628-a3c7-4f507a17c05a"],
Cell[59607, 1526, 2190, 52, 382, "Output",ExpressionUUID->"c98746e2-0366-8343-84d8-c8b74d597174"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61834, 1583, 311, 5, 28, "Input",ExpressionUUID->"1fe8c5a0-8515-4979-91d9-d251e18ae62a"],
Cell[62148, 1590, 180, 2, 32, "Output",ExpressionUUID->"857c133a-3e6b-ac4b-af8b-df94bf55ec13"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62365, 1597, 224, 3, 28, "Input",ExpressionUUID->"1e86d045-429b-4b45-9af2-02899ef37421"],
Cell[62592, 1602, 194, 4, 32, "Output",ExpressionUUID->"9123c687-e6b8-5845-bca9-d1273ed8e600"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62823, 1611, 295, 6, 28, "Input",ExpressionUUID->"fb04fffa-6713-40fc-9a4b-ac43e88ecfca"],
Cell[63121, 1619, 172, 2, 32, "Output",ExpressionUUID->"6b079698-b3e1-5441-9610-73270d4ccb41"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63330, 1626, 711, 15, 28, "Input",ExpressionUUID->"98974bbe-cc28-184e-a8d4-ea9e801c7ec2"],
Cell[64044, 1643, 274, 5, 45, "Output",ExpressionUUID->"c62c3928-a04c-7944-9a28-0dd770499965"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64355, 1653, 1735, 46, 85, "Input",ExpressionUUID->"67de780d-a442-4a31-bffb-451a415aaeac"],
Cell[66093, 1701, 862, 21, 45, "Output",ExpressionUUID->"e9a63c72-885a-d344-a1b2-7bcd8b888601"]
}, Open  ]],
Cell[66970, 1725, 890, 17, 28, "Input",ExpressionUUID->"689276b1-576d-4ab7-9134-f68a9f6122e2"],
Cell[67863, 1744, 346, 7, 28, "Input",ExpressionUUID->"9f043391-9cd9-4283-bd08-9d9da646bc1c"],
Cell[68212, 1753, 584, 12, 28, "Input",ExpressionUUID->"a2292547-1fb4-41f8-87e5-5a8a9a48239d"],
Cell[68799, 1767, 285, 6, 28, "Input",ExpressionUUID->"a156b7eb-e2f8-4a35-9192-41a03415e363"],
Cell[CellGroupData[{
Cell[69109, 1777, 365, 10, 28, "Input",ExpressionUUID->"cfdfafbb-2242-4d1f-a661-67456d7f30c6"],
Cell[69477, 1789, 444, 8, 32, "Output",ExpressionUUID->"a33b1f33-a702-9845-ac2a-852601e91f2f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69958, 1802, 192, 4, 28, "Input",ExpressionUUID->"b3f44829-109b-4a03-a245-e289c820ed35"],
Cell[70153, 1808, 292, 9, 46, "Output",ExpressionUUID->"750106a5-0b4b-9242-9d7a-399a16cf65a6"]
}, Open  ]],
Cell[70460, 1820, 844, 23, 28, "Input",ExpressionUUID->"fb836d59-b682-4b6d-abd7-237271c11c32"],
Cell[71307, 1845, 928, 23, 28, "Input",ExpressionUUID->"5f020eb9-ac8d-42b4-a0f6-09dd906d3dd6"],
Cell[72238, 1870, 2462, 59, 142, "Input",ExpressionUUID->"bdd32276-5739-4b27-bb7c-22531ebc6ae8"],
Cell[74703, 1931, 339, 7, 28, "Input",ExpressionUUID->"e8a88925-83c6-4b25-8c4c-a6fbc69412c5"],
Cell[CellGroupData[{
Cell[75067, 1942, 110, 1, 28, "Input",ExpressionUUID->"785050c0-b1db-4a0b-97ce-675460795977"],
Cell[75180, 1945, 647, 18, 46, "Output",ExpressionUUID->"6dd86b8e-1562-d446-adb5-f072e831be6f"]
}, Open  ]],
Cell[75842, 1966, 1080, 33, 28, "Input",ExpressionUUID->"401ea1e9-2f78-4fb9-80b1-fa6a487d7bb8"],
Cell[CellGroupData[{
Cell[76947, 2003, 360, 8, 28, "Input",ExpressionUUID->"d69aeabd-3454-4ba0-8329-3b6f208289b3"],
Cell[77310, 2013, 225649, 3733, 111, "Output",ExpressionUUID->"e5d7a905-29e6-6143-af46-7dbcbde776f3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[302996, 5751, 334, 6, 28, "Input",ExpressionUUID->"0eb66dd9-5e7a-40ee-9510-10741d05e3f7"],
Cell[303333, 5759, 338, 12, 32, "Output",ExpressionUUID->"ed8c974d-8786-9741-ba13-7e35c0c1143b"]
}, Open  ]],
Cell[303686, 5774, 1123, 25, 28, "Input",ExpressionUUID->"d1b9197f-7429-4300-a7cf-68922798413f"],
Cell[CellGroupData[{
Cell[304834, 5803, 305, 5, 28, "Input",ExpressionUUID->"ca068040-38c3-4a45-a44e-e47bdae99306"],
Cell[305142, 5810, 171, 2, 32, "Output",ExpressionUUID->"bee0307d-c5fc-104d-bbc9-c38839c45433"]
}, Open  ]],
Cell[305328, 5815, 275, 5, 28, "Input",ExpressionUUID->"c9a2f208-efd9-4acd-8488-f6482d16d226"],
Cell[305606, 5822, 848, 16, 28, "Input",ExpressionUUID->"f471049e-1f78-4768-b581-f23806df58dc"],
Cell[306457, 5840, 479, 10, 28, "Input",ExpressionUUID->"f0aea786-c385-4a0c-a169-c7de6764ee17"],
Cell[CellGroupData[{
Cell[306961, 5854, 143, 2, 28, "Input",ExpressionUUID->"0cd44265-c4f3-404e-95c8-6036e74a0790"],
Cell[307107, 5858, 195, 4, 32, "Output",ExpressionUUID->"d6714cf8-812e-db4d-96d6-892ccc2e3505"]
}, Open  ]],
Cell[307317, 5865, 1998, 45, 28, "Input",ExpressionUUID->"7885d1b9-89ef-423f-a679-f4ce63ce9268"],
Cell[309318, 5912, 584, 14, 28, "Input",ExpressionUUID->"6e3f1abd-f505-4bad-931e-5e49783b8c5f"],
Cell[309905, 5928, 784, 18, 28, "Input",ExpressionUUID->"76f2bf66-757b-4929-bcde-7f908c834b08"],
Cell[310692, 5948, 1195, 25, 28, "Input",ExpressionUUID->"b925c1a2-5e7e-43b1-8737-27d06ea2bbdf"],
Cell[311890, 5975, 810, 21, 28, "Input",ExpressionUUID->"81ec461a-df91-47c5-8740-ada1be421a83"],
Cell[312703, 5998, 797, 19, 85, "Input",ExpressionUUID->"b610b8d5-754c-404a-ba0e-19b949d66c67"],
Cell[CellGroupData[{
Cell[313525, 6021, 941, 21, 28, "Input",ExpressionUUID->"a9a98d20-ff5c-4481-99b5-5fc95010c787"],
Cell[314469, 6044, 390, 8, 32, "Output",ExpressionUUID->"0c417e56-e192-4444-a11a-18280f675cd7"]
}, Open  ]],
Cell[314874, 6055, 398, 10, 28, "Input",ExpressionUUID->"5c11e795-cdbd-4ad0-8025-df976cd91427"],
Cell[CellGroupData[{
Cell[315297, 6069, 313, 7, 28, "Input",ExpressionUUID->"269df7e5-188e-4d8b-8c8b-88c17106f9d9"],
Cell[315613, 6078, 156, 3, 32, "Output",ExpressionUUID->"51e8fcae-6677-6e45-a028-d16da12fa0c9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[315806, 6086, 637, 17, 28, "Input",ExpressionUUID->"60654657-3182-401c-a386-98fd12af3046"],
Cell[316446, 6105, 560, 17, 32, "Output",ExpressionUUID->"96493d81-998c-304e-b1ff-79514aa69784"]
}, Open  ]],
Cell[CellGroupData[{
Cell[317043, 6127, 351, 8, 28, "Input",ExpressionUUID->"ad100360-6b75-46f1-a1e7-ada87b575ec5"],
Cell[317397, 6137, 166, 3, 32, "Output",ExpressionUUID->"0f660b3f-c842-2f4a-80d8-bff184e64b8f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[317600, 6145, 328, 9, 28, "Input",ExpressionUUID->"cc2e1e5c-1ead-4c77-804b-50bd518f3e77"],
Cell[317931, 6156, 178, 3, 32, "Output",ExpressionUUID->"195003d8-1c8e-0e40-8e6b-7da1584a49b8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[318146, 6164, 713, 18, 28, "Input",ExpressionUUID->"9a3cee2b-e1cf-483a-a522-2b3250be2857"],
Cell[318862, 6184, 15897, 335, 250, "Output",ExpressionUUID->"5db50ee0-212c-d341-a5bb-a4c69fed3d58"]
}, Open  ]],
Cell[CellGroupData[{
Cell[334796, 6524, 732, 16, 28, "Input",ExpressionUUID->"52853832-38b5-4a97-8877-8cf82d10793b"],
Cell[335531, 6542, 208, 5, 32, "Output",ExpressionUUID->"934b3e77-5ae2-9845-8861-f4235fab7dfd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[335776, 6552, 657, 15, 28, "Input",ExpressionUUID->"cecd6ba1-75da-4ef8-a120-4bc73134910f"],
Cell[336436, 6569, 208, 5, 32, "Output",ExpressionUUID->"230fafb2-cce8-834f-aaae-f947f02012ba"]
}, Open  ]],
Cell[336659, 6577, 705, 16, 28, "Input",ExpressionUUID->"31d24fc9-c508-4669-8242-1c92ea190195"],
Cell[337367, 6595, 975, 23, 28, "Input",ExpressionUUID->"53e641d9-0458-4d68-9261-f0b65784bde5"],
Cell[CellGroupData[{
Cell[338367, 6622, 2000, 43, 123, "Input",ExpressionUUID->"b10b0198-91a7-4908-9acd-02be13faa124"],
Cell[340370, 6667, 170, 3, 32, "Output",ExpressionUUID->"1d02922f-1b1d-1840-95da-11d2b9b5096a"],
Cell[340543, 6672, 172, 3, 32, "Output",ExpressionUUID->"e45e38c7-6c4f-2044-878c-7d63c073bd06"],
Cell[340718, 6677, 172, 3, 32, "Output",ExpressionUUID->"76cb72e6-032d-c54a-8737-c45a29dc96bd"],
Cell[340893, 6682, 169, 3, 32, "Output",ExpressionUUID->"e52dfa69-294c-1e4f-9767-d1ec16fc86ac"],
Cell[341065, 6687, 171, 3, 32, "Output",ExpressionUUID->"ee9d213e-69ab-2145-bc5e-62cda912c794"]
}, Open  ]],
Cell[CellGroupData[{
Cell[341273, 6695, 424, 9, 28, "Input",ExpressionUUID->"21f0dbb9-094d-461f-896c-d2c2e9815ea0"],
Cell[341700, 6706, 174, 3, 32, "Output",ExpressionUUID->"148566dd-4147-364d-9baa-36fd5ad8be92"]
}, Open  ]],
Cell[341889, 6712, 1786, 47, 85, "Input",ExpressionUUID->"af11f8f5-aeba-4c9c-962f-71782682b8c9"],
Cell[CellGroupData[{
Cell[343700, 6763, 389, 9, 28, "Input",ExpressionUUID->"a2ce1441-854b-4f27-a388-8652522936f4"],
Cell[344092, 6774, 309, 6, 32, "Output",ExpressionUUID->"c2c6a60d-ee99-8547-bf91-7abc003e2a45"]
}, Open  ]],
Cell[CellGroupData[{
Cell[344438, 6785, 215, 4, 28, "Input",ExpressionUUID->"ef4e35a3-ff55-4c1e-987e-6f90ba3c111e"],
Cell[344656, 6791, 170, 3, 32, "Output",ExpressionUUID->"f091b302-2c52-e042-8f21-7bf95d39005f"]
}, Open  ]],
Cell[344841, 6797, 278, 6, 28, "Input",ExpressionUUID->"6af85109-d19d-46be-84a9-434cc0b458bc"],
Cell[CellGroupData[{
Cell[345144, 6807, 400, 11, 28, "Input",ExpressionUUID->"cc8f9808-bf0b-49c9-a657-61f0a96112d6"],
Cell[345547, 6820, 361, 8, 53, "Output",ExpressionUUID->"fd93f521-195c-a64d-b385-3f6c4ce19d43"]
}, Open  ]],
Cell[345923, 6831, 244, 5, 28, "Input",ExpressionUUID->"24b66ac9-7982-4353-86c5-f29fda748d91"],
Cell[346170, 6838, 2796, 67, 123, "Input",ExpressionUUID->"14b97858-2a6a-470a-8174-81d7cd4da9f8"],
Cell[CellGroupData[{
Cell[348991, 6909, 160, 4, 28, "Input",ExpressionUUID->"3048bc88-f706-43d2-a5c0-889d04de48ad"],
Cell[349154, 6915, 13658, 278, 76, "Output",ExpressionUUID->"8d68b97e-5f69-6b48-8531-8a731605b1ac"]
}, Open  ]],
Cell[362827, 7196, 309, 7, 28, "Input",ExpressionUUID->"161d34b7-ec5a-40e5-9443-4588fdf678cb"],
Cell[363139, 7205, 855, 19, 28, "Input",ExpressionUUID->"d450a635-fb76-4934-8be0-aedbcbb4de32"],
Cell[363997, 7226, 247, 5, 28, "Input",ExpressionUUID->"1bdb74a0-0bed-44d5-b27f-030ca7a97618"],
Cell[364247, 7233, 959, 24, 28, "Input",ExpressionUUID->"f72fd286-a406-41f1-b0a2-54bcdf31ba69"],
Cell[365209, 7259, 1007, 26, 47, "Input",ExpressionUUID->"fe057f95-352e-44a8-b1f4-152417079543"],
Cell[366219, 7287, 1120, 25, 28, "Input",ExpressionUUID->"e19eb766-d1c4-4b44-8290-5183287582ee"],
Cell[367342, 7314, 804, 19, 28, "Input",ExpressionUUID->"11a5772a-001f-408b-ac0c-23c3866ce907"],
Cell[CellGroupData[{
Cell[368171, 7337, 211, 4, 28, "Input",ExpressionUUID->"10800f08-d99e-4fd3-9329-8c0b76220c69"],
Cell[368385, 7343, 211, 5, 32, "Output",ExpressionUUID->"9492ac02-ac65-f34b-bec4-fde6c7dcf8fb"]
}, Open  ]],
Cell[368611, 7351, 558, 12, 28, "Input",ExpressionUUID->"b3ebcdbe-e53d-4254-870c-3ec724da9fa6"],
Cell[369172, 7365, 456, 10, 28, "Input",ExpressionUUID->"977f4b72-13b1-49fb-b450-ad0802e0fcda"],
Cell[369631, 7377, 456, 10, 28, "Input",ExpressionUUID->"50ab60c5-3335-491a-85f0-93f8b43148d8"],
Cell[370090, 7389, 447, 10, 28, "Input",ExpressionUUID->"89ea6c85-3890-448c-b17c-fafa7160dece"],
Cell[370540, 7401, 765, 16, 28, "Input",ExpressionUUID->"0b2bdab9-cdce-47e4-bff4-643abe760210"],
Cell[CellGroupData[{
Cell[371330, 7421, 10944, 240, 427, "Input",ExpressionUUID->"951c8572-060c-44fa-b448-d198cdb948fa"],
Cell[382277, 7663, 1389, 31, 108, "Output",ExpressionUUID->"513d5048-c3dc-ba44-8d7c-a060ce9351f2"]
}, Open  ]],
Cell[383681, 7697, 875, 24, 47, "Input",ExpressionUUID->"c60b8915-5945-4f15-9c06-1786bbe38521"],
Cell[CellGroupData[{
Cell[384581, 7725, 1980, 55, 66, "Input",ExpressionUUID->"4bcfa3f5-9d68-4c16-b583-071ee082450f"],
Cell[386564, 7782, 186, 3, 32, "Output",ExpressionUUID->"01cb201e-cbad-4d40-92e4-ae20a4f7bb44"]
}, Open  ]],
Cell[386765, 7788, 826, 24, 47, "Input",ExpressionUUID->"75d2164b-9aca-4996-b1e5-5d60b126a031"],
Cell[387594, 7814, 1798, 48, 28, "Input",ExpressionUUID->"87678e99-72ea-4557-bb47-ceea3fff094f"],
Cell[389395, 7864, 694, 14, 28, "Input",ExpressionUUID->"6cca4b53-428e-43f9-abe8-b5d928ec2399"],
Cell[390092, 7880, 401, 10, 28, "Input",ExpressionUUID->"d10da448-3990-41e9-893b-4f95331a9e3a"],
Cell[CellGroupData[{
Cell[390518, 7894, 2009, 56, 66, "Input",ExpressionUUID->"fe38530b-ec26-44a1-ad0a-e76b13181b28"],
Cell[392530, 7952, 184, 3, 32, "Output",ExpressionUUID->"ddeb5d8b-7f0c-164c-9b6f-d870225c1bd7"]
}, Open  ]],
Cell[392729, 7958, 1245, 27, 28, "Input",ExpressionUUID->"553f8818-9400-4fc1-828b-3b17d1bf5aae"],
Cell[CellGroupData[{
Cell[393999, 7989, 216, 4, 28, "Input",ExpressionUUID->"bfeada03-8ac2-4be5-8e3c-3e10f2f8bc49"],
Cell[394218, 7995, 200, 5, 32, "Output",ExpressionUUID->"784452e2-2195-bf43-acfd-f3dcd268f574"]
}, Open  ]],
Cell[CellGroupData[{
Cell[394455, 8005, 253, 6, 28, "Input",ExpressionUUID->"5ae8ca1d-0cfd-4e07-a4e8-bb794fdd2aef"],
Cell[394711, 8013, 189, 3, 32, "Output",ExpressionUUID->"84c5569e-d855-a14f-9764-f97417f9797a"]
}, Open  ]],
Cell[394915, 8019, 321, 7, 28, "Input",ExpressionUUID->"07ad8e44-2019-4b35-b866-ba127688f30a"],
Cell[395239, 8028, 1142, 30, 28, "Input",ExpressionUUID->"caee246d-ff93-4ed1-8355-4928fbe55043"],
Cell[CellGroupData[{
Cell[396406, 8062, 215, 4, 28, "Input",ExpressionUUID->"5b196356-06d9-405b-9d5d-b15d4482141f"],
Cell[396624, 8068, 211, 5, 32, "Output",ExpressionUUID->"594d39cb-4ad1-e949-97ed-d483e3279c95"]
}, Open  ]],
Cell[CellGroupData[{
Cell[396872, 8078, 918, 18, 28, "Input",ExpressionUUID->"07d8f4a1-6ea2-4ddb-8a8d-71a3666cdc22"],
Cell[397793, 8098, 350, 12, 46, "Output",ExpressionUUID->"0f72a490-37d3-454b-9b3e-f0fca863cbfd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[398180, 8115, 457, 12, 28, "Input",ExpressionUUID->"65dd366c-57fd-4e1f-8896-c55ccc5da431"],
Cell[398640, 8129, 158, 3, 32, "Output",ExpressionUUID->"4788063c-c883-0a45-8026-01192ba7fa49"]
}, Open  ]],
Cell[CellGroupData[{
Cell[398835, 8137, 1478, 42, 28, "Input",ExpressionUUID->"d3adb5a1-9b29-4350-a35b-008120cddb68"],
Cell[400316, 8181, 157, 3, 32, "Output",ExpressionUUID->"9b9f18f1-364f-de4f-bdf3-b4dec5b1e5ed"]
}, Open  ]],
Cell[CellGroupData[{
Cell[400510, 8189, 227, 4, 28, "Input",ExpressionUUID->"b9ce807d-191f-4ba5-bbbe-889847453a89"],
Cell[400740, 8195, 173, 3, 32, "Output",ExpressionUUID->"cb431ab1-1b92-6244-b0bc-7e3c3cc0ff18"]
}, Open  ]],
Cell[CellGroupData[{
Cell[400950, 8203, 449, 11, 28, "Input",ExpressionUUID->"24453626-036a-46e5-abd4-67a85069342b"],
Cell[401402, 8216, 165, 3, 32, "Output",ExpressionUUID->"65ed4d96-c99a-dc4d-9a6a-6569879664dc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[401604, 8224, 3015, 72, 85, "Input",ExpressionUUID->"6ce59430-8cf6-410c-9252-edbf7f137133"],
Cell[404622, 8298, 11717, 227, 203, "Output",ExpressionUUID->"88b89135-2d86-b144-9987-7274107df197"]
}, Open  ]],
Cell[CellGroupData[{
Cell[416376, 8530, 414, 11, 28, "Input",ExpressionUUID->"bd5cae24-87a6-47f1-b0cd-9f8cbc8829b7"],
Cell[416793, 8543, 168, 3, 32, "Output",ExpressionUUID->"d33808da-4725-aa42-823e-23cb69fb2788"]
}, Open  ]],
Cell[416976, 8549, 539, 12, 28, "Input",ExpressionUUID->"88273c22-ac60-47c6-979b-75062c0937d1"],
Cell[CellGroupData[{
Cell[417540, 8565, 4306, 118, 237, "Input",ExpressionUUID->"8438e8bd-4b91-4fea-8265-f2ee62c629c7"],
Cell[CellGroupData[{
Cell[421871, 8687, 206, 4, 39, "Print",ExpressionUUID->"0eeae978-b832-d144-8269-4a0fae24229a"],
Cell[422080, 8693, 204, 4, 39, "Print",ExpressionUUID->"2a840f15-e062-1846-8615-efeb88659e89"],
Cell[422287, 8699, 206, 4, 39, "Print",ExpressionUUID->"b2fadf3a-6c32-0340-9b31-bfe858426d37"],
Cell[422496, 8705, 206, 4, 39, "Print",ExpressionUUID->"c3d90e85-6f98-024a-bedd-51dbcb834d33"],
Cell[422705, 8711, 206, 4, 39, "Print",ExpressionUUID->"c3bba82a-ecc6-a044-bbc3-d39341ebd61f"],
Cell[422914, 8717, 204, 4, 39, "Print",ExpressionUUID->"136b1959-64bf-e84c-b445-a9be15c03d40"],
Cell[423121, 8723, 204, 4, 39, "Print",ExpressionUUID->"f0fc3b0a-e84e-6042-8c2a-749813630df2"],
Cell[423328, 8729, 204, 4, 39, "Print",ExpressionUUID->"bbceac5e-8d5e-a241-8dfe-fab97d30e3c3"],
Cell[423535, 8735, 204, 4, 39, "Print",ExpressionUUID->"757ba077-3e07-5f4e-8cf5-522653ca6d3c"],
Cell[423742, 8741, 206, 4, 39, "Print",ExpressionUUID->"40219333-fac0-9e4d-b40d-8027c969ff9f"],
Cell[423951, 8747, 206, 4, 39, "Print",ExpressionUUID->"056a6e3a-87dd-d647-b386-be0e094bc27e"],
Cell[424160, 8753, 204, 4, 39, "Print",ExpressionUUID->"d1876375-7386-7044-95bb-def3f2786e53"],
Cell[424367, 8759, 204, 4, 39, "Print",ExpressionUUID->"f6371986-beb7-cc4b-a407-628667155dba"],
Cell[424574, 8765, 204, 4, 39, "Print",ExpressionUUID->"3591a585-a2c0-1143-bc74-f0ee1d7f8be9"],
Cell[424781, 8771, 206, 4, 39, "Print",ExpressionUUID->"0b7327fe-a397-504a-8ed2-a354ea5d16fd"],
Cell[424990, 8777, 204, 4, 39, "Print",ExpressionUUID->"897f4306-0c51-8c4f-b846-489b63262f0f"],
Cell[425197, 8783, 204, 4, 39, "Print",ExpressionUUID->"9186fc27-4454-ff40-aba6-82361f445b3b"],
Cell[425404, 8789, 206, 4, 39, "Print",ExpressionUUID->"962ca79d-3102-b64f-844f-bfacb41acc10"],
Cell[425613, 8795, 204, 4, 39, "Print",ExpressionUUID->"54846a79-4667-1947-b403-94fa91e85d70"],
Cell[425820, 8801, 206, 4, 39, "Print",ExpressionUUID->"9a0a42e2-694a-2548-9c89-e6ac7eca4a93"],
Cell[426029, 8807, 204, 4, 39, "Print",ExpressionUUID->"abc77b3c-8009-9e45-8e75-c2a6dfea17b3"],
Cell[426236, 8813, 204, 4, 39, "Print",ExpressionUUID->"478890c5-841a-5647-9688-060ab32627b1"],
Cell[426443, 8819, 206, 4, 39, "Print",ExpressionUUID->"b3583f93-26bd-ae4a-9b9c-486781477c13"],
Cell[426652, 8825, 206, 4, 39, "Print",ExpressionUUID->"c2db6ca9-7acb-6e49-aa22-7348fee024e7"],
Cell[426861, 8831, 206, 4, 39, "Print",ExpressionUUID->"36575fd9-798a-854c-aac2-59f042592a69"],
Cell[427070, 8837, 206, 4, 39, "Print",ExpressionUUID->"c8e5c2ad-0478-184b-8975-91e18c1c67f3"],
Cell[427279, 8843, 206, 4, 39, "Print",ExpressionUUID->"9b2a8b9d-b62c-054e-9c65-29dd95043928"],
Cell[427488, 8849, 204, 4, 39, "Print",ExpressionUUID->"1fd5ae68-a8e1-5040-879b-09e1ee868084"],
Cell[427695, 8855, 206, 4, 39, "Print",ExpressionUUID->"c3b3f6f7-29f4-7f49-bef7-5248e61c90db"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[427950, 8865, 214, 4, 28, "Input",ExpressionUUID->"719a1ae9-24e0-4ff5-b841-bb8e2d3c7a11"],
Cell[428167, 8871, 163, 3, 32, "Output",ExpressionUUID->"7ef1d919-f897-064f-9b4b-e65c01021126"]
}, Open  ]],
Cell[428345, 8877, 4106, 122, 256, "Input",ExpressionUUID->"6c3611a1-ff97-4eab-aaa0-31dbac26fff5"],
Cell[432454, 9001, 408, 8, 104, "Input",ExpressionUUID->"5343d982-089c-4350-a08b-29f1570bcd63"],
Cell[432865, 9011, 203, 4, 28, "Input",ExpressionUUID->"595bc42f-5250-4028-b8ee-7622d50c49cd"],
Cell[433071, 9017, 588, 14, 47, "Input",ExpressionUUID->"2c76fb9a-2909-4519-b41d-26ccb27af502"],
Cell[433662, 9033, 388, 9, 28, "Input",ExpressionUUID->"2c2ddb85-957f-493d-83eb-fcb040c71311"],
Cell[434053, 9044, 684, 19, 28, "Input",ExpressionUUID->"d038852a-8bfd-4e91-a209-a239a4e4136b"],
Cell[434740, 9065, 1488, 42, 47, "Input",ExpressionUUID->"e939b264-8a10-4266-b252-6236323c039c"],
Cell[436231, 9109, 596, 15, 28, "Input",ExpressionUUID->"64a806fd-7f44-43f3-a165-18ae1c35724e"],
Cell[436830, 9126, 213, 5, 28, "Input",ExpressionUUID->"e51dba6a-7172-4df7-af58-196485c9a3ef"],
Cell[437046, 9133, 551, 17, 28, "Input",ExpressionUUID->"51761045-81f8-4456-b278-e7db0665c923"],
Cell[437600, 9152, 586, 17, 28, "Input",ExpressionUUID->"5fa58271-8d2a-48e4-829a-0cfb98c20732"],
Cell[438189, 9171, 803, 21, 28, "Input",ExpressionUUID->"ab9ae850-167b-490c-ac4f-07396d65855a"],
Cell[438995, 9194, 796, 21, 28, "Input",ExpressionUUID->"23123d4d-1363-4abb-af86-1a1fd2c7bb60"],
Cell[439794, 9217, 658, 19, 28, "Input",ExpressionUUID->"3583de37-2e8b-4aab-aee5-5daab7161d0a"],
Cell[440455, 9238, 1379, 36, 47, "Input",ExpressionUUID->"db36ee0d-2e15-4161-bf4b-d1c0dbb613f1"],
Cell[441837, 9276, 211, 5, 28, "Input",ExpressionUUID->"593251ca-3af5-4dfa-a664-b4cf418e6a02"],
Cell[442051, 9283, 152, 3, 28, "Input",ExpressionUUID->"c3666edd-477a-4dac-a14f-7791b0a5f1d6"],
Cell[442206, 9288, 154, 3, 28, "Input",ExpressionUUID->"21d3b3cc-390b-44a2-bf7b-c2277e590c77"],
Cell[442363, 9293, 789, 21, 28, "Input",ExpressionUUID->"09be30cc-0346-4bab-944f-fd8a6c6fcb63"],
Cell[443155, 9316, 1146, 28, 28, "Input",ExpressionUUID->"7e03cd6d-4543-4438-8c45-67e2bea804d5"],
Cell[444304, 9346, 838, 23, 28, "Input",ExpressionUUID->"97ad2bfa-ca63-4988-873a-af0171cf027b"],
Cell[445145, 9371, 198, 4, 28, "Input",ExpressionUUID->"08ac2f72-b354-4cb6-bd2b-264548ab8ee0"],
Cell[445346, 9377, 618, 18, 28, "Input",ExpressionUUID->"1eedd566-55c8-469e-b694-e5d62902ef5c"],
Cell[445967, 9397, 206, 5, 28, "Input",ExpressionUUID->"dc30c09c-18a1-48e6-8214-290e967c243e"],
Cell[446176, 9404, 641, 18, 28, "Input",ExpressionUUID->"c3e27683-7f46-4719-a2ea-848577b40af9"],
Cell[446820, 9424, 81, 0, 32, "Input",ExpressionUUID->"81406e04-59b8-4cc2-9695-5a1b94e0732f"],
Cell[446904, 9426, 991, 26, 32, "Input",ExpressionUUID->"f44517a7-88a4-4bca-bd5d-4a84af2ed98b"],
Cell[447898, 9454, 903, 23, 32, "Input",ExpressionUUID->"cbd92bc9-28ad-4351-9694-7fafe965b3b6"],
Cell[448804, 9479, 246, 6, 32, "Input",ExpressionUUID->"80006343-ac93-4f12-9998-1c36aaaa43a6"],
Cell[449053, 9487, 794, 23, 32, "Input",ExpressionUUID->"d36b5143-fc3a-408f-bec6-db7459abb1ee"],
Cell[449850, 9512, 1367, 30, 55, "Input",ExpressionUUID->"357b43b3-e124-4869-8001-766cf6226105"],
Cell[451220, 9544, 206, 4, 32, "Input",ExpressionUUID->"8e771171-4cd1-4eca-aed7-7fe2f74823b7"],
Cell[451429, 9550, 372, 7, 32, "Input",ExpressionUUID->"0ecf63ef-58ff-4c74-a29b-7e93d2274bde"],
Cell[451804, 9559, 223, 4, 32, "Input",ExpressionUUID->"ffef3e0f-6088-4b0e-a4d0-1107b308cbf1"],
Cell[452030, 9565, 245, 5, 32, "Input",ExpressionUUID->"4f928199-2eae-4b81-969e-f95c8f446831"]
}
]
*)

